
VehicleBreakdowns = {}

VehicleBreakdowns.Debug = {}
VehicleBreakdowns.Debug.Info = true

VehicleBreakdowns.ShapesInRange = {}

VehicleBreakdowns.repairCosts = { 0.0015, 0.0025, 0.001, 0.0007, 0.005, 0.02, 0.006, 0.0005, 0.005, 0.003 }
VehicleBreakdowns.IRSBTimes = { 10800, 5400, 7200, 1800, 5400, 21600, 5400, 60, 600, 3600 }
VehicleBreakdowns.faultText = { "THERMOSTAT", "LIGHTINGS", "GLOWPLUG", "WIPERS", "GENERATOR", "ENGINE", "SELFSTARTER", "BATTERY", "TIRE", "TIRE", "TIRE", "TIRE" }

VehicleBreakdowns.INGAME_NOTIFICATION = {
	1, 0.27058823529412, 0,	1.0
}

VehicleBreakdowns.ECONOMIZER = {
	REFRESH_PERIOD = 250.0,
	TIME = 0,
	DISPLAY = false
}

VehicleBreakdowns.FSSET_Daysperiod = 1
VehicleBreakdowns.GSET_Change_difficulty = 1
VehicleBreakdowns.GPSET_Change_thermostat = 1
VehicleBreakdowns.GPSET_Change_lightings = 1
VehicleBreakdowns.GPSET_Change_glowplug = 1
VehicleBreakdowns.GPSET_Change_wipers = 1
VehicleBreakdowns.GPSET_Change_generator = 1
VehicleBreakdowns.GPSET_Change_engine = 1
VehicleBreakdowns.GPSET_Change_selfstarter = 1
VehicleBreakdowns.GPSET_Change_battery = 1
VehicleBreakdowns.GPSET_Change_tire = 1



VehicleBreakdowns.SET = {}
VehicleBreakdowns.SET.BatteryLevel = {}
-- charge level for starting the engine
VehicleBreakdowns.SET.BatteryLevel.MOTOR = 0.10 -- 0.75
VehicleBreakdowns.SET.BatteryLevel.LIGHTS = 0.05 -- 0.85
VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS = 0.03 -- 0.90
VehicleBreakdowns.SET.BatteryLevel.TurnLIGHTS = 0.03 -- 0.90
VehicleBreakdowns.SET.BatteryLevel.BATTERYDISC = 0.95

function VehicleBreakdowns.prerequisitesPresent(specializations)
	return true
end

function VehicleBreakdowns.registerOverwrittenFunctions(vehicleType)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "updateMotorTemperature", VehicleBreakdowns.updateMotorTemperature)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "getCanMotorRun", VehicleBreakdowns.getCanMotorRun)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "getMotorNotAllowedWarning", VehicleBreakdowns.getMotorNotAllowedWarning)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "startMotor", VehicleBreakdowns.startMotor)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "stopMotor", VehicleBreakdowns.stopMotor)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "updateConsumers", VehicleBreakdowns.updateConsumers)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsActiveForWipers", VehicleBreakdowns.getIsActiveForWipers)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "showInfo", VehicleBreakdowns.showInfo)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "getSpeedLimit", VehicleBreakdowns.getSpeedLimit)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "updateDamageAmount", VehicleBreakdowns.updateDamageAmount)
	SpecializationUtil.registerOverwrittenFunction(vehicleType, "deactivateLights", VehicleBreakdowns.deactivateLights)
end

function VehicleBreakdowns.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "saveToXMLFile", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onEnterVehicle", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onLeaveVehicle", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onReadStream", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", VehicleBreakdowns)
	SpecializationUtil.registerEventListener(vehicleType, "onPreLoad", VehicleBreakdowns)

end

function VehicleBreakdowns.registerFunctions(vehicleType)
	SpecializationUtil.registerFunction(vehicleType, "addDamage", VehicleBreakdowns.addDamage)
	SpecializationUtil.registerFunction(vehicleType, "getSpeed", VehicleBreakdowns.getSpeed)
	SpecializationUtil.registerFunction(vehicleType, "lightingsFault", VehicleBreakdowns.lightingsFault)
	SpecializationUtil.registerFunction(vehicleType, "setBatteryDrain", VehicleBreakdowns.setBatteryDrain)
	SpecializationUtil.registerFunction(vehicleType, "setBatteryDrainingIfGeneratorFailure", VehicleBreakdowns.setBatteryDrainingIfGeneratorFailure)
	SpecializationUtil.registerFunction(vehicleType, "setBatteryDrainingIfStartMotor", VehicleBreakdowns.setBatteryDrainingIfStartMotor)
	SpecializationUtil.registerFunction(vehicleType, "StopAI", VehicleBreakdowns.StopAI)
	SpecializationUtil.registerFunction(vehicleType, "DebugFaultPrint", VehicleBreakdowns.DebugFaultPrint)
	SpecializationUtil.registerFunction(vehicleType, "getFaultThermostat", VehicleBreakdowns.getFaultThermostat)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultThermostatoverHeating", VehicleBreakdowns.getIsFaultThermostatoverHeating)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultThermostatoverCooling", VehicleBreakdowns.getIsFaultThermostatoverCooling)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultLightings", VehicleBreakdowns.getIsFaultLightings)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultGlowPlug", VehicleBreakdowns.getIsFaultGlowPlug)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultWipers", VehicleBreakdowns.getIsFaultWipers)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultGenerator", VehicleBreakdowns.getIsFaultGenerator)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultEngine", VehicleBreakdowns.getIsFaultEngine)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultSelfStarter", VehicleBreakdowns.getIsFaultSelfStarter)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultBattery", VehicleBreakdowns.getIsFaultBattery)
	SpecializationUtil.registerFunction(vehicleType, "setIsFaultBattery", VehicleBreakdowns.setIsFaultBattery)
	SpecializationUtil.registerFunction(vehicleType, "getIsFaultOperatingHours", VehicleBreakdowns.getIsFaultOperatingHours)
	
	SpecializationUtil.registerFunction(vehicleType, "getThermostatPercentage", VehicleBreakdowns.getThermostatPercentage)
	SpecializationUtil.registerFunction(vehicleType, "getPartsPercentage", VehicleBreakdowns.getPartsPercentage)
	SpecializationUtil.registerFunction(vehicleType, "getFaultParts", VehicleBreakdowns.getFaultParts)
	
	SpecializationUtil.registerFunction(vehicleType, "getIsOperatingHoursTemp", VehicleBreakdowns.getIsOperatingHoursTemp)
	SpecializationUtil.registerFunction(vehicleType, "getIsInspection", VehicleBreakdowns.getIsInspection)
	SpecializationUtil.registerFunction(vehicleType, "getIsService", VehicleBreakdowns.getIsService)
	--SpecializationUtil.registerFunction(vehicleType, "setIsService", VehicleBreakdowns.setIsService)
	SpecializationUtil.registerFunction(vehicleType, "getIsDailyService", VehicleBreakdowns.getIsDailyService)
	--SpecializationUtil.registerFunction(vehicleType, "setIsDailyService", VehicleBreakdowns.setIsDailyService)
	SpecializationUtil.registerFunction(vehicleType, "getIsPeriodicServiceTime", VehicleBreakdowns.getIsPeriodicServiceTime)
	SpecializationUtil.registerFunction(vehicleType, "setIsPeriodicServiceTime", VehicleBreakdowns.setIsPeriodicServiceTime)
	SpecializationUtil.registerFunction(vehicleType, "getIsRepairStartService", VehicleBreakdowns.getIsRepairStartService)
	SpecializationUtil.registerFunction(vehicleType, "getIsRepairClockService", VehicleBreakdowns.getIsRepairClockService)
	SpecializationUtil.registerFunction(vehicleType, "getIsRepairTimeService", VehicleBreakdowns.getIsRepairTimeService)
	SpecializationUtil.registerFunction(vehicleType, "getIsRepairTimePassedService", VehicleBreakdowns.getIsRepairTimePassedService)
	SpecializationUtil.registerFunction(vehicleType, "getIsRepairScaleService", VehicleBreakdowns.getIsRepairScaleService)

	SpecializationUtil.registerFunction(vehicleType, "CalculateFinishTime", VehicleBreakdowns.CalculateFinishTime)
	SpecializationUtil.registerFunction(vehicleType, "getRepairPrice_RVBClone", VehicleBreakdowns.getRepairPrice_RVBClone)
	SpecializationUtil.registerFunction(vehicleType, "getServicePrice", VehicleBreakdowns.getServicePrice)
	SpecializationUtil.registerFunction(vehicleType, "getInspectionPrice", VehicleBreakdowns.getInspectionPrice)
	SpecializationUtil.registerFunction(vehicleType, "getSellPrice_RVBClone", VehicleBreakdowns.getSellPrice_RVBClone)
	SpecializationUtil.registerFunction(vehicleType, "onStartOperatingHours", VehicleBreakdowns.onStartOperatingHours)
	
	SpecializationUtil.registerFunction(vehicleType, "minuteChanged", VehicleBreakdowns.minuteChanged)
	SpecializationUtil.registerFunction(vehicleType, "RVBhourChanged", VehicleBreakdowns.RVBhourChanged)
	SpecializationUtil.registerFunction(vehicleType, "setBatteryCharging", VehicleBreakdowns.setBatteryCharging)
	SpecializationUtil.registerFunction(vehicleType, "setGeneratorBatteryCharging", VehicleBreakdowns.setGeneratorBatteryCharging)
	SpecializationUtil.registerFunction(vehicleType, "chargeBatteryFromGenerator", VehicleBreakdowns.chargeBatteryFromGenerator)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleInspection", VehicleBreakdowns.setVehicleInspection)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleRepair", VehicleBreakdowns.setVehicleRepair)
	SpecializationUtil.registerFunction(vehicleType, "updateRepair", VehicleBreakdowns.updateRepair)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleRepairDisplayMessage", VehicleBreakdowns.setVehicleRepairDisplayMessage)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleService", VehicleBreakdowns.setVehicleService)
	SpecializationUtil.registerFunction(vehicleType, "setDamageService", VehicleBreakdowns.setDamageService)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleDamageThermostatoverHeatingFailure", VehicleBreakdowns.setVehicleDamageThermostatoverHeatingFailure)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleDamageGlowplugFailure", VehicleBreakdowns.setVehicleDamageGlowplugFailure)
	SpecializationUtil.registerFunction(vehicleType, "setWiperOperatingHours", VehicleBreakdowns.setWiperOperatingHours)
	SpecializationUtil.registerFunction(vehicleType, "setLightingsOperatingHours", VehicleBreakdowns.setLightingsOperatingHours)
	SpecializationUtil.registerFunction(vehicleType, "displayMessage", VehicleBreakdowns.displayMessage)
	SpecializationUtil.registerFunction(vehicleType, "getIsRVBMotorStarted", VehicleBreakdowns.getIsRVBMotorStarted)
	SpecializationUtil.registerFunction(vehicleType, "RVBaddRemoveMoney", VehicleBreakdowns.RVBaddRemoveMoney)
	SpecializationUtil.registerFunction(vehicleType, "inRangeOfchargingStation", VehicleBreakdowns.inRangeOfchargingStation)
	SpecializationUtil.registerFunction(vehicleType, "getBatteryChPrice", VehicleBreakdowns.getBatteryChPrice)
	SpecializationUtil.registerFunction(vehicleType, "calculateBatteryChPrice", VehicleBreakdowns.calculateBatteryChPrice)

	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVB", VehicleBreakdowns.SyncClientServer_RVB)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVBFaultStorage", VehicleBreakdowns.SyncClientServer_RVBFaultStorage)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVBService", VehicleBreakdowns.SyncClientServer_RVBService)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVBRepair", VehicleBreakdowns.SyncClientServer_RVBRepair)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVBInspection", VehicleBreakdowns.SyncClientServer_RVBInspection)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVBBattery", VehicleBreakdowns.SyncClientServer_RVBBattery)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_RVBParts", VehicleBreakdowns.SyncClientServer_RVBParts)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_BatteryChargeLevel", VehicleBreakdowns.SyncClientServer_BatteryChargeLevel)
	SpecializationUtil.registerFunction(vehicleType, "SyncClientServer_Other", VehicleBreakdowns.SyncClientServer_Other)
	
	SpecializationUtil.registerFunction(vehicleType, "getBatteryFillUnitIndex", VehicleBreakdowns.getBatteryFillUnitIndex)
	
	SpecializationUtil.registerFunction(vehicleType, "batteryChargeVehicle", VehicleBreakdowns.batteryChargeVehicle)
	SpecializationUtil.registerFunction(vehicleType, "setRVBLightsStrings", VehicleBreakdowns.setRVBLightsStrings)
	SpecializationUtil.registerFunction(vehicleType, "setRVBLightsTypesMask", VehicleBreakdowns.setRVBLightsTypesMask)
	SpecializationUtil.registerFunction(vehicleType, "rvbVehicleSetLifetime", VehicleBreakdowns.rvbVehicleSetLifetime)
	SpecializationUtil.registerFunction(vehicleType, "updatePartsLifetime", VehicleBreakdowns.updatePartsLifetime)
	SpecializationUtil.registerFunction(vehicleType, "updateRepairNeeds", VehicleBreakdowns.updateRepairNeeds)

end

function VehicleBreakdowns.initSpecialization()
	-- vehicle schema
	local schema = Vehicle.xmlSchema

    schema:setXMLSpecializationType("VehicleBreakdowns")

	-- savegame schema
	local schemaSavegame = Vehicle.xmlSchemaSavegame

	local rvbSavegameKey = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.INT, rvbSavegameKey .. "#timeScale", "Idő skála")
	schemaSavegame:register(XMLValueType.FLOAT, rvbSavegameKey .. "#operatingHoursTemp", "Ideiglenes üzemóra")
	schemaSavegame:register(XMLValueType.FLOAT, rvbSavegameKey .. "#TotaloperatingHours", "Összes üzemóra")

	schemaSavegame:register(XMLValueType.FLOAT, rvbSavegameKey .. "#operatingHours", "futott üzemóra")
	schemaSavegame:register(XMLValueType.FLOAT, rvbSavegameKey .. "#chargelevel", "Akkumulátor tölttötségi szint")

	local savegameKey = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns.faultStorage", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.BOOL, savegameKey .. "#thermostatoverHeating", "Overheating is the most common symptom of a failing thermostat. The engine will overheat, causing severe damage.")
	schemaSavegame:register(XMLValueType.BOOL, savegameKey .. "#thermostatoverCooling", "Overcooling is the most common symptom of a failing thermostat. The engine will overcool, causing severe damage and the engine will run rich and consume more fuel.")

	local parts = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns.parts.part(?)", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.STRING, parts .. "#name", "")
	schemaSavegame:register(XMLValueType.INT, parts .. "#lifetime", "")
	schemaSavegame:register(XMLValueType.FLOAT, parts .. "#operatingHours", "Kár")
	schemaSavegame:register(XMLValueType.BOOL, parts .. "#repairreq", "Repair is required")
	schemaSavegame:register(XMLValueType.FLOAT, parts .. "#amount", "Megadott időközönként ennyivel nőveli a javítási értéket v mi")
	schemaSavegame:register(XMLValueType.FLOAT, parts .. "#cost", "Javítási költség")

	local serviceSavegameKey = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns.vehicleService", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.BOOL, serviceSavegameKey .. "#state", "Service in progress")
	schemaSavegame:register(XMLValueType.BOOL, serviceSavegameKey .. "#suspension", "Munka szüneteltetés")
	schemaSavegame:register(XMLValueType.INT, serviceSavegameKey .. "#finishday", "")
	schemaSavegame:register(XMLValueType.INT, serviceSavegameKey .. "#finishhour", "")
	schemaSavegame:register(XMLValueType.INT, serviceSavegameKey .. "#finishminute", "")
	schemaSavegame:register(XMLValueType.FLOAT, serviceSavegameKey .. "#amount", "Megadott időközönként ennyivel nőveli a javítási értéket v mi")
	schemaSavegame:register(XMLValueType.FLOAT, serviceSavegameKey .. "#cost", "Javítási költség")
	schemaSavegame:register(XMLValueType.FLOAT, serviceSavegameKey .. "#damage", "Kár")

	local repairSavegameKey = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns.vehicleRepair", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.BOOL, repairSavegameKey .. "#state", "Repair in progress")
	schemaSavegame:register(XMLValueType.BOOL, repairSavegameKey .. "#suspension", "Munka szüneteltetés")
	schemaSavegame:register(XMLValueType.INT, repairSavegameKey .. "#finishday", "")
	schemaSavegame:register(XMLValueType.INT, repairSavegameKey .. "#finishhour", "")
	schemaSavegame:register(XMLValueType.INT, repairSavegameKey .. "#finishminute", "")
	schemaSavegame:register(XMLValueType.FLOAT, repairSavegameKey .. "#amount", "Megadott időközönként ennyivel nőveli a javítási értéket v mi")
	schemaSavegame:register(XMLValueType.FLOAT, repairSavegameKey .. "#cost", "Javítási költség")
	schemaSavegame:register(XMLValueType.FLOAT, repairSavegameKey .. "#damage", "Kár")
	schemaSavegame:register(XMLValueType.FLOAT, repairSavegameKey .. "#factor", "")
	schemaSavegame:register(XMLValueType.BOOL, repairSavegameKey .. "#inspection", "")

	local inspectionSavegameKey = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns.vehicleInspection", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.BOOL, inspectionSavegameKey .. "#state", "Inspection in progress")
	schemaSavegame:register(XMLValueType.BOOL, inspectionSavegameKey .. "#suspension", "Munka szüneteltetés")
	schemaSavegame:register(XMLValueType.INT, inspectionSavegameKey .. "#finishday", "")
	schemaSavegame:register(XMLValueType.INT, inspectionSavegameKey .. "#finishhour", "")
	schemaSavegame:register(XMLValueType.INT, inspectionSavegameKey .. "#finishminute", "")
	schemaSavegame:register(XMLValueType.FLOAT, inspectionSavegameKey .. "#cost", "Javítási költség")
	schemaSavegame:register(XMLValueType.FLOAT, inspectionSavegameKey .. "#factor", "")
	schemaSavegame:register(XMLValueType.BOOL, inspectionSavegameKey .. "#inspection", "")

	local batterySavegameKey = string.format("vehicles.vehicle(?).%s.vehicleBreakdowns.vehicleBattery", g_vehicleBreakdownsModName)
	schemaSavegame:register(XMLValueType.BOOL, batterySavegameKey .. "#state", "Töltés elkezdve")
	schemaSavegame:register(XMLValueType.BOOL, batterySavegameKey .. "#suspension", "Munka szüneteltetés")
	schemaSavegame:register(XMLValueType.INT, batterySavegameKey .. "#finishday", "")
	schemaSavegame:register(XMLValueType.INT, batterySavegameKey .. "#finishhour", "")
	schemaSavegame:register(XMLValueType.INT, batterySavegameKey .. "#finishminute", "")
	schemaSavegame:register(XMLValueType.FLOAT, batterySavegameKey .. "#amount", "Mennyit tölt")
	schemaSavegame:register(XMLValueType.FLOAT, batterySavegameKey .. "#cost", "Töltési költség")
	
	schemaSavegame:setXMLSpecializationType()
end

function VehicleBreakdowns:onPreLoad(savegame)
end

function VehicleBreakdowns:onLoad(savegame)

	if self.spec_faultData == nil then
		self.spec_faultData = {}
	end
	
	local spec = self.spec_faultData

	spec.messageCenter = g_messageCenter	
	spec.dirtyFlag = self:getNextDirtyFlag()
	
	spec.randoms = { 0, 0 }
	
	spec.rvb = { 5, 0, 0, 0, 0 }
	spec.faultStorage = { false, false }
	spec.service = { false, false, 0, 0, 0, 0, 0, 0, 0 }
	spec.battery = { false, false, 0, 0, 0, 0, 0 }
	spec.repair = { false, false, 0, 0, 0, 0, 0, 0, 0, false }
	spec.inspection = { false, false, 0, 0, 0, 0, 0, false }
	spec.parts = {}
	
	local xmlFilePath = Utils.getFilename('config/PartsSettingsSetup.xml', g_vehicleBreakdownsDirectory)
	local xmlFile = XMLFile.load("settingSetupXml", xmlFilePath)

	if xmlFile == nil then
		return
	end

	local GSET = g_currentMission.vehicleBreakdowns.generalSettings
	local GPSET = g_currentMission.vehicleBreakdowns.gameplaySettings
	
	local partIndex = 1
	xmlFile:iterate("Parts.Part", function(_, key)
		local name = xmlFile:getString( key.."#name")
		local lifetime = xmlFile:getInt( key.."#lifetime", 100)
		local operatingHours = xmlFile:getFloat( key.."#operatingHours", 0)
		local repairreq = xmlFile:getBool( key.."#repairreq", false)
		local amount = xmlFile:getFloat( key.."#amount", 0)
		local cost = xmlFile:getFloat( key.."#cost", 0)

		spec.parts[partIndex] = {}
		spec.parts[partIndex].name = name or "Unknown"

		if partIndex == 1 then
			spec.parts[partIndex].lifetime = GPSET.thermostatLifetime or lifetime
		end
		if partIndex == 2 then
			spec.parts[partIndex].lifetime = GPSET.lightingsLifetime or lifetime
		end
		if partIndex == 3 then
			spec.parts[partIndex].lifetime = GPSET.glowplugLifetime or lifetime
		end
		if partIndex == 4 then
			spec.parts[partIndex].lifetime = GPSET.wipersLifetime or lifetime
		end
		if partIndex == 5 then
			spec.parts[partIndex].lifetime = GPSET.generatorLifetime or lifetime
		end
		if partIndex == 6 then
			spec.parts[partIndex].lifetime = GPSET.engineLifetime or lifetime
		end
		if partIndex == 7 then
			spec.parts[partIndex].lifetime = GPSET.selfstarterLifetime or lifetime
		end
		if partIndex == 8 then
			spec.parts[partIndex].lifetime = GPSET.batteryLifetime or lifetime
		end
		if partIndex == 9 or partIndex == 10 or partIndex == 11 or partIndex == 12 then
			spec.parts[partIndex].lifetime = GPSET.tireLifetime or lifetime
		end
		if GSET.difficulty == 1 then
			spec.parts[partIndex].tmp_lifetime = spec.parts[partIndex].lifetime * 2 * g_currentMission.environment.plannedDaysPerPeriod
		elseif GSET.difficulty == 2 then
			spec.parts[partIndex].tmp_lifetime = spec.parts[partIndex].lifetime * 1 * g_currentMission.environment.plannedDaysPerPeriod
		else
			spec.parts[partIndex].tmp_lifetime = spec.parts[partIndex].lifetime / 2 * g_currentMission.environment.plannedDaysPerPeriod
		end

		spec.parts[partIndex].operatingHours = operatingHours or 0
		spec.parts[partIndex].repairreq = repairreq or false
		spec.parts[partIndex].amount = amount or 0
		spec.parts[partIndex].cost = cost or 0
		
		spec.parts[partIndex].damaged = false
		
		partIndex = partIndex + 1

	end)
	
	spec.partsToChange = 0
	spec.serviceToChange = 0
	
	
	spec.runtimeToChange = 0
	spec.serviceRuntimeToChange = 0
	spec.thermostatoverHeatingRuntimeToChange = 0
	spec.glowplugRuntimeToChange = 0
	spec.wiperRuntimeToChange = 0
	spec.lightingsRuntimeToChange = 0
	-- Alkatrészek kiírása
	for i, part in ipairs(spec.parts) do
		--print(string.format("Part %d: %s, Lifetime: %s, Operating Hours: %s, Repair Required: %s, Amount: %s, Cost: %s", i, part.name, part.lifetime, part.operatingHours, tostring(part.repairReq), part.amount, part.cost))
	end

	spec.partfoot = 0
	spec.rvblightsTypesMask = 0
	
	-- onUpdateTick()
	spec.instantFuel = {}
	spec.instantFuel.Consumption = string.format("%.1f l/h", 0.0)
	spec.instantFuel.time = 0

	
	spec.isRVBMotorStarted = false
	spec.rvbmotorStartTime = 0
	spec.rvbMotorStart = false

	-- load sound effects
	if g_dedicatedServerInfo == nil then
		local file, id
		VehicleBreakdowns.sounds = {}
		for _, id in ipairs({"self_starter", "battery"}) do
			VehicleBreakdowns.sounds[id] = createSample(id)
			file = g_currentMission.vehicleBreakdowns.modDirectory.."sounds/"..id..".ogg"
			loadSample(VehicleBreakdowns.sounds[id], file, false)
		end
	end

	self.currentTemperaturDay = g_currentMission.environment.weather:getCurrentTemperature()
	self.currentTemperaturDay =  self.currentTemperaturDay - math.random(2,5)
	self.spec_motorized.motorTemperature.value = self.currentTemperaturDay
	self.spec_motorized.motorTemperature.valueMin = self.currentTemperaturDay
	--self.spec_motorized.motorFan.disableTemperature = 85
	self.spec_motorized.motorTemperature.valueMax = 122

	-- engine data
	spec.motorTemperature = self.currentTemperaturDay
	spec.fanEnabled = false
	spec.fanEnabledLast = false

	spec.fanEnableTemperature = 95
	spec.fanDisableTemperature = 85

	spec.lastFuelUsage = 0
	spec.lastDefUsage = 0
	spec.lastAirUsage = 0

	spec.DontStopMotor = {}
	spec.DontStopMotor.glowPlug	= false
	spec.DontStopMotor.self_starter	= false
	spec.RandomNumber = {}
	spec.RandomNumber.glowPlug = 0
	spec.TimesSoundPlayed = {}
	spec.TimesSoundPlayed.glowPlug = 2
	spec.TimesSoundPlayed.self_starter = 2
	spec.MotorTimer = {}
	spec.MotorTimer.glowPlug = -1
	spec.MotorTimer.self_starter = -1
	spec.NumberMotorTimer = {}
	spec.NumberMotorTimer.glowPlug = 0
	spec.NumberMotorTimer.self_starter = 0

	spec.DontStopMotor.battery	= false
	
	spec.updateTimer = 0
	
	spec.addDamage = {}
	spec.addDamage.alert = false

	g_messageCenter:subscribe(MessageType.MINUTE_CHANGED, self.minuteChanged, self)
	g_messageCenter:subscribe(MessageType.HOUR_CHANGED, self.RVBhourChanged, self)

	VehicleBreakdowns.FSSET_Daysperiod = g_currentMission.environment.plannedDaysPerPeriod
	VehicleBreakdowns.GSET_Change_difficulty = g_currentMission.vehicleBreakdowns.generalSettings.difficulty
	VehicleBreakdowns.GPSET_Change_thermostat = g_currentMission.vehicleBreakdowns.gameplaySettings.thermostatLifetime
	VehicleBreakdowns.GPSET_Change_lightings = g_currentMission.vehicleBreakdowns.gameplaySettings.lightingsLifetime
	VehicleBreakdowns.GPSET_Change_glowplug = g_currentMission.vehicleBreakdowns.gameplaySettings.glowplugLifetime
	VehicleBreakdowns.GPSET_Change_wipers = g_currentMission.vehicleBreakdowns.gameplaySettings.wipersLifetime
	VehicleBreakdowns.GPSET_Change_generator = g_currentMission.vehicleBreakdowns.gameplaySettings.generatorLifetime
	VehicleBreakdowns.GPSET_Change_engine = g_currentMission.vehicleBreakdowns.gameplaySettings.engineLifetime
	VehicleBreakdowns.GPSET_Change_selfstarter = g_currentMission.vehicleBreakdowns.gameplaySettings.selfstarterLifetime
	VehicleBreakdowns.GPSET_Change_battery = g_currentMission.vehicleBreakdowns.gameplaySettings.batteryLifetime
	VehicleBreakdowns.GPSET_Change_tire = g_currentMission.vehicleBreakdowns.gameplaySettings.tireLifetime

	--self.speedLimit = 10
	
	
	spec.motorStart_updateDelta = 0
	spec.motorStart_updateRate = 600

	spec.lights_request_A = false
	spec.lights_request_B = false

	spec.faultListText = {}
	spec.faultList = {}


	spec.RVB_Battery = {}
	spec.RVB_BatteryFillLevel = 100.000000
	spec.updateBatteryTimer = 0
	
	spec.BatteryPlusMinus = {}
	spec.BatteryPlusMinus.lightings = 0
	
	spec.batteryFillUnitIndex = nil
	spec.isInitialized = true
	
	local specFillunit = self.spec_fillUnit
	local batteryFillUnitsCount = 0

	spec.batteryCHActive = false
	local batteryLevel = 100
	local spec_fillUnit = self.spec_fillUnit
	
	spec.updateDelta = 5001
	spec.updateRate = 5000


	if self.isServer then

		if savegame ~= nil and savegame.xmlFile:hasProperty(savegame.key..".fillUnit") then
            local i = 0
            local xmlFile = savegame.xmlFile
            while true do
                local key = string.format("%s.fillUnit.unit(%d)", savegame.key, i)
				
                if not xmlFile:hasProperty(key) then
                    break
                end

				local fillTypeName = xmlFile:getValue(key.."#fillType")
				if fillTypeName == "ELECTRICCHARGE" then
					local fillUnitIndex = xmlFile:getValue(key.."#index")
					local fillLevel = xmlFile:getValue(key.."#fillLevel", 100)
					batteryLevel = fillLevel
					spec.RVB_BatteryFillLevel = fillLevel
				end	

                i = i + 1
			end
		end
		
	end



	local spec_m = self.spec_motorized

	if spec_m.motor ~= nil then
	
	

		local specFillUnit = self.spec_fillUnit

	
		local xmlFillUnit = XMLFile.load("vehicleXml", Utils.getFilename("config/battery_fillUnit.xml", g_currentMission.vehicleBreakdowns.modDirectory), Vehicle.xmlSchema)

		local fillUnitConfigurationId = 1 --Utils.getNoNil(self.configurations.fillUnit, 1)

		local batteryKey = string.format("vehicle.fillUnit.fillUnitConfigurations.fillUnitConfiguration(%d).fillUnits.fillUnit(%d)", fillUnitConfigurationId-1, fillUnitConfigurationId-1)

		local entry = {}
		if self:loadFillUnitFromXML(xmlFillUnit, batteryKey, entry, #self.spec_fillUnit.fillUnits + 1) then
			entry.capacity = 100
			entry.startFillLevel = 100
		--	entry.fillLevel = batteryLevel
			entry.fillType = FillType.ELECTRICCHARGE

		-- ha ezt hasznalnam loadFillUnitFromXML, de meg nem tom mert dedin szarakodik vmi
			entry.allowFoldingThreshold = entry.capacity

			table.insert(self.spec_fillUnit.fillUnits, entry)

			
			spec.batteryFillUnitIndex = #self.spec_fillUnit.fillUnits
			
			--self:raiseDirtyFlags(self.spec_fillUnit.dirtyFlag)
			--self:raiseDirtyFlags(spec.dirtyFlag)

		else
			Logging.xmlWarning(xmlFillUnit, "Could not load fillUnit for '%s'", batteryKey)
			self:setLoadingState(VehicleLoadingUtil.VEHICLE_LOAD_ERROR)
		end

	else
		spec.isInitialized = false
	end
	
	

	if self.getConsumerFillUnitIndex ~= nil and self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil then
		local specConsumers = self.spec_motorized
		if spec.batteryFillUnitIndex ~= nil and spec.isInitialized then
		
		
			local xmlFillUnit = XMLFile.load("vehicleXml", Utils.getFilename("config/battery_consumer.xml", g_currentMission.vehicleBreakdowns.modDirectory), Vehicle.xmlSchema)
			local unitindex = 1

			local vkey, motorId = ConfigurationUtil.getXMLConfigurationKey(self.xmlFile, self.configurations["motor"], "vehicle.motorized.motorConfigurations.motorConfiguration", "vehicle.motorized", "motor")
			local fallbackConfigKey = "vehicle.motorized.motorConfigurations.motorConfiguration(0)"
			local consumerConfigurationIndex = ConfigurationUtil.getConfigurationValue(self.xmlFile, vkey, "#consumerConfigurationIndex", "", 1, fallbackConfigKey)
			local key = string.format("vehicle.motorized.consumerConfigurations.consumerConfiguration(%d)", consumerConfigurationIndex-1)
			local consumerKey = string.format(".consumer(%d)", #specConsumers.consumers + 1)
			local consumer = {}
			consumer.fillUnitIndex = spec.batteryFillUnitIndex
			
			self.spec_fillUnit.fillUnits[spec.batteryFillUnitIndex].fillType = FillType.ELECTRICCHARGE
			self.spec_fillUnit.fillUnits[spec.batteryFillUnitIndex].fillLevel = spec.RVB_BatteryFillLevel -- batteryLevel
			--self:raiseDirtyFlags(self.spec_fillUnit.dirtyFlag)
			local fillTypeName = "electricCharge"
			consumer.fillType = g_fillTypeManager:getFillTypeIndexByName(fillTypeName)
			consumer.capacity = nil
			local fillUnit = self:getFillUnitByIndex(consumer.fillUnitIndex)
			if fillUnit ~= nil then
				if fillUnit.supportedFillTypes[consumer.fillType] ~= nil then

					fillUnit.capacity = consumer.capacity or fillUnit.capacity
					fillUnit.startFillLevel = fillUnit.capacity
					fillUnit.startFillTypeIndex = consumer.fillType

					local usage = 0.1
					consumer.permanentConsumption = false
					if consumer.permanentConsumption then
						consumer.usage = usage / (60*60*1000)
					else
						consumer.usage = usage
					end
					consumer.refillLitersPerSecond = 0
					consumer.refillCapacityPercentage = 0
					consumer.fillLevelToChange = 0.1
					table.insert(specConsumers.consumers, consumer)
					specConsumers.consumersByFillTypeName[fillTypeName:upper()] = consumer
					specConsumers.consumersByFillType[consumer.fillType] = consumer
					
			--self:raiseDirtyFlags(specConsumers.dirtyFlag)

				else
					Logging.xmlWarning(self.xmlFile, "FillUnit '%d' does not  support fillType '%s' for consumer '%s'", consumer.fillUnitIndex, fillTypeName, key..consumerKey)
				end
			else
				Logging.xmlWarning(self.xmlFile, "Unknown fillUnit '%d' for consumer '%s'", consumer.fillUnitIndex, key..consumerKey)
			end
		end
	end


	
	

	
	spec.rvb_actionEventToggleLights = 0
		

	
end




---Update
-- @param float dt time since last call in ms
function VehicleBreakdowns:PlaceableChargingStationonUpdateXXXXXXX(superFunc, dt)
    local spec = self.spec_chargingStation

    if spec.loadTrigger ~= nil then
        local isActive = next(spec.loadTrigger.fillableObjects) ~= nil

        if spec.chargeIndicatorNode ~= nil then
            if isActive then
                local color = spec.chargeIndicatorColorEmpty
                local fillLevel, capacity = self:getChargeState()
                if fillLevel / capacity > 0.95 then
                    color = spec.chargeIndicatorColorFull
                end

                setShaderParameter(spec.chargeIndicatorNode, "colorScale", color[1], color[2], color[3], color[4], false)
                spec.chargeIndicatorLightColor = color
				
				if g_currentMission.controlledVehicle ~= nil then
					local rvb = g_currentMission.controlledVehicle.spec_faultData
					rvb.batteryCHActive = false
				end
				
            end

            local blinkSpeed = spec.loadTrigger.isLoading and spec.chargeIndicatorBlinkSpeed or 0
            setShaderParameter(spec.chargeIndicatorNode, "blinkSpeed", blinkSpeed, 0, 0, 0, false)
            setShaderParameter(spec.chargeIndicatorNode, "lightControl", isActive and spec.chargeIndicatorIntensity or 0, 0, 0, 0, false)

            if spec.chargeIndicatorLight ~= nil then
                local alpha = 0
                if isActive then
                    local x, y, z, _ = getShaderParameter(spec.chargeIndicatorNode, "blinkOffset")
                    alpha = MathUtil.clamp(math.cos(blinkSpeed * z * (getShaderTimeSec() - y) + 2 * math.pi * x) + 0.2, 0, 1)
                end

                setLightColor(spec.chargeIndicatorLight, spec.chargeIndicatorLightColor[1]*alpha, spec.chargeIndicatorLightColor[2]*alpha, spec.chargeIndicatorLightColor[3]*alpha)
            end
        end

        if spec.loadTrigger.isLoading then
            local allowDisplay = false
            if g_currentMission.controlPlayer and g_currentMission.player ~= nil then
                local distance = calcDistanceFrom(g_currentMission.player.rootNode, self.rootNode)
                if distance < spec.interactionRadius then
                    allowDisplay = true
                end
            else
                if g_currentMission.controlledVehicle ~= nil then
                    for _, object in pairs(spec.loadTrigger.fillableObjects) do
                        if object.object == g_currentMission.controlledVehicle then
                            allowDisplay = true
                        end
                    end
                end
            end

            if allowDisplay then
                local fillLevel, capacity = self:getChargeState()
                local fillLevelToFill = capacity - fillLevel
                local literPerSecond = spec.loadTrigger.fillLitersPerMS * 1000
                local seconds = fillLevelToFill / literPerSecond
                if seconds >= 1 then
                    local minutes = math.floor(seconds / 60)
                    seconds = seconds - (minutes * 60)
					
					if g_currentMission.controlledVehicle ~= nil then
						local rvb = g_currentMission.controlledVehicle.spec_faultData
						rvb.batteryCHActive = true
					end
					-- motor es vilagitas leallitas 
					local index = next(spec.loadTrigger.fillableObjects)
					local vehicle = spec.loadTrigger.fillableObjects[index].object
					if vehicle.configurations["motor"] ~= nil then
						if vehicle:getIsMotorStarted() then
							vehicle:stopMotor()
						end
						if vehicle.deactivateLights ~= nil then
							vehicle:deactivateLights()
						end
						local spec_m = vehicle.spec_motorized
						if spec_m.motor ~= nil then
							spec_m.motor:setGearShiftMode(spec_m.gearShiftMode)
						end
					end
					-- motor es vilagitas leallitas END

                    g_currentMission:addExtraPrintText(string.format(g_i18n:getText("info_chargeTime"), minutes, seconds, fillLevel / capacity * 100))

                end
            end
        end
    end

    self:raiseActive()
end
function VehicleBreakdowns:PlaceableChargingStationonUpdate(superFunc, dt)
	local spec = self.spec_chargingStation
	if spec.loadTrigger ~= nil then
		local isActive = next(spec.loadTrigger.fillableObjects) ~= nil
		if spec.chargeIndicatorNode ~= nil then
			if isActive then
				local color = spec.chargeIndicatorColorEmpty
				local fillLevel, capacity = self:getChargeState()
				if fillLevel / capacity > 0.95 then
					color = spec.chargeIndicatorColorFull
				end
				setShaderParameter(spec.chargeIndicatorNode, "colorScale", color[1], color[2], color[3], color[4], false)
				spec.chargeIndicatorLightColor = color
				--
				if g_currentMission.controlledVehicle ~= nil then
					local rvb = g_currentMission.controlledVehicle.spec_faultData
					rvb.batteryCHActive = false
				end
				--
			end
			local blinkSpeed = spec.loadTrigger.isLoading and (spec.chargeIndicatorBlinkSpeed or 0) or 0
			setShaderParameter(spec.chargeIndicatorNode, "blinkSimple", blinkSpeed, 0, 0, 0, false)
			setShaderParameter(spec.chargeIndicatorNode, "lightControl", isActive and (spec.chargeIndicatorIntensity or 0) or 0, 0, 0, 0, false)
			if spec.chargeIndicatorLight ~= nil then
				local alpha
				if isActive then
					local x, y, _, _ = getShaderParameter(spec.chargeIndicatorNode, "blinkSimple")
					local v27 = x * getShaderTimeSec() + y
					local v28 = math.fmod(v27, 1) - 0.5
					local v29 = 4 * math.abs(v28) - 0.8
					alpha = math.clamp(v29, 0, 1)
				else
					alpha = 0
				end
				setLightColor(spec.chargeIndicatorLight, spec.chargeIndicatorLightColor[1] * alpha, spec.chargeIndicatorLightColor[2] * alpha, spec.chargeIndicatorLightColor[3] * alpha)
			end
		end
		if spec.loadTrigger.isLoading then
			local allowDisplay = false
			local v31 = g_localPlayer
			if v31 == nil or v31:getIsInVehicle() then
				local v32 = v31:getCurrentVehicle()
				if v32 ~= nil then
					for _, v33 in pairs(spec.loadTrigger.fillableObjects) do
						if v33.object == v32 then
							allowDisplay = true
						end
					end
				end
			elseif calcDistanceFrom(v31.rootNode, self.rootNode) < spec.interactionRadius then
				allowDisplay = true
			end
			if allowDisplay then
				local fillLevel, capacity = self:getChargeState()
				local seconds = (capacity - fillLevel) / (spec.loadTrigger.fillLitersPerMS * 1000)
				if seconds >= 1 then
					local v37 = seconds / 60
					local minutes = math.floor(v37)
					local seconds = seconds - minutes * 60
					--
					if g_currentMission.controlledVehicle ~= nil then
						local rvb = g_currentMission.controlledVehicle.spec_faultData
						rvb.batteryCHActive = true
					end
					-- motor es vilagitas leallitas 
					local index = next(spec.loadTrigger.fillableObjects)
					local vehicle = spec.loadTrigger.fillableObjects[index].object
					if vehicle.configurations["motor"] ~= nil then
						if vehicle:getIsMotorStarted() then
							vehicle:stopMotor()
						end
						if vehicle.deactivateLights ~= nil then
							vehicle:deactivateLights()
						end
						local spec_m = vehicle.spec_motorized
						if spec_m.motor ~= nil then
							spec_m.motor:setGearShiftMode(spec_m.gearShiftMode)
						end
					end
					-- motor es vilagitas leallitas END
					local v40 = string.format(g_i18n:getText("info_chargeTime"), minutes, seconds, fillLevel / capacity * 100)
					g_currentMission:addExtraPrintText(v40)
				end
			end
		end
		if isActive then
			self:raiseActive()
		end
	end
end
PlaceableChargingStation.onUpdate = Utils.overwrittenFunction(PlaceableChargingStation.onUpdate, VehicleBreakdowns.PlaceableChargingStationonUpdate)

	
function VehicleBreakdowns:getBatteryFillUnitIndex()
    local spec = self.spec_fillUnit
    local batteryFillType = g_fillTypeManager:getFillTypeIndexByName("ELECTRICCHARGE")
    for fillUnitIndex, _ in ipairs(spec.fillUnits) do
        if self:getFillUnitAllowsFillType(fillUnitIndex, batteryFillType) then
            return fillUnitIndex
        end
    end
    return nil
end

function VehicleBreakdowns:minuteChanged()

	local spec = self.spec_faultData
	local GPSET = g_currentMission.vehicleBreakdowns.gameplaySettings
	local GSET = g_currentMission.vehicleBreakdowns.generalSettings
	
	local currentMinute = g_currentMission.environment.currentMinute
	
	if g_currentMission.environment.currentMinute ~= 0 then
		--self:setVehicleService()
		--self:setBatteryCharging()
		self:setVehicleInspection()
	--	self:setVehicleRepair()
		self:setVehicleRepairDisplayMessage()
	end
	
	local spec_M = self.spec_motorized
    --if spec_M.isMotorStarted then
	if self:getIsMotorStarted() then

		--self:setDamageService()
		--self:setGeneratorBatteryCharging()
		--self:setVehicleDamageThermostatoverHeatingFailure()
		
		--self:addDamage()
		
		--ha a generator meghibasodik lemerul az akkumulator
		self:setBatteryDrainingIfGeneratorFailure()

	
	else

	--	self:setBatteryDrain()
	
		
	end
	
end

function VehicleBreakdowns:RVBhourChanged()
	
	local spec = self.spec_faultData
	local GPSET = g_currentMission.vehicleBreakdowns.gameplaySettings
	



	if g_currentMission.environment.currentHour == GPSET.workshopClose and g_currentMission.environment.currentMinute == 0 then

		if spec.service[1] then
			spec.service[8] = spec.service[8] - spec.service[6]
			spec.service[2] = true
		end
		
		if spec.repair[1] then
			spec.repair[8] = spec.repair[8] - spec.repair[6]
			--local damage = self:getDamageAmount()
			--self:setDamageAmount(damage - ((spec.repair[9] / (1 / spec.repair[6])) / 100), true)
			--self:raiseDirtyFlags(self.spec_wearable.dirtyFlag)
			spec.repair[2] = true
		end
		
		if spec.inspection[1] then
			spec.inspection[2] = true
		end
		
		--if spec.battery[1] then
		--	self:setIsFaultBattery(self:getIsFaultBattery() - spec.battery[6])
		--	spec.battery[2] = true
		--end
		
		--if self.isServer then
		--elseif self.isClient then
			if spec.service[1] then
				RVBService_Event.sendEvent(self, unpack(spec.service))
			end
			if spec.repair[1] then
				RVBRepair_Event.sendEvent(self, unpack(spec.repair))
			end
			if spec.inspection[1] then
				RVBInspection_Event.sendEvent(self, unpack(spec.inspection))
			end
			if spec.battery[1] then
				RVBBattery_Event.sendEvent(self, unpack(spec.battery))
				RVBTotal_Event.sendEvent(self, unpack(spec.rvb))
			end
			--self:raiseDirtyFlags(spec.dirtyFlag)
			
		--end
	end
	
	if g_currentMission.environment.currentHour == GPSET.workshopOpen and g_currentMission.environment.currentMinute == 0 then
	
		if spec.service[1] then
			spec.service[2] = false
		end
		if spec.repair[1] then
			spec.repair[2] = false
		end
		if spec.inspection[1] then
			spec.inspection[2] = false
		end
		if spec.battery[1] then
			spec.battery[2] = false
		end
		
		--if self.isServer then
		--elseif self.isClient then
			if spec.service[1] then
				RVBService_Event.sendEvent(self, unpack(spec.service))
			end
			if spec.repair[1] then
				RVBRepair_Event.sendEvent(self, unpack(spec.repair))
			end
			if spec.inspection[1] then
				RVBInspection_Event.sendEvent(self, unpack(spec.inspection))
			end
			if spec.battery[1] then
				RVBBattery_Event.sendEvent(self, unpack(spec.battery))
			end
			--self:raiseDirtyFlags(spec.dirtyFlag)
		--end
		
	end

	if (g_currentMission.environment.currentHour > GPSET.workshopOpen and g_currentMission.environment.currentMinute == tonumber(0)) and (g_currentMission.environment.currentHour < GPSET.workshopClose and g_currentMission.environment.currentMinute == tonumber(0)) then
		--self:setBatteryCharging()
		self:setVehicleInspection()
	--	self:setVehicleRepair()
		self:setVehicleRepairDisplayMessage()
		--self:setVehicleService()
	end
	
end

function VehicleBreakdowns:setDamageService(dt)
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local servicePeriodic = math.floor(spec.rvb[4])
	if servicePeriodic > RVBSET:getPeriodicService() and self:getIsMotorStarted() then
		local oneGameMinute = 1000 * 60 * 60
		local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
		local increase = runtimeIncrease
		if increase ~= 0 then
			spec.serviceRuntimeToChange = spec.serviceRuntimeToChange + increase
			local serviceRuntimeToChange = spec.serviceRuntimeToChange
			if math.abs(serviceRuntimeToChange) > 0.016666 then
				increase = spec.serviceRuntimeToChange
				spec.serviceRuntimeToChange = 0
				-- PARTS operatingHours
				spec.parts[1].operatingHours = spec.parts[1].operatingHours + increase
				spec.parts[5].operatingHours = spec.parts[5].operatingHours + increase
				spec.parts[6].operatingHours = spec.parts[6].operatingHours + increase
				self:raiseDirtyFlags(spec.dirtyFlag)
				RVBParts_Event.sendEvent(self, unpack(spec.parts))
				if RVBSET:getIsAlertMessage() then
					if self.getIsEntered ~= nil and self:getIsEntered() then
					--	g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_fault_operatinghours"), 2500)
					else
					--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("RVB_fault_operatinghours_hud"), self:getFullName()), 5000)
					end
				end
			end
		end
	end
end	
function VehicleBreakdowns:setVehicleDamageThermostatoverHeatingFailure(dt)
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local currentTemp = self.spec_motorized.motorTemperature.value
	currentTemp = math.floor(currentTemp)
	local oneGameMinute = 1000 * 60 * 60
	local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
	if spec.faultStorage[1] and currentTemp > 95 and self:getIsMotorStarted() then
		local increase = runtimeIncrease
		if increase ~= 0 then
			spec.thermostatoverHeatingRuntimeToChange = spec.thermostatoverHeatingRuntimeToChange + increase
			local thermostatoverHeatingRuntimeToChange = spec.thermostatoverHeatingRuntimeToChange
			if math.abs(thermostatoverHeatingRuntimeToChange) > 0.016666 then
				increase = spec.thermostatoverHeatingRuntimeToChange
				spec.thermostatoverHeatingRuntimeToChange = 0
				-- PARTS operatingHours
				spec.parts[1].operatingHours = spec.parts[1].operatingHours + increase
				spec.parts[6].operatingHours = spec.parts[6].operatingHours + increase
				RVBParts_Event.sendEvent(self, unpack(spec.parts))
				self:raiseDirtyFlags(spec.dirtyFlag)
				if RVBSET:getIsAlertMessage() then
					if self.getIsEntered ~= nil and self:getIsEntered() then
					--	g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_fault_thermostat"), 2500)
					else
					--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("RVB_fault_thermostat_hud"), self:getFullName()), 5000)
					end
				end
			end
		end
	end
end
function VehicleBreakdowns:setVehicleDamageGlowplugFailure(dt)
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local oneGameMinute = 1000 * 60 * 60
	local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
	if self:getIsFaultGlowPlug() then
		local increase = runtimeIncrease
		if increase ~= 0 then
			spec.glowplugRuntimeToChange = spec.glowplugRuntimeToChange + increase
			local glowplugRuntimeToChange = spec.glowplugRuntimeToChange
			if math.abs(glowplugRuntimeToChange) > 0.016666 then
				increase = spec.glowplugRuntimeToChange
				spec.glowplugRuntimeToChange = 0
				-- PARTS operatingHours
				spec.parts[1].operatingHours = spec.parts[1].operatingHours + increase
				spec.parts[5].operatingHours = spec.parts[5].operatingHours + increase
				spec.parts[6].operatingHours = spec.parts[6].operatingHours + increase
				RVBParts_Event.sendEvent(self, unpack(spec.parts))
				self:raiseDirtyFlags(spec.dirtyFlag)
				if RVBSET:getIsAlertMessage() then
					if self.getIsEntered ~= nil and self:getIsEntered() then
					--	g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_fault_glowplug"), 2500)
					else
					--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("RVB_fault_glowplug_hud"), self:getFullName()), 5000)
					end
				end
			end
		end
	end
end
function VehicleBreakdowns:deactivateLights(superFunc, keepHazardLightsOn)
    local spec = self.spec_lights
    self:setLightsTypesMask(0, true, true)
    self:setBeaconLightsVisibility(false, true, true)
    if not keepHazardLightsOn or spec.turnLightState ~= Lights.TURNLIGHT_HAZARD then
        self:setTurnLightState(Lights.TURNLIGHT_OFF, true, true)
    end
    self:setBrakeLightsVisibility(false)
    self:setReverseLightsVisibility(false)
    self:setInteriorLightsVisibility(false)
    spec.currentLightState = 0
end

	
function VehicleBreakdowns:setLightsTypesMask(superFunc, lightsTypesMask, force, noEventSend)
	local spec = self.spec_lights

	if self.isServer then
		lightsTypesMask = bitAND(lightsTypesMask, spec.maxLightStateMask)

		if spec.turnLightState == Lights.TURNLIGHT_LEFT then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.turnLightLeft)
		end

		if spec.turnLightState == Lights.TURNLIGHT_RIGHT then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.turnLightRight)
		end

		if spec.turnLightState == Lights.TURNLIGHT_HAZARD then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.turnLightAny)
		end

		if spec.brakeLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.brakeLight)
		end

		if spec.reverseLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.reverseLight)
		end

		if spec.interiorLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.interiorLight)
		end
		
	else
		
		--[[lightsTypesMask = bitXOR(lightsTypesMask, 2^spec.additionalLightTypes.interiorLight)

		if spec.interiorLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.interiorLight)
		end]]
		
		--lightsTypesMask = bitAND(lightsTypesMask, spec.maxLightStateMask)
		lightsTypesMask = bitXOR(lightsTypesMask, 2^spec.additionalLightTypes.interiorLight)

		if spec.turnLightState == Lights.TURNLIGHT_LEFT then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.turnLightLeft)
		end

		if spec.turnLightState == Lights.TURNLIGHT_RIGHT then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.turnLightRight)
		end

		if spec.turnLightState == Lights.TURNLIGHT_HAZARD then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.turnLightAny)
		end

		if spec.brakeLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.brakeLight)
		end

		if spec.reverseLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.reverseLight)
		end

		if spec.interiorLightsVisibility then
			lightsTypesMask = bitOR(lightsTypesMask, 2^spec.additionalLightTypes.interiorLight)
		end

	end

	if lightsTypesMask ~= spec.lightsTypesMask or force then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(VehicleSetLightEvent.new(self, lightsTypesMask, spec.totalNumLightTypes), nil, nil, self)
			else
				g_client:getServerConnection():sendEvent(VehicleSetLightEvent.new(self, lightsTypesMask, spec.totalNumLightTypes))
			end
		end

		if bitAND(lightsTypesMask, spec.maxLightStateMask) ~= bitAND(spec.lightsTypesMask, spec.maxLightStateMask) and self.isClient then
			g_soundManager:playSample(spec.samples.toggleLights)
		end

		local activeLightSetup = spec.realLights.low
		local inactiveLightSetup = spec.realLights.high

		if self:getUseHighProfile() then
			activeLightSetup = spec.realLights.high
			inactiveLightSetup = spec.realLights.low
		end

		self:setLightsState(inactiveLightSetup.realLights, false)
		self:setLightsState(activeLightSetup.realLights, lightsTypesMask)
		self:setLightsState(spec.staticLights, lightsTypesMask)

		spec.lightsTypesMask = lightsTypesMask

		
		SpecializationUtil.raiseEvent(self, "onLightsTypesMaskChanged", lightsTypesMask)
	end

	return true
end
--Lights.setLightsTypesMask = Utils.overwrittenFunction(Lights.setLightsTypesMask, VehicleBreakdowns.setLightsTypesMask)

function VehicleBreakdowns:setBatteryDrain(dt)

	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns

	if not self:getIsMotorStarted() and not spec.parts[2].damaged and not spec.parts[2].repairreq then -- self.spec_motorized.isMotorStarted

		if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.LIGHTS and self:getIsFaultBattery() >= VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS then
			if self.deactivateLights ~= nil then
				self:deactivateLights()
			end
		end
		if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS then
			if self.deactivateBeaconLights ~= nil then
				self:deactivateBeaconLights()
			end
		end

		local drainValue = 0
		local dischargeValue = 0

		if spec.rvblightsTypesMask > 0 then
			if self.spec_lights.currentLightState == 1 then
				if spec.rvblightsTypesMask == 9 then
					drainValue = 0.015
					dischargeValue = 8500
				end
				drainValue = 0.012--0.1
				dischargeValue = 9000
			elseif self.spec_lights.currentLightState == 2 then
				drainValue = 0.024
				dischargeValue = 7200
			elseif self.spec_lights.currentLightState == 3 then
				drainValue = 0.036
				dischargeValue = 5400
			elseif self.spec_lights.currentLightState == 4 then
				drainValue = 0.041
				dischargeValue = 3600
			elseif self.spec_lights.currentLightState == 9 then
				drainValue = 0.041
				dischargeValue = 3600
			else
				if spec.rvblightsTypesMask ~= 32 and spec.rvblightsTypesMask ~= 64 and spec.rvblightsTypesMask ~= 128 and spec.rvblightsTypesMask ~= 256 then
					drainValue = 0.03
					dischargeValue = 5800
				end
			end
	
		end

		if self.spec_lights.beaconLightsActive then
			drainValue = drainValue + 0.001
			dischargeValue = dischargeValue - 600
		end
		--if self.spec_lights.brakeLightsVisibility then
		--	drainValue = drainValue + 0.02
		--end
		
	
		if self.spec_lights.turnLightState ~= Lights.TURNLIGHT_OFF then
			if self.spec_lights.turnLightState == Lights.TURNLIGHT_LEFT or self.spec_lights.turnLightState == Lights.TURNLIGHT_RIGHT then
				drainValue = drainValue + 0.002
				dischargeValue = dischargeValue - 1200
			end
			if self.spec_lights.turnLightState == Lights.TURNLIGHT_HAZARD then
				drainValue = drainValue + 0.004
				dischargeValue = dischargeValue - 1400
			end
		end
		
		if drainValue > 0 then
			if spec.isInitialized then
				local batteryFillLevel = self:getFillUnitFillLevel(spec.batteryFillUnitIndex)
				if batteryFillLevel > 0 then
					
					local repairTime = dischargeValue * 1000

					local delta = dt * g_currentMission.missionInfo.timeScale / repairTime * 100

					self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, -delta, self:getFillUnitFillType(spec.batteryFillUnitIndex), ToolType.UNDEFINED)
			
				end
			end
		end

		if RVBSET:getIsAlertMessage() then
			if self.getIsEntered ~= nil and self:getIsEntered() then
			--	g_currentMission:showBlinkingWarning(g_i18n:getText("fault_operatinghours"), 2500)
			else
			--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("fault_operatinghours_hud"), self:getFullName()), 5000)
			end
			if VehicleBreakdowns.Debug.Info then
				--Logging.info("[RVB] "..string.format(g_i18n:getText("RVB_alertmessage_batteryCh_hud"), self:getFullName()))
			end
		end

	end
	
end

function VehicleBreakdowns:setBatteryDrainingIfGeneratorFailure()

	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns

	if self:getIsMotorStarted() and not self:getIsFaultLightings() then -- self.spec_motorized.isMotorStarted

		if self:getIsFaultGenerator() then

			local drainValue = 0

			if spec.rvblightsTypesMask > 0 then

				if self.spec_lights.currentLightState == 1 then
					--if self.spec_lights.lightsTypesMask == 9 then
					if spec.rvblightsTypesMask == 9 then
						drainValue = 0.15
					end
					drainValue = 0.1
				elseif self.spec_lights.currentLightState == 2 then
					drainValue = 0.2
				elseif self.spec_lights.currentLightState == 3 then
					drainValue = 0.3
				elseif self.spec_lights.currentLightState == 4 then
					drainValue = 0.35
				elseif self.spec_lights.currentLightState == 9 then
					drainValue = 0.35
				else
					if spec.rvblightsTypesMask ~= 32 and spec.rvblightsTypesMask ~= 64 and spec.rvblightsTypesMask ~= 128 and spec.rvblightsTypesMask ~= 256 then
						drainValue = 0.3
					end
				end
	
			end
			
			if self.spec_lights.beaconLightsActive then
				drainValue = drainValue + 0.01
			end
			--if self.spec_lights.brakeLightsVisibility then
			--	drainValue = drainValue + 0.02
			--end
		
			if self.spec_lights.turnLightState ~= Lights.TURNLIGHT_OFF then
				if self.spec_lights.turnLightState == Lights.TURNLIGHT_LEFT or self.spec_lights.turnLightState == Lights.TURNLIGHT_RIGHT then
					drainValue = drainValue + 0.02
				end
				if self.spec_lights.turnLightState == Lights.TURNLIGHT_HAZARD then
					drainValue = drainValue + 0.04
				end
			end

			if spec.isInitialized and self.getConsumerFillUnitIndex ~= nil and self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil then
				local batteryFillLevel = self:getFillUnitFillLevel(spec.batteryFillUnitIndex)
				if batteryFillLevel > 0 then
					self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, -drainValue, self:getFillUnitFillType( spec.batteryFillUnitIndex), ToolType.UNDEFINED, nil)
				end
			end
		end
	end
	
end

function VehicleBreakdowns:setBatteryDrainingIfStartMotor()

	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	
	local drainValue = 2
	if self.getConsumerFillUnitIndex ~= nil and self:getConsumerFillUnitIndex(FillType.ELECTRICCHARGE) ~= nil and self:getConsumerFillUnitIndex(FillType.DIESEL) == nil then
		drainValue = 1
	end


	if self:getIsFaultBattery() <= VehicleBreakdowns.SET.BatteryLevel.MOTOR or self:getIsFaultSelfStarter() then

		drainValue = 1
		
		if RVBSET:getIsAlertMessage() then
			--if self:displayMessage(currentMinute) == "0" or self:displayMessage(currentMinute) == "5" then
				if self.getIsEntered ~= nil and self:getIsEntered() then
					g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_fault_BHlights"), 2500)
				else
				--	g_currentMission.hud:addSideNotification(FSBaseMission.INGAME_NOTIFICATION_OK, string.format(g_i18n:getText("RVB_fault_BHlights"), self:getFullName()), 2500)
				end
				if VehicleBreakdowns.Debug.Info then
					Logging.info("[RVB] "..string.format(g_i18n:getText("RVB_fault_BHlights"), self:getFullName()))
				end
			--end
		end
		
	end

	if self:getIsFaultBattery() >= 0.03 then -- VehicleBreakdowns.SET.BatteryLevel.MOTOR then

		if self:getIsFaultGlowPlug() then
			drainValue = 1
		end
		if spec.isInitialized then
			local batteryFillLevel = self:getFillUnitFillLevel(spec.batteryFillUnitIndex)
			if batteryFillLevel > 0 then
				self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, -drainValue, self:getFillUnitFillType(spec.batteryFillUnitIndex), ToolType.UNDEFINED, nil)
			end
		end

	end

end

function VehicleBreakdowns:setBatteryCharging()

	local spec = self.spec_faultData
	
	if spec.battery[1] then

		self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, 100, self:getFillUnitFillType(spec.batteryFillUnitIndex), ToolType.UNDEFINED, nil)

		self:setIsFaultBattery(0)
		spec.battery[1] = false
		spec.battery[2] = false
		spec.battery[3] = 0
		spec.battery[4] = 0
		spec.battery[5] = 0
		spec.battery[6] = 0

		local specm = self.spec_motorized
		specm.motorTemperature.value = self.currentTemperaturDay

		if self.isClient and self:getIsEntered() then
			--self:requestActionEventUpdate()
		end
		
		local batterycosts = spec.battery[7]
		self:RVBaddRemoveMoney(-batterycosts, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR)
		spec.battery[7] = 0
		RVBBattery_Event.sendEvent(self, unpack(spec.battery))
		--self:raiseDirtyFlags(spec.dirtyFlag)

	end

end

function VehicleBreakdowns:rvbVehicleSetLifetime(fieldNum, fieldValue)
	local GSET = g_currentMission.vehicleBreakdowns.generalSettings
	local GPSET = g_currentMission.vehicleBreakdowns.gameplaySettings
	
	for _, vehicle in ipairs(g_currentMission.vehicleSystem.vehicles) do
		if vehicle.spec_faultData ~= nil then
			for i=1, #vehicle.spec_faultData.parts do
				if i == fieldNum then
					vehicle.spec_faultData.parts[i].lifetime = fieldValue
					if GSET.difficulty == 1 then
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime * 2 * g_currentMission.environment.plannedDaysPerPeriod
					elseif GSET.difficulty == 2 then
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime * 1 * g_currentMission.environment.plannedDaysPerPeriod
					else
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime / 2 * g_currentMission.environment.plannedDaysPerPeriod
					end
				end
			end
			RVBParts_Event.sendEvent(vehicle, unpack(vehicle.spec_faultData.parts))
			--self:raiseDirtyFlags(vehicle.spec_faultData.dirtyFlag)
		end
	end

end

		
function VehicleBreakdowns:batteryChargeVehicle()
	local spec = self.spec_faultData
	self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, 100, self:getFillUnitFillType(spec.batteryFillUnitIndex), ToolType.UNDEFINED, nil)
	if self.isServer then
		g_currentMission:addMoney(-25, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR, true, true)
		local total, _ = g_farmManager:updateFarmStats(self:getOwnerFarmId(), "repairVehicleCount", 1)
		if total ~= nil then
			g_achievementManager:tryUnlock("VehicleRepairFirst", total)
			g_achievementManager:tryUnlock("VehicleRepair", total)
		end
	end
end

function VehicleBreakdowns:setGeneratorBatteryCharging(dt)

	local spec = self.spec_faultData

	local motorState = self:getMotorState()

	if not self:getIsFaultGenerator() and motorState == MotorState.ON then -- FS22 self.spec_motorized.isMotorStarted

		if spec.isInitialized and self.getConsumerFillUnitIndex ~= nil and self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil then
			local batteryFillLevel = self:getFillUnitFillLevel(spec.batteryFillUnitIndex)
			if batteryFillLevel < 100 then

				local Plusbattery = 0.02
				local delta = dt * g_currentMission.missionInfo.timeScale * Plusbattery / 1000

				self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, delta, self:getFillUnitFillType(spec.batteryFillUnitIndex), ToolType.UNDEFINED, nil)
				--print("setGeneratorBatteryCharging "..self.spec_fillUnit.fillUnits[spec.batteryFillUnitIndex].fillLevel)
				--spec.RVB_BatteryFillLevel = self.spec_fillUnit.fillUnits[spec.batteryFillUnitIndex].fillLevel
				--self:raiseDirtyFlags(spec.dirtyFlag)
		--		self:raiseDirtyFlags(self.spec_fillUnit.dirtyFlag)

			end
		end

	end

end
function VehicleBreakdowns:chargeBatteryFromGenerator(dt)
    local spec = self.spec_faultData
    local generatorBaseOutput = 60 -- Alap generátor kimenet (A)
    local maxGeneratorOutput = 120 -- Maximális generátor kimenet (A)
	local motorState = self:getMotorState()

    if not self:getIsFaultGenerator() and motorState == MotorState.ON then
        if spec.isInitialized and self.getConsumerFillUnitIndex ~= nil and self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil then
            local batteryFillLevel = self:getFillUnitFillLevel(spec.batteryFillUnitIndex)

            -- Csak akkor töltjük az akkumulátort, ha a töltöttség 100% alatt van
            if batteryFillLevel < 100 then
                local currentRPM = self.spec_motorized.motor.lastMotorRpm -- Aktuális fordulatszám
                local minRPM = self.spec_motorized.motor.minRpm
                local maxRPM = self.spec_motorized.motor.maxRpm

                -- Hatékonysági tényező az üzemórák alapján
                local efficiencyFactor = math.max(0.1, 1 - (spec.parts[5].operatingHours / spec.parts[5].tmp_lifetime)) -- Minimális hatékonyság: 0.1

                -- RPM százalék és RPM faktor számítása
                local rpmPercentage = (currentRPM - minRPM) / (maxRPM - minRPM)
                local idleFactor = 0.5
                local rpmFactor = idleFactor + rpmPercentage * (1 - idleFactor)

                -- Terhelési tényező számítása
                local loadFactor = math.max(self.spec_motorized.smoothedLoadPercentage * rpmPercentage, 0)
                local motorFactor = 0.5 * (0.2 * rpmFactor + 1.8 * loadFactor) + 0.8  -- Motor faktor frissítve

				 -- Ellenőrizzük a minimális fordulatszámot
                if currentRPM < 1000 then
                    --print("A fordulatszám túl alacsony a töltéshez.")
                    return -- Nem töltjük, ha a fordulatszám alacsony
                end
				
				-- Töltési ráta számítása a motor és generátor állapot alapján
				--local chargeRate = generatorBaseOutput * motorFactor * efficiencyFactor * (dt / 3600000) * g_currentMission.missionInfo.timeScale -- Töltési ráta (A)
				local oneGameMinute = 1000 * 60 * 60
				local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
				--local chargeRate = generatorBaseOutput * motorFactor * efficiencyFactor * runtimeIncrease

				local generatorOutput = generatorBaseOutput + (maxGeneratorOutput - generatorBaseOutput) * loadFactor
				local chargeRate = generatorOutput * motorFactor * efficiencyFactor * runtimeIncrease

                -- Ellenőrizzük, hogy a kimeneti áram helyes legyen
                if chargeRate < 0 then
                    chargeRate = 0
                end

                -- Új töltöttségi szint számítása
                local newFillLevel = batteryFillLevel + chargeRate

                -- Ellenőrizzük, hogy a töltöttség ne lépje túl a maximális szintet
                if newFillLevel > 100 then
                    newFillLevel = 100 -- Maximalizáljuk a töltöttséget
                end

                -- Akkumulátor töltöttségének frissítése
                self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.batteryFillUnitIndex, newFillLevel - batteryFillLevel, self:getFillUnitFillType(spec.batteryFillUnitIndex), ToolType.UNDEFINED, nil)

                -- Debugging információk (opcionális)
                --print(string.format("Akkumulátor töltöttség: %.2f Ah, Töltési Ráta: %.6f A, Fordulatszám: %.2f RPM, Hatékonyság: %.2f, Terhelési tényező: %.2f", newFillLevel, chargeRate, currentRPM, efficiencyFactor, motorFactor))
				
				--print(string.format("Current RPM: %.2f, Generator Output: %.6f A, Motor Factor: %.2f, Efficiency Factor: %.2f", currentRPM, chargeRate, motorFactor, efficiencyFactor))
				--print(string.format("Motor Factor: %.2f, Load Factor: %.2f", motorFactor, loadFactor))

                -- Töltési idő nyomon követése
				if chargeRate > 0 then
					self.spec_faultData.chargeTime = (self.spec_faultData.chargeTime or 0) + (dt / 1000) -- Töltési idő másodpercekben
					local seconds = (100 - batteryFillLevel) / chargeRate / 1000 -- Hátralévő idő (másodpercben)
					if seconds >= 1 then
						local minutes = math.floor(seconds / 60)
						seconds = seconds - (minutes * 60)
					--	g_currentMission:addExtraPrintText(string.format("Hátralévő töltési idő: %d perc %d másodperc", minutes, seconds))
						--g_currentMission:addExtraPrintText(string.format(g_i18n:getText("info_chargeTime"), minutes, seconds, fillLevel / capacity * 100))
					end
				end

            end
        end
    end
end

function VehicleBreakdowns:setVehicleInspectionAAA()

	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns

	local currentDay = g_currentMission.environment.currentDay
	local currentHour = g_currentMission.environment.currentHour
	local currentMinute = g_currentMission.environment.currentMinute

	if spec.inspection[1] then

		if not spec.inspection[2] then
	
			if RVBSET:getIsAlertMessage() then
				if self:displayMessage(currentMinute) == "0" then
					if self.getIsEntered ~= nil and self:getIsEntered() then
						g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_alertmessage_inspection"), 2500)
					else
					--	g_currentMission.hud:addSideNotification(FSBaseMission.INGAME_NOTIFICATION_OK, string.format(g_i18n:getText("RVB_alertmessage_inspection_hud"), self:getFullName()), 2500)
					end
					if VehicleBreakdowns.Debug.Info then
						Logging.info("[RVB] "..string.format(g_i18n:getText("RVB_alertmessage_inspection_hud"), self:getFullName()))
					end
				end
			end

		end

		if currentDay == spec.inspection[3] and currentHour >= spec.inspection[4] and currentMinute >= spec.inspection[5] then

			spec.inspection[1] = false
			spec.inspection[2] = false
			spec.inspection[3] = 0
			spec.inspection[4] = 0
			spec.inspection[5] = 0

			local specm = self.spec_motorized
			specm.motorTemperature.value = self.currentTemperaturDay
			--specm.motorFan.enableTemperature = 95
			--specm.motorFan.disableTemperature = 85

			if self.isClient and self:getIsEntered() then
				--self:requestActionEventUpdate()
			end


			local thermostatRandom = false

			for i = 1, #spec.parts do
				spec.partfoot = (spec.parts[i].operatingHours * 100) / spec.parts[i].tmp_lifetime

				if i == 2 or i == 4 then
					if spec.partfoot >= 100 and not spec.parts[i].repairreq then
						spec.faultList[i] = true -- Hiba hozzáadása a táblához
						spec.parts[i].repairreq = true
					end
				else
					if spec.partfoot > 95 and not spec.parts[i].repairreq then
						if i == 1 then
							thermostatRandom = true
						end
						spec.faultList[i] = true -- Hiba hozzáadása a táblához
						spec.parts[i].repairreq = true
					end
				end
			end

			if thermostatRandom and not spec.faultStorage[1] and not spec.faultStorage[2] then
				local faultNum = {1,2}
				if faultNum[math.random(#faultNum)] == 1 then
					spec.faultStorage[1] = true
				else
					spec.faultStorage[2] = true
				end
			
				--if self.isServer then
				--elseif self.isClient then
					RVB_Event.sendEvent(self, unpack(spec.faultStorage))
					--self:raiseDirtyFlags(spec.dirtyFlag)
				--end
				thermostatRandom = false
			end
		
			local faultTexts = {}
			for index, isActive in pairs(spec.faultList) do
				if isActive and VehicleBreakdowns.faultText[index] then
					table.insert(faultTexts, g_i18n:getText("RVB_faultText_" .. VehicleBreakdowns.faultText[index]))
				end
			end


			if #faultTexts > 0 then
				spec.inspection[8] = true
				local errorMessage = string.format(
					g_i18n:getText("RVB_inspectionDialogFault"),
					self:getFullName(),
					g_i18n:formatMoney(self:getRepairPrice_RVBClone(true))
				) .. "\n" .. g_i18n:getText("RVB_ErrorList") .. "\n" .. table.concat(faultTexts, ", ")
				InfoDialog.show(errorMessage)	
			else
				
				local damage = self:getDamageAmount()
				local end_text = ""

				if damage >= 0.90 then

					--if self.isServer then

						g_currentMission:addMoney(-self:getRepairPrice(), self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR, true, true)
						local damage_repair = math.random(20,50)
											-- 0
						self:setDamageAmount(damage_repair, true)
					
					--end
					end_text = "RVB_inspectionDialogEnd_other"
					
				else
					end_text = "RVB_inspectionDialogEnd"
				end
				
				spec.inspection[8] = false
				InfoDialog.show(string.format(g_i18n:getText(end_text), self:getFullName()))
				
			end
			
			if self.isClient and self:getIsEntered() then
				self:requestActionEventUpdate()
			end
			
			local inspectioncosts = spec.inspection[6]
			self:RVBaddRemoveMoney(-inspectioncosts, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR)
			spec.inspection[6] = 0
			RVBInspection_Event.sendEvent(self, unpack(spec.inspection))
			RVBParts_Event.sendEvent(self, unpack(spec.parts))
			--self:raiseDirtyFlags(spec.dirtyFlag)
			
			--VehicleBreakdowns:DebugFaultPrint(spec)

		end

	end

end

		
function VehicleBreakdowns:setVehicleInspection()
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local currentDay = g_currentMission.environment.currentDay
	local currentHour = g_currentMission.environment.currentHour
	local currentMinute = g_currentMission.environment.currentMinute
	if self:getIsInspection() then
		if not spec.inspection[2] then
			if RVBSET:getIsAlertMessage() then
				if self:displayMessage(currentMinute) == "0" then
					if self.getIsEntered ~= nil and self:getIsEntered() then
						g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_alertmessage_inspection"), 2500)
					else
					--	g_currentMission.hud:addSideNotification(FSBaseMission.INGAME_NOTIFICATION_OK, string.format(g_i18n:getText("RVB_alertmessage_inspection_hud"), self:getFullName()), 2500)
					end
					if VehicleBreakdowns.Debug.Info then
						Logging.info("[RVB] "..string.format(g_i18n:getText("RVB_alertmessage_inspection_hud"), self:getFullName()))
					end
				end
			end

		end
		if currentDay == spec.inspection[3] and currentHour >= spec.inspection[4] and currentMinute >= spec.inspection[5] then
			spec.inspection[1] = false
			spec.inspection[2] = false
			spec.inspection[3] = 0
			spec.inspection[4] = 0
			spec.inspection[5] = 0
			local specm = self.spec_motorized
			specm.motorTemperature.value = self.currentTemperaturDay
			for i = 1, #spec.parts do
				spec.parts[i].repairreq = false
			end
			local thermostatRandom = false
			for i = 1, #spec.parts do
				spec.partfoot = (spec.parts[i].operatingHours * 100) / spec.parts[i].tmp_lifetime
				if i == 2 or i == 4 then
					if spec.partfoot >= 100 then
						spec.faultList[i] = true
						spec.parts[i].repairreq = true
					end
				else
					if spec.partfoot > 95 then
						if i == 1 then
							thermostatRandom = true
						end
						spec.faultList[i] = true
						spec.parts[i].repairreq = true
					end
				end
			end
			if thermostatRandom and not spec.faultStorage[1] and not spec.faultStorage[2] then
				local faultNum = {1,2}
				if faultNum[math.random(#faultNum)] == 1 then
					spec.faultStorage[1] = true
				else
					spec.faultStorage[2] = true
				end
				--if self.isServer then
				--elseif self.isClient then
					RVB_Event.sendEvent(self, unpack(spec.faultStorage))
					--self:raiseDirtyFlags(spec.dirtyFlag)
				--end
				thermostatRandom = false
			end
			local faultTexts = {}
			for index, isActive in pairs(spec.faultList) do
				if isActive and VehicleBreakdowns.faultText[index] then
					table.insert(faultTexts, g_i18n:getText("RVB_faultText_" .. VehicleBreakdowns.faultText[index]))
				end
			end
			if #faultTexts > 0 then
				spec.inspection[8] = true
				local errorMessage = string.format(
					g_i18n:getText("RVB_inspectionDialogFault"),
					self:getFullName(),
					g_i18n:formatMoney(self:getRepairPrice_RVBClone(true))
				) .. "\n" .. g_i18n:getText("RVB_ErrorList") .. "\n" .. table.concat(faultTexts, ", ")
				InfoDialog.show(errorMessage)	
			else
				local damage = self:getDamageAmount()
				local end_text = ""

				if damage >= 0.90 then
					--if self.isServer then
						g_currentMission:addMoney(-self:getRepairPrice(), self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR, true, true)
						local damage_repair = math.random(20,50)
						self:setDamageAmount(damage_repair, true)
					--end
					end_text = "RVB_inspectionDialogEnd_other"
				else
					end_text = "RVB_inspectionDialogEnd"
				end
				
				spec.inspection[8] = true
				InfoDialog.show(string.format(g_i18n:getText(end_text), self:getFullName()))
			end
			if self.isClient and self:getIsEntered() then
				self:requestActionEventUpdate()
			end
			local inspectioncosts = spec.inspection[6]
			self:RVBaddRemoveMoney(-inspectioncosts, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR)
			spec.inspection[6] = 0
			RVBInspection_Event.sendEvent(self, unpack(spec.inspection))
			RVBParts_Event.sendEvent(self, unpack(spec.parts))
			--self:raiseDirtyFlags(spec.dirtyFlag)
			--VehicleBreakdowns:DebugFaultPrint(spec)
		end
	end
end
function VehicleBreakdowns:RVBaddRemoveMoney(amount, farmId, moneyType)
	if g_currentMission:getIsServer() then
		g_currentMission:addMoneyChange(amount, farmId, moneyType, true)
		local farm = g_farmManager:getFarmById(farmId)
		if farm ~= nil then
			farm:changeBalance(amount, moneyType)
		end
	end
end

function VehicleBreakdowns:CalculateFinishTime(AddHour, AddMinute)
    local GPSET = g_currentMission.vehicleBreakdowns.gameplaySettings
    local currentTimeInMinutes = g_currentMission.environment.currentHour * 60 + g_currentMission.environment.currentMinute
    local addTimeInMinutes = AddHour * 60 + AddMinute
    local workshopOpenTime = GPSET.workshopOpen * 60
    local workshopCloseTime = GPSET.workshopClose * 60
    local finishDay = g_currentMission.environment.currentDay
    if currentTimeInMinutes < workshopOpenTime then
        currentTimeInMinutes = workshopOpenTime
    end
    local finishTimeInMinutes = currentTimeInMinutes + addTimeInMinutes
    if finishTimeInMinutes >= workshopCloseTime then
        finishDay = finishDay + 1
        finishTimeInMinutes = workshopOpenTime + (finishTimeInMinutes - workshopCloseTime)
    end
    local finishHour = math.floor(finishTimeInMinutes / 60)
    local finishMinute = finishTimeInMinutes % 60
    return finishDay, finishHour, finishMinute
end
function VehicleBreakdowns:setVehicleRepairDisplayMessage()
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local isInspectionCompletedAndRepairNeeded = spec.inspection[8] and spec.repair[1]
	local isRepairNotPaused = not spec.repair[2]
	-- Az ellenőrzés és javítás állapotának figyelése
	if isInspectionCompletedAndRepairNeeded and isRepairNotPaused then
		if RVBSET:getIsAlertMessage() then
			if self.getIsEntered ~= nil and self:getIsEntered() then
				g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_alertmessage_repair"), 2500)
			else
				--g_currentMission.hud:addSideNotification(FSBaseMission.INGAME_NOTIFICATION_OK, string.format(g_i18n:getText("RVB_alertmessage_repair_hud"), self:getFullName()), 2500)
			end
			if VehicleBreakdowns.Debug.Info then
				Logging.info("[RVB] "..string.format(g_i18n:getText("RVB_alertmessage_repair_hud"), self:getFullName()))
			end
		end
	end
end
function VehicleBreakdowns:updateRepair(dt)
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local currentDay = g_currentMission.environment.currentDay
	local currentHour = g_currentMission.environment.currentHour
	local currentMinute = g_currentMission.environment.currentMinute
	local isInspectionCompletedAndRepairNeeded = spec.inspection[8] and spec.repair[1]
	local isRepairNotPaused = not spec.repair[2]
	if isInspectionCompletedAndRepairNeeded then
		if isRepairNotPaused then
			for i, part in ipairs(spec.parts) do
				if part.repairreq then
					if not part.startingOperatingHours then
						part.startingOperatingHours = part.operatingHours
					end
					local repairTime = VehicleBreakdowns.IRSBTimes[i] or 0
					if repairTime > 0 then

						local operatingHoursPerSecond = part.startingOperatingHours  / repairTime
						local reduction = operatingHoursPerSecond * (dt / 1000) * g_currentMission.missionInfo.timeScale

						if reduction ~= 0 then
							spec.partsToChange = spec.partsToChange + reduction
							local partsToChange = spec.partsToChange

							if math.abs(partsToChange) > 0.016666 or partsToChange >= part.operatingHours then
								reduction = spec.partsToChange
								spec.partsToChange = 0
								part.operatingHours = math.max(part.operatingHours - reduction, 0)
								self:raiseDirtyFlags(spec.dirtyFlag)				
							end

						end
					end
				end
			end
		end
		if currentDay == spec.repair[3] and currentHour >= spec.repair[4] and currentMinute >= spec.repair[5] then
			for i, part in ipairs(spec.parts) do
				--if part.operatingHours <= 0.016 then
					part.repairreq = false
					part.operatingHours = 0.000000
					part.damaged = false
					part.startingOperatingHours = nil
					spec.repair[1] = false
					spec.repair[2] = false
					spec.repair[3] = 0
					spec.repair[4] = 0
					spec.repair[5] = 0
					spec.repair[6] = 0
					spec.repair[8] = 0
					spec.repair[9] = 0
					spec.repair[10] = false
					spec.inspection[8] = false
					local specm = self.spec_motorized
					specm.motorTemperature.value = self.currentTemperaturDay
					specm.motorFan.enableTemperature = 95
					specm.motorFan.disableTemperature = 85
					if self.isClient and self:getIsEntered() then
						self:requestActionEventUpdate()
					end
					for index, value in pairs(spec.faultStorage) do
						if type(value) == "boolean" and value then
							spec.faultStorage[index] = false
						end
					end
					local repaircosts = spec.repair[7]
					self:RVBaddRemoveMoney(-repaircosts, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR)
					spec.repair[7] = 0
					RVBRepair_Event.sendEvent(self, unpack(spec.repair))
					RVBInspection_Event.sendEvent(self, unpack(spec.inspection))
					RVB_Event.sendEvent(self, unpack(spec.faultStorage))
					RVBParts_Event.sendEvent(self, unpack(spec.parts))
				--end
			end
		end
	end
end

function VehicleBreakdowns:setVehicleRepair(dt)

	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns

	local currentDay = g_currentMission.environment.currentDay
	local currentHour = g_currentMission.environment.currentHour
	local currentMinute = g_currentMission.environment.currentMinute

	if spec.repair[1] and spec.inspection[8] then

		if not spec.repair[2] then

			local repairTime = 0
			for i=1, #spec.parts do
				if spec.parts[i].repairreq then
					repairTime = repairTime + VehicleBreakdowns.IRSBTimes[i]
				end
			end
			repairTime = repairTime * 1000
			for i, value in pairs(spec.parts) do
				if value.repairreq then
					value.operatingHours = value.operatingHours - dt * g_currentMission.missionInfo.timeScale / repairTime * value.tmp_lifetime
					--RVBParts_Event.sendEvent(self, unpack(spec.parts))
					--self:raiseDirtyFlags(spec.dirtyFlag)
					self:raiseDirtyFlags(spec.dirtyFlag)
				end
			end

			
			--if self.isServer then
			--	self:raiseDirtyFlags(self.spec_wearable.dirtyFlag)
			--end

			--if self.isServer then
			--elseif self.isClient then
			--	RVBRepair_Event.sendEvent(self, unpack(spec.repair))
			--	self:raiseDirtyFlags(spec.dirtyFlag)
			--end



		end

		if currentDay == spec.repair[3] and currentHour >= spec.repair[4] and currentMinute >= spec.repair[5] then

			spec.repair[1] = false
			spec.repair[2] = false
			spec.repair[3] = 0
			spec.repair[4] = 0
			spec.repair[5] = 0
			spec.repair[6] = 0
			spec.repair[8] = 0
			spec.repair[9] = 0
			spec.repair[10] = false
			
			spec.inspection[8] = false
			
			local specm = self.spec_motorized
			specm.motorTemperature.value = self.currentTemperaturDay
			specm.motorFan.enableTemperature = 95
			specm.motorFan.disableTemperature = 85

			if self.isClient and self:getIsEntered() then
				self:requestActionEventUpdate()
			end

			for index, value in pairs(spec.faultStorage) do
				if type(value) == "boolean" and value then
					spec.faultStorage[index] = false
				end
			end
			
			for i=1, #spec.parts do
				if spec.parts[i].repairreq then
					spec.parts[i].operatingHours = 0.000000
					spec.parts[i].repairreq = false
					spec.parts[i].damaged = false
				end
			end

			local repaircosts = spec.repair[7]
			self:RVBaddRemoveMoney(-repaircosts, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR)
			spec.repair[7] = 0
			RVBRepair_Event.sendEvent(self, unpack(spec.repair))
			RVBInspection_Event.sendEvent(self, unpack(spec.inspection))
			RVB_Event.sendEvent(self, unpack(spec.faultStorage))
			RVBParts_Event.sendEvent(self, unpack(spec.parts))
			--self:raiseDirtyFlags(spec.dirtyFlag)

		end

	end

end
function VehicleBreakdowns:setVehicleService(dt)
	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns
	local currentDay = g_currentMission.environment.currentDay
	local currentHour = g_currentMission.environment.currentHour
	local currentMinute = g_currentMission.environment.currentMinute
	if self:getIsService() then
		if not spec.service[2] then
			local moreservice = 0
			local servicePeriodic = math.floor(spec.rvb[4])
			if servicePeriodic > RVBSET:getPeriodicService() then
				moreservice = math.ceil(servicePeriodic - RVBSET:getPeriodicService())
			end
			local defaultValue = 10800
			--local serviceTime = defaultValue + VehicleBreakdowns.IRSBTimes[9] * moreservice
			local serviceTime = defaultValue
			if moreservice > 0 then
				serviceTime = serviceTime + VehicleBreakdowns.IRSBTimes[9] * moreservice
			end
			if not spec.rvbStartingService then
				spec.rvbStartingService = spec.rvb[4]
			end
			if serviceTime > 0 then

				local servicePerSecond = spec.rvbStartingService  / serviceTime

				local reduction = servicePerSecond * (dt / 1000) * g_currentMission.missionInfo.timeScale


				--local reduction = servicePerSecond * (dt / 1000) * g_currentMission.missionInfo.timeScale

				if reduction ~= 0 then
					spec.serviceToChange = spec.serviceToChange + reduction
					local serviceToChange = spec.serviceToChange

					if math.abs(serviceToChange) > 1 or serviceToChange >= spec.rvb[4] then
						reduction = spec.serviceToChange
						spec.serviceToChange = 0
						spec.rvb[4] = math.max(spec.rvb[4] - reduction, 0)
						self:raiseDirtyFlags(spec.dirtyFlag)				
					end
				end
			end
			
	--		spec.service[8] = spec.service[8] - spec.service[6]
			--if self.isServer then
			--elseif self.isClient then
	--			RVBService_Event.sendEvent(self, unpack(spec.service))
	--			self:raiseDirtyFlags(spec.dirtyFlag)
			--end

			if RVBSET:getIsAlertMessage() then
				if self:displayMessage(currentMinute) == "0" then
					if self.getIsEntered ~= nil and self:getIsEntered() then
						g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_alertmessage_service"), 2500)
					else
					--	g_currentMission.hud:addSideNotification(FSBaseMission.INGAME_NOTIFICATION_OK, string.format(g_i18n:getText("RVB_alertmessage_service_hud"), self:getFullName()), 2500)
					end
					if VehicleBreakdowns.Debug.Info then
						Logging.info("[RVB] "..string.format(g_i18n:getText("RVB_alertmessage_service_hud"), self:getFullName()))
					end
				end
			end

		end

		if currentDay == spec.service[3] and currentHour >= spec.service[4] and currentMinute >= spec.service[5] then
			--if spec.rvb[4] <= 0.01 then
			spec.service[1] = false
			spec.service[2] = false
			spec.service[3] = 0
			spec.service[4] = 0
			spec.service[5] = 0
			spec.service[6] = 0
			spec.service[8] = 0
			spec.rvb[4] = 0
			spec.rvbStartingService = nil

			local specm = self.spec_motorized
			specm.motorTemperature.value = 15

			if self.isClient and self:getIsEntered() then
				self:requestActionEventUpdate()
			end

			local servicecosts = spec.service[7]
			self:RVBaddRemoveMoney(-servicecosts, self:getOwnerFarmId(), MoneyType.VEHICLE_REPAIR)
			spec.service[7] = 0
			RVBService_Event.sendEvent(self, unpack(spec.service))
			RVBTotal_Event.sendEvent(self, unpack(spec.rvb))
			--self:raiseDirtyFlags(spec.dirtyFlag)
--end
		end

	end

end

function VehicleBreakdowns:displayMessage(currentMinute)
	local count = 0
	local string_num = tostring(currentMinute)
	for i in string_num:gmatch("") do
		count = count + 1
	end
	count = count - 1
	return string.sub(string_num, count, count)
end


function VehicleBreakdowns:onPostLoad(savegame)

	if savegame == nil or savegame.resetVehicles then
        return
    end

    local spec = self.spec_faultData
	
	local rvbkey = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns")
	spec.rvb[1] = savegame.xmlFile:getValue(rvbkey .. "#timeScale", 5)
	local starthours = savegame.xmlFile:getValue(rvbkey .. "#operatingHoursTemp", spec.rvb[2]) * 1000
	spec.rvb[2] = math.max(Utils.getNoNil(starthours, 0), 0)
	local totaloperatinghours = savegame.xmlFile:getValue(rvbkey .. "#TotaloperatingHours", spec.rvb[3]) 
	spec.rvb[3] = math.max(Utils.getNoNil(totaloperatinghours, 0), 0)
	
	local periodic = savegame.xmlFile:getValue(rvbkey .. "#operatingHours", spec.rvb[4])
	spec.rvb[4] = math.max(Utils.getNoNil(periodic, 0), 0)
	self:setIsFaultBattery(savegame.xmlFile:getValue(rvbkey .. "#chargelevel", 0))
	
    local key = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns.faultStorage")
	spec.faultStorage[1] = savegame.xmlFile:getValue(key .. "#thermostatoverHeating", false)
	spec.faultStorage[2] = savegame.xmlFile:getValue(key .. "#thermostatoverCooling", false)
	
	local keyservice = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns.vehicleService")
	spec.service[1] = savegame.xmlFile:getValue(keyservice .. "#state", false)
	spec.service[2] = savegame.xmlFile:getValue(keyservice .. "#suspension", false)
	spec.service[3] = savegame.xmlFile:getValue(keyservice .. "#finishday", 0)
	spec.service[4] = savegame.xmlFile:getValue(keyservice .. "#finishhour", 0)
	spec.service[5] = savegame.xmlFile:getValue(keyservice .. "#finishminute", 0)
	spec.service[6] = savegame.xmlFile:getValue(keyservice .. "#amount", 0)
	spec.service[7] = savegame.xmlFile:getValue(keyservice .. "#cost", 0)
	spec.service[8] = savegame.xmlFile:getValue(keyservice .. "#damage", 0)

	local keyrepair = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns.vehicleRepair")
	spec.repair[1] = savegame.xmlFile:getValue(keyrepair .. "#state", false)
	spec.repair[2] = savegame.xmlFile:getValue(keyrepair .. "#suspension", false)
	spec.repair[3] = savegame.xmlFile:getValue(keyrepair .. "#finishday", 0)
	spec.repair[4] = savegame.xmlFile:getValue(keyrepair .. "#finishhour", 0)
	spec.repair[5] = savegame.xmlFile:getValue(keyrepair .. "#finishminute", 0)
	spec.repair[6] = savegame.xmlFile:getValue(keyrepair .. "#amount", 0)
	spec.repair[7] = savegame.xmlFile:getValue(keyrepair .. "#cost", 0)
	spec.repair[8] = savegame.xmlFile:getValue(keyrepair .. "#damage", 0)
	spec.repair[9] = savegame.xmlFile:getValue(keyrepair .. "#factor", 0)
	spec.repair[10] = savegame.xmlFile:getValue(keyrepair .. "#inspection", false)
	
	local keyinspection = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns.vehicleInspection")
	spec.inspection[1] = savegame.xmlFile:getValue(keyinspection .. "#state", false)
	spec.inspection[2] = savegame.xmlFile:getValue(keyinspection .. "#suspension", false)
	spec.inspection[3] = savegame.xmlFile:getValue(keyinspection .. "#finishday", 0)
	spec.inspection[4] = savegame.xmlFile:getValue(keyinspection .. "#finishhour", 0)
	spec.inspection[5] = savegame.xmlFile:getValue(keyinspection .. "#finishminute", 0)
	spec.inspection[6] = savegame.xmlFile:getValue(keyinspection .. "#cost", 0)
	spec.inspection[7] = savegame.xmlFile:getValue(keyinspection .. "#factor", 0)
	spec.inspection[8] = savegame.xmlFile:getValue(keyinspection .. "#inspection", false)

	local keybattery = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns.vehicleBattery")
	spec.battery[1] = savegame.xmlFile:getValue(keybattery .. "#state", false)
	spec.battery[2] = savegame.xmlFile:getValue(keybattery .. "#suspension", false)
	spec.battery[3] = savegame.xmlFile:getValue(keybattery .. "#finishday", 0)
	spec.battery[4] = savegame.xmlFile:getValue(keybattery .. "#finishhour", 0)
	spec.battery[5] = savegame.xmlFile:getValue(keybattery .. "#finishminute", 0)
	spec.battery[6] = savegame.xmlFile:getValue(keybattery .. "#amount", 0)
	spec.battery[7] = savegame.xmlFile:getValue(keybattery .. "#cost", 0)

	local GSET = g_currentMission.vehicleBreakdowns.generalSettings
	local keyparts = string.format("%s.%s.%s", savegame.key, g_vehicleBreakdownsModName, "vehicleBreakdowns")
	
	for i=1, #spec.parts do
		local keyss = string.format("%s.parts.part(%d)", keyparts, i)
		spec.parts[i].name = savegame.xmlFile:getValue(keyss .. "#name", spec.parts[i].name)
		spec.parts[i].lifetime = savegame.xmlFile:getValue(keyss .. "#lifetime", spec.parts[i].lifetime)
		if GSET.difficulty == 1 then
			spec.parts[i].tmp_lifetime = spec.parts[i].lifetime * 2 * g_currentMission.environment.plannedDaysPerPeriod
		elseif GSET.difficulty == 2 then
			spec.parts[i].tmp_lifetime = spec.parts[i].lifetime * 1 * g_currentMission.environment.plannedDaysPerPeriod
		else
			spec.parts[i].tmp_lifetime = spec.parts[i].lifetime / 2 * g_currentMission.environment.plannedDaysPerPeriod
		end
		spec.parts[i].operatingHours = savegame.xmlFile:getValue(keyss .. "#operatingHours", spec.parts[i].operatingHours)
		spec.parts[i].repairreq = savegame.xmlFile:getValue(keyss .. "#repairreq", spec.parts[i].repairreq)
		spec.parts[i].amount = savegame.xmlFile:getValue(keyss .. "#amount", spec.parts[i].amount)
		spec.parts[i].cost = savegame.xmlFile:getValue(keyss .. "#cost", spec.parts[i].cost)
	end


	local i = 0
	local xmlFile = savegame.xmlFile
	while true do
		local key = string.format("%s.fillUnit.unit(%d)", savegame.key, i)
		if not xmlFile:hasProperty(key) then
			break
		end

		local fillTypeName = xmlFile:getValue(key.."#fillType")
		if fillTypeName == "ELECTRICCHARGE" then
			local fillUnitIndex = xmlFile:getValue(key.."#index")
			local fillLevel = xmlFile:getValue(key.."#fillLevel", 100)
			self.spec_fillUnit.fillUnits[fillUnitIndex].fillLevel = fillLevel
			spec.RVB_BatteryFillLevel = fillLevel
			--self:raiseDirtyFlags(spec.dirtyFlag)
		end	

		i = i + 1
	end

	if self.isServer then
		--self:raiseDirtyFlags(spec.dirtyFlag)
	elseif self.isClient then
		spec.rvb = { unpack(spec.rvb) }
		spec.faultStorage = { unpack(spec.faultStorage) }
		spec.parts = { unpack(spec.parts) }
		spec.service = { unpack(spec.service) }
		spec.repair = { unpack(spec.repair) }
		spec.inspection = { unpack(spec.inspection) }
		spec.battery = { unpack(spec.battery) }
	end

end

function VehicleBreakdowns.SyncClientServer_Other(vehicle, batteryCHActive)
	local spec = vehicle.spec_faultData
	spec.batteryCHActive = batteryCHActive
end

function VehicleBreakdowns.SyncClientServer_RVB(vehicle, b1, b2, b3, b4, b5)
	local spec = vehicle.spec_faultData
	spec.rvb = spec.rvb or {}
	spec.rvb[1] = b1
    spec.rvb[2] = b2
	spec.rvb[3] = b3
	spec.rvb[4] = b4
	spec.rvb[5] = b5
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
	if vehicle:getIsSynchronized() then
    end
end

function VehicleBreakdowns.SyncClientServer_RVBFaultStorage(vehicle, b1, b2)
	local spec = vehicle.spec_faultData
	spec.faultStorage = spec.faultStorage or {}
	spec.faultStorage[1] = b1
    spec.faultStorage[2] = b2
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
	if vehicle:getIsSynchronized() then
    end
end

function VehicleBreakdowns.SyncClientServer_RVBService(vehicle, b1, b2, b3, b4, b5, b6, b7, b8)
	local spec = vehicle.spec_faultData
	spec.service = spec.service or {}
	spec.service[1] = b1
    spec.service[2] = b2
	spec.service[3] = b3
	spec.service[4] = b4
	spec.service[5] = b5
	spec.service[6] = b6
	spec.service[7] = b7
	spec.service[8] = b8
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
	if vehicle:getIsSynchronized() then
    end
end

function VehicleBreakdowns.SyncClientServer_RVBRepair(vehicle, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10)
	local spec = vehicle.spec_faultData
	spec.repair = spec.repair or {}
	spec.repair[1] = b1
    spec.repair[2] = b2
	spec.repair[3] = b3
	spec.repair[4] = b4
	spec.repair[5] = b5
	spec.repair[6] = b6
	spec.repair[7] = b7
	spec.repair[8] = b8
	spec.repair[9] = b9
	spec.repair[10] = b10
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
	if vehicle:getIsSynchronized() then
    end
end

function VehicleBreakdowns.SyncClientServer_RVBInspection(vehicle, b1, b2, b3, b4, b5, b6, b7, b8)
	local spec = vehicle.spec_faultData
	spec.inspection = spec.inspection or {}
	spec.inspection[1] = b1
    spec.inspection[2] = b2
	spec.inspection[3] = b3
	spec.inspection[4] = b4
	spec.inspection[5] = b5
	spec.inspection[6] = b6
	spec.inspection[7] = b7
	spec.inspection[8] = b8
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
	if vehicle:getIsSynchronized() then
    end
end

function VehicleBreakdowns.SyncClientServer_RVBBattery(vehicle, b1, b2, b3, b4, b5, b6, b7)
    local spec = vehicle.spec_faultData
    spec.battery = spec.battery or {}
    spec.battery[1] = b1
    spec.battery[2] = b2
    spec.battery[3] = b3
    spec.battery[4] = b4
    spec.battery[5] = b5
    spec.battery[6] = b6
    spec.battery[7] = b7
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
    if vehicle:getIsSynchronized() then
    end
end


function VehicleBreakdowns.SyncClientServer_RVBParts(vehicle, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12)
	local spec = vehicle.spec_faultData
	spec.parts = spec.parts or {}
	spec.parts[1] = b1
    spec.parts[2] = b2
	spec.parts[3] = b3
	spec.parts[4] = b4
	spec.parts[5] = b5
	spec.parts[6] = b6
	spec.parts[7] = b7
	spec.parts[8] = b8
	spec.parts[9] = b9
	spec.parts[10] = b10
	spec.parts[11] = b11
	spec.parts[12] = b12
	vehicle:raiseDirtyFlags(spec.dirtyFlag)
	if vehicle:getIsSynchronized() then
    end
end

function VehicleBreakdowns.SyncClientServer_BatteryChargeLevel(vehicle, level)
	local spec = vehicle.spec_faultData
	spec.RVB_BatteryFillLevel = level
end

function VehicleBreakdowns:onReadStream(streamId, connection)
	
	if self.spec_faultData == nil then
        return
    end

	local spec = self.spec_faultData
	
	spec.rvb = {
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId)
    }

	spec.faultStorage = {
        streamReadBool(streamId),
        streamReadBool(streamId)
    }

	spec.service = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId)
    }
	
	spec.repair = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadBool(streamId)
    }
	
	spec.inspection = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadBool(streamId)
    }
	
	spec.battery = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId)
    }
	
	for i = 1, #spec.parts do
        spec.parts[i] = {
            name = streamReadString(streamId),
            lifetime = streamReadInt16(streamId),
            tmp_lifetime = streamReadInt16(streamId),
            operatingHours = streamReadFloat32(streamId),
            repairreq = streamReadBool(streamId),
            amount = streamReadFloat32(streamId),
            cost = streamReadFloat32(streamId)
        }
    end
	
	spec.motorTemperature = streamReadFloat32(streamId)
	spec.fanEnabled = streamReadBool(streamId)
	
	spec.fanEnableTemperature = streamReadFloat32(streamId)
	spec.fanDisableTemperature = streamReadFloat32(streamId)
	spec.lastFuelUsage = streamReadFloat32(streamId)
	spec.lastDefUsage = streamReadFloat32(streamId)
	spec.lastAirUsage = streamReadFloat32(streamId)
		
	spec.RVB_BatteryFillLevel = streamReadFloat32(streamId)
	spec.batteryFillUnitIndex = streamReadInt16(streamId)
	spec.batteryCHActive = streamReadBool(streamId)
	
	VehicleBreakdowns.FSSET_Daysperiod = streamReadInt16(streamId)
	VehicleBreakdowns.GSET_Change_difficulty = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_thermostat = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_lightings = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_glowplug = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_wipers = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_generator = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_engine = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_selfstarter = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_battery = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_tire = streamReadInt16(streamId)
	
	local lights_request_A = streamReadBool(streamId)
	local lights_request_B = streamReadBool(streamId)
    self:setRVBLightsStrings(lights_request_A, lights_request_B, true, true)
	
	local lightsTypesMask = streamReadInt16(streamId)
	self:setRVBLightsTypesMask(lightsTypesMask, true, true)

	local isRVBMotorStarted = streamReadBool(streamId)
    if isRVBMotorStarted then
        self:startMotor(true)
    else
        self:stopMotor(true)
    end

end

function VehicleBreakdowns:onWriteStream(streamId, connection)
	
	if self.spec_faultData == nil then
		return
	end
		
	local spec = self.spec_faultData
	
	streamWriteInt16(streamId, spec.rvb[1])
	streamWriteFloat32(streamId, spec.rvb[2])
	streamWriteFloat32(streamId, spec.rvb[3])
	
	streamWriteFloat32(streamId, spec.rvb[4])
	streamWriteFloat32(streamId, spec.rvb[5])
	
	for index=1, 2 do
		streamWriteBool(streamId, spec.faultStorage[index])
	end
	
	streamWriteBool(streamId, spec.service[1])
	streamWriteBool(streamId, spec.service[2])
	streamWriteInt16(streamId, spec.service[3])
	streamWriteInt16(streamId, spec.service[4])
	streamWriteInt16(streamId, spec.service[5])
	streamWriteFloat32(streamId, spec.service[6])
	streamWriteFloat32(streamId, spec.service[7])
	streamWriteFloat32(streamId, spec.service[8])

	streamWriteBool(streamId, spec.repair[1])
	streamWriteBool(streamId, spec.repair[2])
	streamWriteInt16(streamId, spec.repair[3])
	streamWriteInt16(streamId, spec.repair[4])
	streamWriteInt16(streamId, spec.repair[5])
	streamWriteFloat32(streamId, spec.repair[6])
	streamWriteFloat32(streamId, spec.repair[7])
	streamWriteFloat32(streamId, spec.repair[8])
	streamWriteFloat32(streamId, spec.repair[9])
	streamWriteBool(streamId, spec.repair[10])
	
	streamWriteBool(streamId, spec.inspection[1])
	streamWriteBool(streamId, spec.inspection[2])
	streamWriteInt16(streamId, spec.inspection[3])
	streamWriteInt16(streamId, spec.inspection[4])
	streamWriteInt16(streamId, spec.inspection[5])
	streamWriteFloat32(streamId, spec.inspection[6])
	streamWriteFloat32(streamId, spec.inspection[7])
	streamWriteBool(streamId, spec.inspection[8])

	streamWriteBool(streamId, spec.battery[1])
	streamWriteBool(streamId, spec.battery[2])
	streamWriteInt16(streamId, spec.battery[3])
	streamWriteInt16(streamId, spec.battery[4])
	streamWriteInt16(streamId, spec.battery[5])
	streamWriteFloat32(streamId, spec.battery[6])
	streamWriteFloat32(streamId, spec.battery[7])

	for i=1, #spec.parts do
		streamWriteString(streamId, spec.parts[i].name)
		streamWriteInt16(streamId, spec.parts[i].lifetime)
		streamWriteInt16(streamId, spec.parts[i].tmp_lifetime)
		streamWriteFloat32(streamId, spec.parts[i].operatingHours)
		streamWriteBool(streamId, spec.parts[i].repairreq)
		streamWriteFloat32(streamId, spec.parts[i].amount)
		streamWriteFloat32(streamId, spec.parts[i].cost)
		streamWriteBool(streamId, spec.parts[i].damaged)
	end
	
	streamWriteFloat32(streamId, spec.motorTemperature)
	streamWriteBool(streamId, spec.fanEnabled)
	streamWriteFloat32(streamId, spec.fanEnableTemperature)
	streamWriteFloat32(streamId, spec.fanDisableTemperature)
	streamWriteFloat32(streamId, spec.lastFuelUsage)
	streamWriteFloat32(streamId, spec.lastDefUsage)
	streamWriteFloat32(streamId, spec.lastAirUsage)

	streamWriteFloat32(streamId, spec.RVB_BatteryFillLevel)
	streamWriteInt16(streamId, spec.batteryFillUnitIndex)
	streamWriteBool(streamId, spec.batteryCHActive)
	
	streamWriteInt16(streamId, VehicleBreakdowns.FSSET_Daysperiod)
	streamWriteInt16(streamId, VehicleBreakdowns.GSET_Change_difficulty)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_thermostat)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_lightings)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_glowplug)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_wipers)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_generator)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_engine)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_selfstarter)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_battery)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_tire)
	
	streamWriteBool(streamId, spec.lights_request_A)
	streamWriteBool(streamId, spec.lights_request_B)
	
	streamWriteInt16(streamId, spec.rvblightsTypesMask)

	streamWriteBool(streamId, spec.isRVBMotorStarted)
	
end

function VehicleBreakdowns:onReadUpdateStream(streamId, timestamp, connection)

	if connection.isServer then

		local spec = self.spec_faultData
		
			if streamReadBool(streamId) then
		

			spec.rvb = {
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId)
    }

	spec.faultStorage = {
        streamReadBool(streamId),
        streamReadBool(streamId)
    }

	spec.service = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId)
    }
	
	spec.repair = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadBool(streamId)
    }
	
	spec.inspection = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId),
        streamReadBool(streamId)
    }
	
	spec.battery = {
        streamReadBool(streamId),
        streamReadBool(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadInt16(streamId),
        streamReadFloat32(streamId),
        streamReadFloat32(streamId)
    }
	
	for i = 1, #spec.parts do
        spec.parts[i] = {
            name = streamReadString(streamId),
            lifetime = streamReadInt16(streamId),
            tmp_lifetime = streamReadInt16(streamId),
            operatingHours = streamReadFloat32(streamId),
            repairreq = streamReadBool(streamId),
            amount = streamReadFloat32(streamId),
            cost = streamReadFloat32(streamId)
        }

    end


			spec.motorTemperature = streamReadFloat32(streamId)
			spec.fanEnabled = streamReadBool(streamId)
			spec.fanEnableTemperature = streamReadFloat32(streamId)
			spec.fanDisableTemperature = streamReadFloat32(streamId)
			spec.lastFuelUsage = streamReadFloat32(streamId)
			spec.lastDefUsage = streamReadFloat32(streamId)
			spec.lastAirUsage = streamReadFloat32(streamId)
			
			spec.RVB_BatteryFillLevel = streamReadFloat32(streamId)
			spec.batteryFillUnitIndex = streamReadInt16(streamId)
			spec.batteryCHActive = streamReadBool(streamId)

	--[[
	VehicleBreakdowns.FSSET_Daysperiod = streamReadInt16(streamId)
	VehicleBreakdowns.GSET_Change_difficulty = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_thermostat = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_lightings = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_glowplug = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_wipers = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_generator = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_engine = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_selfstarter = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_battery = streamReadInt16(streamId)
	VehicleBreakdowns.GPSET_Change_tire = streamReadInt16(streamId)
	
	local lights_request_A = streamReadBool(streamId)
	local lights_request_B = streamReadBool(streamId)
    self:setRVBLightsStrings(lights_request_A, lights_request_B, true, true)
	
	local lightsTypesMask = streamReadInt16(streamId)
	self:setRVBLightsTypesMask(lightsTypesMask, true, true)
]]

end
	end
end

function VehicleBreakdowns:onWriteUpdateStream(streamId, connection, dirtyMask)
	if not connection.isServer then

		local spec = self.spec_faultData
		if streamWriteBool(streamId, bitAND(dirtyMask, spec.dirtyFlag) ~= 0) then
			streamWriteInt16(streamId, spec.rvb[1])
			streamWriteFloat32(streamId, spec.rvb[2])
			streamWriteFloat32(streamId, spec.rvb[3])
			
			streamWriteFloat32(streamId, spec.rvb[4])
			streamWriteFloat32(streamId, spec.rvb[5])
	
			for index=1, 2 do
				streamWriteBool(streamId, spec.faultStorage[index])
			end
	
			streamWriteBool(streamId, spec.service[1])
			streamWriteBool(streamId, spec.service[2])
			streamWriteInt16(streamId, spec.service[3])
			streamWriteInt16(streamId, spec.service[4])
			streamWriteInt16(streamId, spec.service[5])
			streamWriteFloat32(streamId, spec.service[6])
			streamWriteFloat32(streamId, spec.service[7])
			streamWriteFloat32(streamId, spec.service[8])

			streamWriteBool(streamId, spec.repair[1])
			streamWriteBool(streamId, spec.repair[2])
			streamWriteInt16(streamId, spec.repair[3])
			streamWriteInt16(streamId, spec.repair[4])
			streamWriteInt16(streamId, spec.repair[5])
			streamWriteFloat32(streamId, spec.repair[6])
			streamWriteFloat32(streamId, spec.repair[7])
			streamWriteFloat32(streamId, spec.repair[8])
			streamWriteFloat32(streamId, spec.repair[9])
			streamWriteBool(streamId, spec.repair[10])
			
			streamWriteBool(streamId, spec.inspection[1])
			streamWriteBool(streamId, spec.inspection[2])
			streamWriteInt16(streamId, spec.inspection[3])
			streamWriteInt16(streamId, spec.inspection[4])
			streamWriteInt16(streamId, spec.inspection[5])
			streamWriteFloat32(streamId, spec.inspection[6])
			streamWriteFloat32(streamId, spec.inspection[7])
			streamWriteBool(streamId, spec.inspection[8])

			streamWriteBool(streamId, spec.battery[1])
			streamWriteBool(streamId, spec.battery[2])
			streamWriteInt16(streamId, spec.battery[3])
			streamWriteInt16(streamId, spec.battery[4])
			streamWriteInt16(streamId, spec.battery[5])
			streamWriteFloat32(streamId, spec.battery[6])
			streamWriteFloat32(streamId, spec.battery[7])
			
			for i=1, #spec.parts do
				streamWriteString(streamId, spec.parts[i].name)
				streamWriteInt16(streamId, spec.parts[i].lifetime)
				streamWriteInt16(streamId, spec.parts[i].tmp_lifetime)
				streamWriteFloat32(streamId, spec.parts[i].operatingHours)
				streamWriteBool(streamId, spec.parts[i].repairreq)
				streamWriteFloat32(streamId, spec.parts[i].amount)
				streamWriteFloat32(streamId, spec.parts[i].cost)
				streamWriteBool(streamId, spec.parts[i].damaged)
			end

			streamWriteFloat32(streamId, spec.motorTemperature)
			streamWriteBool(streamId, spec.fanEnabled)
			streamWriteFloat32(streamId, spec.fanEnableTemperature)
			streamWriteFloat32(streamId, spec.fanDisableTemperature)
			streamWriteFloat32(streamId, spec.lastFuelUsage)
			streamWriteFloat32(streamId, spec.lastDefUsage)
			streamWriteFloat32(streamId, spec.lastAirUsage)
			self.spec_motorized.motorTemperature.valueSend = spec.motorTemperature
			
			self.spec_motorized.motorFan.enabled = spec.fanEnabled
			self.spec_motorized.motorFan.enableTemperature = spec.fanEnableTemperature
			self.spec_motorized.motorFan.disableTemperature = spec.fanDisableTemperature
			
			streamWriteFloat32(streamId, spec.RVB_BatteryFillLevel)
			streamWriteInt16(streamId, spec.batteryFillUnitIndex)
			streamWriteBool(streamId, spec.batteryCHActive)
			
	--[[		
				streamWriteInt16(streamId, VehicleBreakdowns.FSSET_Daysperiod)
	streamWriteInt16(streamId, VehicleBreakdowns.GSET_Change_difficulty)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_thermostat)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_lightings)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_glowplug)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_wipers)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_generator)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_engine)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_selfstarter)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_battery)
	streamWriteInt16(streamId, VehicleBreakdowns.GPSET_Change_tire)
	
	streamWriteBool(streamId, spec.lights_request_A)
	streamWriteBool(streamId, spec.lights_request_B)
	
	streamWriteInt16(streamId, spec.rvblightsTypesMask)
]]

	
		end
	end
	if not connection.isServer then
		local spec = self.spec_faultData
        if streamWriteBool(streamId, spec.isRVBMotorStarted) then

		end
	end
end


function VehicleBreakdowns:saveToXMLFile(xmlFile, key, usedModNames)
	local spec = self.spec_faultData
	
	xmlFile:setValue(key .. "#timeScale", spec.rvb[1])
	xmlFile:setValue(key .. "#operatingHoursTemp", self:getIsOperatingHoursTemp() / 1000)
	xmlFile:setValue(key .. "#TotaloperatingHours", spec.rvb[3])
	
	xmlFile:setValue(key .. "#operatingHours", spec.rvb[4])
	xmlFile:setValue(key .. "#chargelevel", self:getIsFaultBattery())
	
    xmlFile:setValue(key .. ".faultStorage#thermostatoverHeating", self:getIsFaultThermostatoverHeating())
	xmlFile:setValue(key .. ".faultStorage#thermostatoverCooling", self:getIsFaultThermostatoverCooling())
	
	xmlFile:setValue(key .. ".vehicleService#state", spec.service[1])
	xmlFile:setValue(key .. ".vehicleService#suspension", spec.service[2])
	xmlFile:setValue(key .. ".vehicleService#finishday", spec.service[3])
	xmlFile:setValue(key .. ".vehicleService#finishhour", spec.service[4])
	xmlFile:setValue(key .. ".vehicleService#finishminute", spec.service[5])
	xmlFile:setValue(key .. ".vehicleService#amount", spec.service[6])
	xmlFile:setValue(key .. ".vehicleService#cost", spec.service[7])
	xmlFile:setValue(key .. ".vehicleService#damage", spec.service[8])
		
	xmlFile:setValue(key .. ".vehicleRepair#state", spec.repair[1])
	xmlFile:setValue(key .. ".vehicleRepair#suspension", spec.repair[2])
	xmlFile:setValue(key .. ".vehicleRepair#finishday", spec.repair[3])
	xmlFile:setValue(key .. ".vehicleRepair#finishhour", spec.repair[4])
	xmlFile:setValue(key .. ".vehicleRepair#finishminute", spec.repair[5])
	xmlFile:setValue(key .. ".vehicleRepair#amount", spec.repair[6])
	xmlFile:setValue(key .. ".vehicleRepair#cost", spec.repair[7])
	xmlFile:setValue(key .. ".vehicleRepair#damage", spec.repair[8])
	xmlFile:setValue(key .. ".vehicleRepair#factor", spec.repair[9])
	xmlFile:setValue(key .. ".vehicleRepair#inspection", spec.repair[10])
	
	xmlFile:setValue(key .. ".vehicleInspection#state", spec.inspection[1])
	xmlFile:setValue(key .. ".vehicleInspection#suspension", spec.inspection[2])
	xmlFile:setValue(key .. ".vehicleInspection#finishday", spec.inspection[3])
	xmlFile:setValue(key .. ".vehicleInspection#finishhour", spec.inspection[4])
	xmlFile:setValue(key .. ".vehicleInspection#finishminute", spec.inspection[5])
	xmlFile:setValue(key .. ".vehicleInspection#cost", spec.inspection[6])
	xmlFile:setValue(key .. ".vehicleInspection#factor", spec.inspection[7])
	xmlFile:setValue(key .. ".vehicleInspection#inspection", spec.inspection[8])
	
	xmlFile:setValue(key .. ".vehicleBattery#state", spec.battery[1])
	xmlFile:setValue(key .. ".vehicleBattery#suspension", spec.battery[2])
	xmlFile:setValue(key .. ".vehicleBattery#finishday", spec.battery[3])
	xmlFile:setValue(key .. ".vehicleBattery#finishhour", spec.battery[4])
	xmlFile:setValue(key .. ".vehicleBattery#finishminute", spec.battery[5])
	xmlFile:setValue(key .. ".vehicleBattery#amount", spec.battery[6])
	xmlFile:setValue(key .. ".vehicleBattery#cost", spec.battery[7])


	for i=1, #spec.parts do
		if spec.parts[i].name ~= nil and spec.parts[i].name ~= "" then
			local keyss = string.format("%s.parts.part(%d)", key, i)
			xmlFile:setValue(keyss.."#name", spec.parts[i].name)
			xmlFile:setValue(keyss.."#lifetime", spec.parts[i].lifetime)
			xmlFile:setValue(keyss.."#operatingHours", spec.parts[i].operatingHours)
			xmlFile:setValue(keyss.."#repairreq", spec.parts[i].repairreq)
			xmlFile:setValue(keyss.."#amount", spec.parts[i].amount)
			xmlFile:setValue(keyss.."#cost", spec.parts[i].cost)
		end
	end
	
end

function VehicleBreakdowns.onRegisterActionEvents(self, isActiveForInput, isActiveForInputIgnoreSelection)

	local rvbs = self.spec_faultData
	
	if self.isClient then

		if self.getIsEntered ~= nil and self:getIsEntered() then
		
			local spec = self.spec_lights

			self:clearActionEventsTable(spec.actionEvents)

			local rvbToggleLights = Lights.actionEventToggleLights
			local rvbToggleLightsBack = Lights.actionEventToggleLightsBack
			local rvbToggleLightFront = Lights.actionEventToggleLightFront
			local rvbToggleWorkLightBack = Lights.actionEventToggleWorkLightBack
			local rvbToggleWorkLightFront = Lights.actionEventToggleWorkLightFront
			local rvbToggleHighBeamLight = Lights.actionEventToggleHighBeamLight
			
			local rvbToggleBeaconLights = Lights.actionEventToggleBeaconLights
			local rvbToggleTurnLightHazard = Lights.actionEventToggleTurnLightHazard
			local rvbToggleTurnLightLeft = Lights.actionEventToggleTurnLightLeft
			local rvbToggleTurnLightRight = Lights.actionEventToggleTurnLightRight
			
			if self:getIsFaultLightings() or self:getIsFaultBattery() ~= 0 and self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.LIGHTS then
				rvbToggleLights = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleLightsBack = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleLightFront = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleWorkLightBack = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleWorkLightFront = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleHighBeamLight = VehicleBreakdowns.actionToggleLightsFault
			end
			
			if self:getIsFaultLightings() or self:getIsFaultBattery() ~= 0 and self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS then
				rvbToggleBeaconLights = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleTurnLightHazard = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleTurnLightLeft = VehicleBreakdowns.actionToggleLightsFault
				rvbToggleTurnLightRight = VehicleBreakdowns.actionToggleLightsFault
			end

			if isActiveForInputIgnoreSelection then


				local set, actionEventIdSet = self:addActionEvent(spec.actionEvents, InputAction.VEHICLE_BREAKDOWN_MENU, self, VehicleBreakdowns.RVBMenu, true, true, false, true, nil)
				if set then
					g_inputBinding:setActionEventTextPriority(actionEventIdSet, GS_PRIO_VERY_LOW)
					g_inputBinding:setActionEventTextVisibility(actionEventIdSet, true)
					g_inputBinding:setActionEventActive(actionEventIdSet, true)
				end
					
					
				local _
					_, spec.actionEventIdLight = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_LIGHTS, self, rvbToggleLights, false, true, false, true, nil)
				local _, actionEventIdReverse = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_LIGHTS_BACK, self, rvbToggleLightsBack, false, true, false, true, nil)
				local _, actionEventIdFront = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_LIGHT_FRONT, self, rvbToggleLightFront, false, true, false, true, nil)
				local _, actionEventIdWorkBack = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_WORK_LIGHT_BACK, self, rvbToggleWorkLightBack, false, true, false, true, nil)
				local _, actionEventIdWorkFront = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_WORK_LIGHT_FRONT, self, rvbToggleWorkLightFront, false, true, false, true, nil)
				local _, actionEventIdHighBeam = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_HIGH_BEAM_LIGHT, self, rvbToggleHighBeamLight, false, true, false, true, nil)

				self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_TURNLIGHT_HAZARD, self, rvbToggleTurnLightHazard, false, true, false, true, nil)
				self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_TURNLIGHT_LEFT, self, rvbToggleTurnLightLeft, false, true, false, true, nil)
				self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_TURNLIGHT_RIGHT, self, rvbToggleTurnLightRight, false, true, false, true, nil)
				local _, actionEventIdBeacon = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_BEACON_LIGHTS, self, rvbToggleBeaconLights, false, true, false, true, nil)

				-- action events that are only active if getIsActiveForLights
				spec.actionEventsActiveChange = {actionEventIdFront, actionEventIdWorkBack, actionEventIdWorkFront, actionEventIdHighBeam, actionEventIdBeacon}

				for _,actionEvent in pairs(spec.actionEvents) do
					if actionEvent.actionEventId ~= nil then
						g_inputBinding:setActionEventTextVisibility(actionEvent.actionEventId, false)
						g_inputBinding:setActionEventTextPriority(actionEvent.actionEventId, GS_PRIO_LOW)
					end
				end

				if g_beaconLightManager:getNumOfLights() > 0 and getPlatformId() == PlatformId.PS4 then
					g_inputBinding:setActionEventTextPriority(actionEventIdBeacon, GS_PRIO_VERY_LOW)
					g_inputBinding:setActionEventTextVisibility(actionEventIdBeacon, true)
				end

				g_inputBinding:setActionEventTextVisibility(spec.actionEventIdLight, not g_currentMission.environment.isSunOn)
				g_inputBinding:setActionEventTextVisibility(actionEventIdReverse, false)

			end

		end

	end

end

function VehicleBreakdowns:RVBMenu()
	if not self.isClient then
      return
    end

    if not g_currentMission.isSynchronizingWithPlayers then
      if not g_gui:getIsGuiVisible() then
        --VehicleBreakdowns.ui_menu:setVehicle(self)
        g_gui:showDialog("RVBMenu")
      end
    end
end


function VehicleBreakdowns:actionToggleLightsFault()

	local spec = self.spec_faultData

	if self:getIsFaultLightings() or self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.LIGHTS then

		local GSET = g_currentMission.vehicleBreakdowns.generalSettings

		if GSET.alertmessage then
			if self.getIsEntered ~= nil and self:getIsEntered() then
				g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_fault_lights"), 2500)
			else
			--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("RVB_fault_lights_hud"), self:getFullName()), 5000)
			end
		end

	end
	
	if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS then

		local GSET = g_currentMission.vehicleBreakdowns.generalSettings

		if GSET.alertmessage then
			if self.getIsEntered ~= nil and self:getIsEntered() then
				g_currentMission:showBlinkingWarning(g_i18n:getText("RVB_fault_BHlights"), 2500)
			else
			--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("RVB_fault_BHlights_hud"), self:getFullName()), 5000)
			end
		end

	end

end

function VehicleBreakdowns:lightingsFault()

	local spec = self.spec_faultData

	if self:getIsFaultLightings() or self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.LIGHTS then
		self:setLightsTypesMask(0, true, true)
	end
	
	if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS then
		self:setBeaconLightsVisibility(false, true, true)
		self:setTurnLightState(Lights.TURNLIGHT_OFF, true, true)
	end

end

function VehicleBreakdowns:StopAI(self)
    local rootVehicle = self.rootVehicle
    if rootVehicle ~= nil and rootVehicle:getIsAIActive() then
        rootVehicle:stopCurrentAIJob(AIMessageErrorVehicleBroken.new())
    end
end

function VehicleBreakdowns:inRangeOfchargingStation(chargingStation, vehicle, vehicleFarm)

	for rootNode, _ in pairs(chargingStation) do
		if rootNode ~= nil then
			local distanceToStation = calcDistanceFrom(vehicle, rootNode)
			if distanceToStation <= 6 then
				return true
			end
		end
	end

end

function VehicleBreakdowns:updatePartsLifetime(partsName, partsLifetime)
	local GSET = g_currentMission.vehicleBreakdowns.generalSettings
	for _, vehicle in ipairs(g_currentMission.vehicleSystem.vehicles) do
		if vehicle.spec_faultData ~= nil then
			for i=1, #vehicle.spec_faultData.parts do
				if string.match(vehicle.spec_faultData.parts[i].name, partsName) then
					vehicle.spec_faultData.parts[i].lifetime = partsLifetime
					if GSET.difficulty == 1 then
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime * 2 * g_currentMission.environment.plannedDaysPerPeriod
					elseif GSET.difficulty == 2 then
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime * 1 * g_currentMission.environment.plannedDaysPerPeriod
					else
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime / 2 * g_currentMission.environment.plannedDaysPerPeriod
					end
				end
			end
			RVBParts_Event.sendEvent(vehicle, unpack(vehicle.spec_faultData.parts))
			--vehicle:raiseDirtyFlags(vehicle.spec_faultData.dirtyFlag)
		end
	end
end

--[[
Növelje az ablaktörlő üzemidejét
Amikor a motor jár
Ha az ablaktörlő működik és esik az eső
Increase wiper operating hours
When the engine is running
If the wiper is working and it is raining
]]
function VehicleBreakdowns:setWiperOperatingHours(dt)
	local spec = self.spec_faultData
	local lastRainScale = g_currentMission.environment.weather:getRainFallScale()
	if self:getIsActiveForWipers() and lastRainScale > 0.01 then
		local oneGameMinute = 1000 * 60 * 60
		local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
		local increase = runtimeIncrease
		if increase ~= 0 then
			spec.wiperRuntimeToChange = spec.wiperRuntimeToChange + increase
			local wiperRuntimeToChange = spec.wiperRuntimeToChange
			if math.abs(wiperRuntimeToChange) > 0.016666 then
				increase = spec.wiperRuntimeToChange
				spec.wiperRuntimeToChange = 0
				spec.parts[4].operatingHours = spec.parts[4].operatingHours + increase
				RVBParts_Event.sendEvent(self, unpack(spec.parts))
				self:raiseDirtyFlags(spec.dirtyFlag)
			end
		end
	end
end
--[[
	Növelje a világítás üzemidejét
	Amikor ég a lámpa
	A világítás működik
	Az akkumulátor működik és a töltési szint megfelelő
	Increase the operating hours of the lighting
	When the light is on
	Lighting is working
	The battery is working and the charge level is adequate
]]
function VehicleBreakdowns:setLightingsOperatingHours(dt)
	local spec = self.spec_faultData
	if spec.rvblightsTypesMask > 0 and not spec.parts[2].repairreq and not spec.parts[8].repairreq and self:getIsFaultBattery() >= VehicleBreakdowns.SET.BatteryLevel.LIGHTS then
		local oneGameMinute = 1000 * 60 * 60
		local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
		local increase = runtimeIncrease
		if increase ~= 0 then
			spec.lightingsRuntimeToChange = spec.lightingsRuntimeToChange + increase
			local lightingsRuntimeToChange = spec.lightingsRuntimeToChange
			if math.abs(lightingsRuntimeToChange) > 0.016666 then
				increase = spec.lightingsRuntimeToChange
				spec.lightingsRuntimeToChange = 0
				spec.parts[2].operatingHours = spec.parts[2].operatingHours + increase
				if spec.parts[2].operatingHours > spec.parts[2].tmp_lifetime then
					spec.parts[2].operatingHours = spec.parts[2].tmp_lifetime
				end
				RVBParts_Event.sendEvent(self, unpack(spec.parts))
				self:raiseDirtyFlags(spec.dirtyFlag)
			end
        end
	end
end

function VehicleBreakdowns:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)

	local spec = self.spec_faultData
	local motorized = self.spec_motorized




	if not self:getIsEntered() then
		self:raiseActive()
	end

	g_currentMission.vehicleBreakdowns.rvbHud:update(self, dt)
	
	--self:setVehicleRepair(dt)
	self:updateRepair(dt)
	self:setVehicleService(dt)
	
	-- isActiveForInputIgnoreSelection
	local motorState = self:getMotorState()

	--if motorState == MotorState.ON then
	if self:getIsMotorStarted() then
	-- FS22 if motorized.isMotorStarted then
	
		self:onStartOperatingHours(dt)
		self:setDamageService(dt)
		
		--self:setGeneratorBatteryCharging(dt)
		self:chargeBatteryFromGenerator(dt)
		
		self:setVehicleDamageThermostatoverHeatingFailure(dt)
		--ha a generator meghibasodik lemerul az akkumulator
		--self:setBatteryDrainingIfGeneratorFailure(dt)
 
		self:setWiperOperatingHours(dt)
		self:updateRepairNeeds(dt)
		

	else

		self:setBatteryDrain(dt)

	
		--[[
			Motor hűtőfolyadék hőmérséklet csökkentése
			Ha a motor nem jár
			Ha a motor hőmérséklete nagyobb, mint az aktuális időjárási hőmérséklet
			Minden percben 0.35 fokkal csökken
		]]
		if self.spec_motorized.motorTemperature.value > self.currentTemperaturDay then
			local currentTemperaturInC = g_currentMission.environment.weather:getCurrentTemperature()
			local coolingRatePerMinute = (currentTemperaturInC < 0) and 0.55 or 0.35

			local coolingRatePerSecond = coolingRatePerMinute / 60  -- fok/másodperc

			-- Csökkentjük a hőmérsékletet a dt és a g_currentMission.missionInfo.timeScale figyelembevételével
			self.spec_motorized.motorTemperature.value = self.spec_motorized.motorTemperature.value - (coolingRatePerSecond * (dt / 1000) * g_currentMission.missionInfo.timeScale)

			-- Biztosítjuk, hogy a hőmérséklet ne csökkenjen az időjárási hőmérséklet alá
			if self.spec_motorized.motorTemperature.value < self.currentTemperaturDay then
				self.spec_motorized.motorTemperature.value = self.currentTemperaturDay
			end
		end
		
			
	end

	self:setLightingsOperatingHours(dt)	
		
	--self:setBatteryCharging()
	



	
	
	
	local engine_percent = (spec.parts[6].operatingHours * 100) / spec.parts[6].tmp_lifetime
	if self:getIsFaultSelfStarter() or self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.MOTOR or engine_percent >= 99 then
	
		if g_modIsLoaded["FS25_AutoDrive"] then
			if FS25_AutoDrive ~= nil then
				if self.ad.stateModule:isActive() then
					self:stopAutoDrive(self)
					--self:updateVehiclePhysics(0, 0, 0, 16)
					self:stopVehicle()
					FS25_AutoDrive.AutoDriveMessageEvent.sendNotification(self, FS25_AutoDrive.ADMessagesManager.messageTypes.INFO, g_i18n:getText("RVB_aimessage_batterydischarged"), 8000, self:getFullName())
				end
			end
		end
		
		if g_modIsLoaded["FS25_Courseplay"] then
			if FS25_Courseplay ~= nil then
				if self:getIsCpActive() then
					if self.getIsAIActive and self:getIsAIActive() then
						self:stopCurrentAIJob(AIMessageErrorBatteryDischarged.new())
						self:stopVehicle()
					end
				end
			end
		end

	end
	
	if self.isServer then
		if spec.rvblightsTypesMask ~= self.spec_lights.lightsTypesMask then
			lightsTypesMask = self.spec_lights.lightsTypesMask
			if self.spec_lights.lightsTypesMask >= 512 then
				lightsTypesMask = self.spec_lights.lightsTypesMask - 512
			end
			self:setRVBLightsTypesMask(lightsTypesMask)
		end
	end

	if self:getIsEntered() then
		if self:getIsFaultLightings() or self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.LIGHTS then
			if not spec.lights_request_A then
				self:setRVBLightsStrings(true, spec.lights_request_B)
				self:requestActionEventUpdate()
			end
		else
			if spec.lights_request_A then
				self:setRVBLightsStrings(false, spec.lights_request_B)
				self:requestActionEventUpdate()
			end
		end

		if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.BeaconLIGHTS then
			if not spec.lights_request_B then
				self:setRVBLightsStrings(spec.lights_request_A, true)
				self:requestActionEventUpdate()
			end
		else
			if spec.lights_request_B then
				self:setRVBLightsStrings(spec.lights_request_A, false)
				self:requestActionEventUpdate()
			end
		end
	end
	

	local GSET = g_currentMission.vehicleBreakdowns.generalSettings
	local GPSET = g_currentMission.vehicleBreakdowns.gameplaySettings	
	
	if VehicleBreakdowns.GPSET_Change_thermostat ~= GPSET.thermostatLifetime then
		local thermostat = rvb_Utils.removeLifetimeText("thermostatLifetime")
		self:updatePartsLifetime(thermostat, GPSET.thermostatLifetime)
		VehicleBreakdowns.GPSET_Change_thermostat = GPSET.thermostatLifetime
	end

	if VehicleBreakdowns.GPSET_Change_lightings ~= GPSET.lightingsLifetime then
		local lightings = rvb_Utils.removeLifetimeText("lightingsLifetime")
		self:updatePartsLifetime(lightings, GPSET.lightingsLifetime)
		VehicleBreakdowns.GPSET_Change_lightings = GPSET.lightingsLifetime
	end

	if VehicleBreakdowns.GPSET_Change_glowplug ~= GPSET.glowplugLifetime then
		local glowplug = rvb_Utils.removeLifetimeText("glowplugLifetime")
		self:updatePartsLifetime(glowplug, GPSET.glowplugLifetime)
		VehicleBreakdowns.GPSET_Change_glowplug = GPSET.glowplugLifetime
	end

	if VehicleBreakdowns.GPSET_Change_wipers ~= GPSET.wipersLifetime then
		local wipers = rvb_Utils.removeLifetimeText("wipersLifetime")
		self:updatePartsLifetime(wipers, GPSET.wipersLifetime)
		VehicleBreakdowns.GPSET_Change_wipers = GPSET.wipersLifetime
	end

	if VehicleBreakdowns.GPSET_Change_generator ~= GPSET.generatorLifetime then
		local generator = rvb_Utils.removeLifetimeText("generatorLifetime")
		self:updatePartsLifetime(generator, GPSET.generatorLifetime)
		VehicleBreakdowns.GPSET_Change_generator = GPSET.generatorLifetime
	end

	if VehicleBreakdowns.GPSET_Change_engine ~= GPSET.engineLifetime then
		local engine = rvb_Utils.removeLifetimeText("engineLifetime")
		self:updatePartsLifetime(engine, GPSET.engineLifetime)
		VehicleBreakdowns.GPSET_Change_engine = GPSET.engineLifetime
	end

	if VehicleBreakdowns.GPSET_Change_selfstarter ~= GPSET.selfstarterLifetime then
		local selfstarter = rvb_Utils.removeLifetimeText("selfstarterLifetime")
		self:updatePartsLifetime(selfstarter, GPSET.selfstarterLifetime)
		VehicleBreakdowns.GPSET_Change_selfstarter = GPSET.selfstarterLifetime
	end

	if VehicleBreakdowns.GPSET_Change_battery ~= GPSET.batteryLifetime then
		local battery = rvb_Utils.removeLifetimeText("batteryLifetime")
		self:updatePartsLifetime(battery, GPSET.batteryLifetime)
		VehicleBreakdowns.GPSET_Change_battery = GPSET.batteryLifetime
	end

	if VehicleBreakdowns.GPSET_Change_tire ~= GPSET.tireLifetime then
		local tire = rvb_Utils.removeLifetimeText("tireLifetime")
		self:updatePartsLifetime(tire, GPSET.tireLifetime)
		VehicleBreakdowns.GPSET_Change_tire = GPSET.tireLifetime
	end

	if VehicleBreakdowns.FSSET_Daysperiod ~= g_currentMission.environment.plannedDaysPerPeriod or VehicleBreakdowns.GSET_Change_difficulty ~= GSET.difficulty then
		for _, vehicle in ipairs(g_currentMission.vehicleSystem.vehicles) do
			if vehicle.spec_faultData ~= nil then
				for i=1, #vehicle.spec_faultData.parts do
					if GSET.difficulty == 1 then
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime * 2 * g_currentMission.environment.plannedDaysPerPeriod
					elseif GSET.difficulty == 2 then
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime * 1 * g_currentMission.environment.plannedDaysPerPeriod
					else
						vehicle.spec_faultData.parts[i].tmp_lifetime = vehicle.spec_faultData.parts[i].lifetime / 2 * g_currentMission.environment.plannedDaysPerPeriod
					end
				end
				RVBParts_Event.sendEvent(vehicle, unpack(vehicle.spec_faultData.parts))
				--vehicle:raiseDirtyFlags(vehicle.spec_faultData.dirtyFlag)
			end
		end
		VehicleBreakdowns.FSSET_Daysperiod = g_currentMission.environment.plannedDaysPerPeriod
		VehicleBreakdowns.GSET_Change_difficulty = GSET.difficulty
	end

	
	if self:getIsFaultGlowPlug() then
		local rnumsec = 2500
		if spec.RandomNumber.glowPlug == 0 then
			spec.RandomNumber.glowPlug = math.random(1, 4)
			spec.TimesSoundPlayed.glowPlug = spec.RandomNumber.glowPlug
		end
		if not spec.DontStopMotor.glowPlug then
			if motorState == MotorState.STARTING then
			--if self:getIsMotorStarted() then 
				spec.MotorTimer.glowPlug = spec.MotorTimer.glowPlug - dt
				spec.NumberMotorTimer.glowPlug = math.min(-spec.MotorTimer.glowPlug / rnumsec, 0.9)
				if spec.NumberMotorTimer.glowPlug >= 0.243589 then
					self:stopMotor()
					spec.MotorTimer.glowPlug = -1
					self:startMotor()
					spec.TimesSoundPlayed.glowPlug = spec.TimesSoundPlayed.glowPlug - 1
					self:setVehicleDamageGlowplugFailure(dt)
				end
				if spec.NumberMotorTimer.glowPlug >= 0.243589 and spec.TimesSoundPlayed.glowPlug == 0 then
					spec.DontStopMotor.glowPlug = true
					spec.TimesSoundPlayed.glowPlug = 2
					spec.RandomNumber.glowPlug = 0
				end
			end
		end
		--if not self:getIsMotorStarted() then
		if motorState == MotorState.OFF then
			if spec.DontStopMotor.glowPlug then
				spec.DontStopMotor.glowPlug = false
			end
		end
	end
	
if self.isClient and isActiveForInputIgnoreSelection then



		if spec.isRVBMotorStarted then
		spec.motorStart_updateDelta = spec.motorStart_updateDelta + dt
		if spec.motorStart_updateDelta > spec.motorStart_updateRate then
			spec.motorStart_updateDelta = 0
			--g_soundManager:stopSample(spec.samples.motorStop)
			--g_soundManager:playSample(spec.samples.motorStart)
			--g_soundManager:playSamples(spec.motorSamples, 0, spec.samples.motorStart)

		end
	end
	
	
	if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.MOTOR or self:getIsFaultSelfStarter() and not self:getIsMotorStarted() then --motorized.isMotorStarted then
		--spec.DontStopMotor.battery = true
		if self.isClient then
			local rvbvolume = 0.550000
			if g_soundManager:getIsIndoor() then
				rvbvolume = 0.250000
			else
				rvbvolume = 0.550000
			end
			setSampleVolume(VehicleBreakdowns.sounds["self_starter"], rvbvolume)
		end

		if not spec.DontStopMotor.self_starter then

			spec.DontStopMotor.battery = true
			
			if self:getIsRVBMotorStarted() then

				spec.MotorTimer.self_starter = spec.MotorTimer.self_starter - dt
				spec.NumberMotorTimer.self_starter = math.min(-spec.MotorTimer.self_starter / 2000, 0.9)

				if spec.NumberMotorTimer.self_starter >= 0.243589 then
					self:stopMotor()
					spec.MotorTimer.self_starter = -1
					self:startMotor()
					spec.TimesSoundPlayed.self_starter = spec.TimesSoundPlayed.self_starter - 1

					local oneGameMinute = 1000 * 60 * 60
					local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
					-- PARTS operatingHours
					spec.parts[1].operatingHours = spec.parts[1].operatingHours + runtimeIncrease
					spec.parts[5].operatingHours = spec.parts[5].operatingHours + runtimeIncrease
					spec.parts[6].operatingHours = spec.parts[6].operatingHours + runtimeIncrease

					--if self.isServer then
					--elseif self.isClient then
						RVBParts_Event.sendEvent(self, unpack(spec.parts))
						--self:raiseDirtyFlags(spec.dirtyFlag)

					--end
					if GSET.alertmessage then
						if self.getIsEntered ~= nil and self:getIsEntered() then
							--g_currentMission:showBlinkingWarning(g_i18n:getText("fault_glowplug"), 2500)
							--g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("fault_glowplug_hud"), self:getFullName()), 5000)
						else
							--g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText("fault_glowplug_hud"), self:getFullName()), 5000)
						end
					end

				end
				
				if spec.NumberMotorTimer.self_starter >= 0.243589 and spec.TimesSoundPlayed.self_starter == 0 then
					spec.DontStopMotor.self_starter = true
					spec.TimesSoundPlayed.self_starter = 2
					self:stopMotor()

					--self:setBatteryDrainingIfStartMotor()
				end
				--self:raiseActive()
			end

		end

		if not self:getIsRVBMotorStarted() then

			if spec.DontStopMotor.self_starter then
				spec.DontStopMotor.self_starter = false
				spec.DontStopMotor.battery = false
			end

		end

	end

end
	if self:getIsMotorStarted() then
		if self.isClient then
			local MotorSounds = self.spec_motorized.motorSamples
			local gearboxSounds = self.spec_motorized.gearboxSamples
			if not g_soundManager:getIsSamplePlaying(MotorSounds[1]) then
				g_soundManager:playSamples(MotorSounds)
			end
			if not g_soundManager:getIsSamplePlaying(gearboxSounds[1]) then
				g_soundManager:playSamples(gearboxSounds)
			end
			if not g_soundManager:getIsSamplePlaying(self.spec_motorized.samples.retarder) then
				g_soundManager:playSample(self.spec_motorized.samples.retarder)
			end
		end	
	end
	
	if self:getIsMotorStarted() then --motorized.isMotorStarted then

		spec.updateDelta = spec.updateDelta + dt * g_currentMission.missionInfo.timeScale
		--if spec.updateDelta * g_currentMission.missionInfo.timeScale > spec.updateRate * g_currentMission.missionInfo.timeScale then
			self:addDamage(dt)
			spec.updateDelta = 0
		--end
		

		
	end
	
	if self:getIsFaultLightings() or self:getIsFaultBattery() ~= nil and self:getIsFaultBattery() ~= 0 then
		self:lightingsFault()
	end


	--if self:getIsFaultEngine() then -- self:getIsFaultGenerator() or
	local engine_percent = (spec.parts[6].operatingHours * 100) / spec.parts[6].tmp_lifetime
	if engine_percent >= 99 then
		self:StopAI(self)
	end


end
function VehicleBreakdowns:updateRepairNeeds(dt)
    -- Időzítő beállítása a javítási igények frissítéséhez
    self.repairUpdateTimer = (self.repairUpdateTimer or 0) + dt
    local updateInterval = 1200 -- ms-ban (1.2 másodperc)
	local thermostatRandom = false
    if self.repairUpdateTimer >= updateInterval then
        self.repairUpdateTimer = 0 -- Időzítő visszaállítása
        local spec = self.spec_faultData
		for i = 1, #spec.parts do
			spec.partfoot = (spec.parts[i].operatingHours * 100) / spec.parts[i].tmp_lifetime
			if i == 2 or i == 4 then
				if spec.partfoot >= 100 and not spec.parts[i].damaged then
					spec.faultList[i] = true
					spec.parts[i].damaged = true
				end
			else
				if spec.partfoot > 95 and not spec.parts[i].damaged then
					if i == 1 then
						thermostatRandom = true
					end
					spec.faultList[i] = true
					spec.parts[i].damaged = true
				end
			end
		end
		VehicleBreakdowns:DebugFaultPrint(spec)
        -- Frissítési igény jelzése a szerver és kliens között
		RVBParts_Event.sendEvent(self, unpack(spec.parts))
        self:raiseDirtyFlags(spec.dirtyFlag)
		if thermostatRandom and not spec.faultStorage[1] and not spec.faultStorage[2] then
			local faultNum = {1,2}
			if faultNum[math.random(#faultNum)] == 1 then
				spec.faultStorage[1] = true
			else
				spec.faultStorage[2] = true
			end
			RVB_Event.sendEvent(self, unpack(spec.faultStorage))
			self:raiseDirtyFlags(spec.dirtyFlag)
			thermostatRandom = false
		end
    end
end

function VehicleBreakdowns:setRVBLightsStrings(lights_request_A, lights_request_B, force, noEventSend)
    local spec = self.spec_faultData

    if lights_request_A ~= spec.lights_request_A or lights_request_B ~= spec.lights_request_B or force then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(RVBLightingsStringsEvent.new(self, lights_request_A, lights_request_B), nil, nil, self)
            else
                g_client:getServerConnection():sendEvent(RVBLightingsStringsEvent.new(self, lights_request_A, lights_request_B))
            end
        end

        spec.lights_request_A = lights_request_A
		spec.lights_request_B = lights_request_B

    end

    return true
end

function VehicleBreakdowns:setRVBLightsTypesMask(rvblightsTypesMask, force, noEventSend)
    local spec = self.spec_faultData

    if rvblightsTypesMask ~= spec.rvblightsTypesMask or force then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(RVBLightingsTypesMaskEvent.new(self, rvblightsTypesMask), nil, nil, self)
            else
                g_client:getServerConnection():sendEvent(RVBLightingsTypesMaskEvent.new(self, rvblightsTypesMask))
            end
        end

        spec.rvblightsTypesMask = rvblightsTypesMask

    end

    return true
end

	
function VehicleBreakdowns:getSpeedLimit(superFunc, onlyIfWorking)
    local limit = math.huge
	
	local spec = self.spec_faultData
	if spec ~= nil then
		local Pfoot = (spec.parts[6].operatingHours * 100) / spec.parts[6].tmp_lifetime
		if spec.parts[6].damaged or spec.parts[6].repairreq and Pfoot > 95 then
			limit = 7
		end
	end
	
    local doCheckSpeedLimit = self:doCheckSpeedLimit()

    if onlyIfWorking == nil or onlyIfWorking and doCheckSpeedLimit then
        limit = self:getRawSpeedLimit()

        local damage = self:getVehicleDamage()
        if damage > 0 then
            limit = limit * (1 - damage * Vehicle.DAMAGED_SPEEDLIMIT_REDUCTION)
        end
    else
		--limit = (1 / 0)
		limit = math.huge
	end
	
    local attachedImplements
	if self.getAttachedImplements == nil then
		attachedImplements = nil
	else
		attachedImplements = self:getAttachedImplements()
	end
    if attachedImplements ~= nil then
        for _, implement in pairs(attachedImplements) do
            if implement.object ~= nil then
                local speed, implementDoCheckSpeedLimit = implement.object:getSpeedLimit(onlyIfWorking)
                if onlyIfWorking == nil or onlyIfWorking and implementDoCheckSpeedLimit then
					if spec ~= nil and Pfoot ~= nil and spec.parts[6].damaged or spec.parts[6].repairreq and Pfoot > 95 then
						limit = 3
					end
                    limit = math.min(limit, speed)
                end
                doCheckSpeedLimit = doCheckSpeedLimit or implementDoCheckSpeedLimit
            end
        end
    end
    return limit, doCheckSpeedLimit
end

---Start motor
-- @param boolean noEventSend no event send
--[[function Motorized:startMotor(noEventSend)
    local motorState = self:getMotorState()
    if motorState == MotorState.OFF or motorState == MotorState.IGNITION then
        MotorSetTurnedOnEvent.sendEvent(self, true, noEventSend)
        self:setMotorState(MotorState.STARTING, true)
    end
end


---Stop motor
-- @param boolean noEventSend no event send
function Motorized:stopMotor(noEventSend)
    local motorState = self:getMotorState()
    if motorState == MotorState.ON or motorState == MotorState.STARTING then
        MotorSetTurnedOnEvent.sendEvent(self, false, noEventSend)
        self:setMotorState(MotorState.OFF, true)
    end
end

function Motorized:setMotorState(superFunc, p356, p357)
	local v358 = p355.spec_motorized
	if v358.motorState ~= p356 then
		MotorStateEvent.sendEvent(p355, p356, p357)
		local v359 = v358.motorState
		v358.motorState = p356
		local v360 = false
		local v361 = false
		if v359 == MotorState.OFF or v359 == MotorState.IGNITION then
			if p356 == MotorState.STARTING or p356 == MotorState.ON then
				v360 = true
			end
		elseif v359 == MotorState.STARTING or v359 == MotorState.ON then
			if p356 == MotorState.OFF or p356 == MotorState.IGNITION then
				v361 = true
			end
		end
		if g_ignitionLockManager:getIsAvailable() then
			if p356 == MotorState.IGNITION then
				v358.motorStateIgnitionTime = g_currentMission.time
			elseif p356 == MotorState.OFF then
				v358.motorStateIgnitionTime = 0
			elseif (p356 == MotorState.STARTING or p356 == MotorState.ON) and v358.motorStateIgnitionTime == 0 then
				v358.motorStateIgnitionTime = g_currentMission.time
			end
		elseif p356 == MotorState.STARTING then
			v358.motorStateIgnitionTime = g_currentMission.time
		elseif p356 == MotorState.OFF then
			v358.motorStateIgnitionTime = 0
		end
		if v360 then
			if p355.isClient then
				if v358.exhaustParticleSystems ~= nil then
					for _, v362 in pairs(v358.exhaustParticleSystems) do
						ParticleUtil.setEmittingState(v362, true)
					end
				end
				if v358.exhaustEffects ~= nil then
					for _, v363 in pairs(v358.exhaustEffects) do
						setVisibility(v363.effectNode, true)
						setShaderParameter(v363.effectNode, "param", v363.xRot, v363.zRot, 0, 0, false)
						local v364 = v363.minRpmColor
						setShaderParameter(v363.effectNode, "exhaustColor", v364[1], v364[2], v364[3], v364[4], false)
					end
				end
				if v358.samples == nil then
					Logging.error("Motor samples not found (%s, %d)", p355.configFileName, p355.loadingState)
					printCallstack()
				end
				g_soundManager:stopSample(v358.samples.motorStop)
				g_soundManager:playSample(v358.samples.motorStart)
				g_soundManager:playSamples(v358.motorSamples, 0, v358.samples.motorStart)
				g_soundManager:playSamples(v358.gearboxSamples, 0, v358.samples.motorStart)
				g_soundManager:playSample(v358.samples.retarder, 0, v358.samples.motorStart)
				g_animationManager:startAnimations(v358.animationNodes)
				if v358.motorStartAnimation ~= nil then
					p355:playAnimation(v358.motorStartAnimation, 1, nil, true)
				end
			end
			v358.motorStartTime = g_currentMission.time + v358.motorStartDuration
			v358.motorNotRequiredTimer = 0
			v358.compressionSoundTime = g_currentMission.time + math.random(5000, 20000)
			v358.motor.lastMotorRpm = 0
			SpecializationUtil.raiseEvent(p355, "onStartMotor")
			p355.rootVehicle:raiseStateChange(VehicleStateChange.MOTOR_TURN_ON)
		elseif v361 then
			if p355.isClient then
				if v358.exhaustParticleSystems ~= nil then
					for _, v365 in pairs(v358.exhaustParticleSystems) do
						ParticleUtil.setEmittingState(v365, false)
					end
				end
				if v358.exhaustEffects ~= nil then
					for _, v366 in pairs(v358.exhaustEffects) do
						setVisibility(v366.effectNode, false)
					end
				end
				for _, v367 in ipairs(v358.exhaustFlaps) do
					setRotation(v367.node, 0, 0, 0)
				end
				g_soundManager:stopSamples(v358.samples)
				g_soundManager:playSample(v358.samples.motorStop)
				g_soundManager:stopSamples(v358.motorSamples)
				g_soundManager:stopSamples(v358.gearboxSamples)
				v358.isBrakeSamplePlaying = false
				g_animationManager:stopAnimations(v358.animationNodes)
				if v358.motorStartAnimation ~= nil then
					p355:playAnimation(v358.motorStartAnimation, -1, nil, true)
				end
			end
			SpecializationUtil.raiseEvent(p355, "onStopMotor")
			p355.rootVehicle:raiseStateChange(VehicleStateChange.MOTOR_TURN_OFF)
		end
	end
	if p356 == MotorState.ON or p356 == MotorState.STARTING then
		if p355.isServer then
			p355:wakeUp()
		end
	else
		v358.motor.lastMotorRpm = 0
	end
	if p355.setDashboardsDirty ~= nil then
		p355:setDashboardsDirty()
	end
end]]

	
---Start motor
-- @param boolean noEventSend no event send
function VehicleBreakdowns:startMotor(superFunc, noEventSend)

	SetRVBMotorTurnedOnEvent.sendEvent(self, true, noEventSend)

	local spec = self.spec_motorized
	local rvbs = self.spec_faultData

	if self.spec_motorized.motorTemperature.value <= self.currentTemperaturDay then
		self.spec_motorized.motorTemperature.value = self.currentTemperaturDay
	end

	-- GLOWPLUG SERULES
	local oneGameMinute = 60
	if self.currentTemperaturDay > 20 then
		oneGameMinute = oneGameMinute / 2
	elseif self.currentTemperaturDay <= 20 and self.currentTemperaturDay >= 5 then
		oneGameMinute = oneGameMinute
	else
		oneGameMinute = oneGameMinute * 1.5
	end

	if rvbs.parts[3].operatingHours < rvbs.parts[3].tmp_lifetime then
		rvbs.parts[3].operatingHours = rvbs.parts[3].operatingHours + oneGameMinute / 3600
	end

	--SELFSTARTER SERULES
	--starter
	local oneGameMinute7 = 60
	if rvbs.parts[7].operatingHours < rvbs.parts[7].tmp_lifetime then
		rvbs.parts[7].operatingHours = rvbs.parts[7].operatingHours + oneGameMinute7 / 3600
	end

	RVBParts_Event.sendEvent(self, unpack(rvbs.parts))


	--if not rvbs.DontStopMotor.battery then
		self:setBatteryDrainingIfStartMotor()
	--end

	self:raiseDirtyFlags(rvbs.dirtyFlag)

	if self:getIsFaultSelfStarter() or self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.MOTOR then

		if not rvbs.isRVBMotorStarted then
			rvbs.isRVBMotorStarted = true
			if self.isClient then
				local rvbvolume = 0.550000
				if g_soundManager:getIsIndoor() then
					rvbvolume = 0.250000
				else
					rvbvolume = 0.550000
				end
				--playSample(VehicleBreakdowns.sounds["self_starter"], 1, rvbvolume, 0, 0, 0)
				--g_soundManager:playSample(spec.samples.motorStart)
				--g_soundManager:playSamples(spec.motorSamples, 0, spec.samples.motorStart)
				g_soundManager:stopSample(spec.samples.motorStop)
				g_soundManager:playSample(spec.samples.motorStart)
				g_soundManager:playSamples(spec.motorSamples, 0, spec.samples.motorStart)
		--playSample(VehicleBreakdowns.sounds["battery"], 1, rvbvolume, 0, 0, 0)

--Logging.error("startMotor")
--printCallstack()
			end

			rvbs.rvbmotorStartTime = g_currentMission.time + self.spec_motorized.motorStartDuration

		end

		--[[if p356 == MotorState.ON or p356 == MotorState.STARTING then
			if self.isServer then
				self:wakeUp()
			end
		else
			v358.motor.lastMotorRpm = 0
		end]]
		--if self.isServer then
		--	self:wakeUp()
		--end

	else
		superFunc(self, noEventSend)
	end

end

function VehicleBreakdowns:Motorized_setMotorState(superFunc, p356, p357)
	local p355 = self
	local v358 = p355.spec_motorized
	if v358.motorState ~= p356 then
		MotorStateEvent.sendEvent(p355, p356, p357)
		local v359 = v358.motorState
		v358.motorState = p356
		local v360 = false
		local v361 = false
		if v359 == MotorState.OFF or v359 == MotorState.IGNITION then
			if p356 == MotorState.STARTING or p356 == MotorState.ON then
				v360 = true
			end
		elseif v359 == MotorState.STARTING or v359 == MotorState.ON then
			if p356 == MotorState.OFF or p356 == MotorState.IGNITION then
				v361 = true
			end
		end
		if g_ignitionLockManager:getIsAvailable() then
			if p356 == MotorState.IGNITION then
				v358.motorStateIgnitionTime = g_currentMission.time
			elseif p356 == MotorState.OFF then
				v358.motorStateIgnitionTime = 0
			elseif (p356 == MotorState.STARTING or p356 == MotorState.ON) and v358.motorStateIgnitionTime == 0 then
				v358.motorStateIgnitionTime = g_currentMission.time
			end
		elseif (p356 == MotorState.STARTING or p356 == MotorState.ON) and v358.motorStateIgnitionTime == 0 then
			v358.motorStateIgnitionTime = g_currentMission.time
		elseif p356 == MotorState.OFF then
			v358.motorStateIgnitionTime = 0
		end
		if v360 then
			if p355.isClient then
				if v358.exhaustParticleSystems ~= nil then
					for _, v362 in pairs(v358.exhaustParticleSystems) do
						ParticleUtil.setEmittingState(v362, true)
					end
				end
				if v358.exhaustEffects ~= nil then
					for _, v363 in pairs(v358.exhaustEffects) do
						setVisibility(v363.effectNode, true)
						setShaderParameter(v363.effectNode, "param", v363.xRot, v363.zRot, 0, 0, false)
						local v364 = v363.minRpmColor
						setShaderParameter(v363.effectNode, "exhaustColor", v364[1], v364[2], v364[3], v364[4], false)
					end
				end
				if v358.samples == nil then
					Logging.error("Motor samples not found (%s, %d)", p355.configFileName, p355.loadingState)
					printCallstack()
				end
				g_soundManager:stopSample(v358.samples.motorStop)
				g_soundManager:playSample(v358.samples.motorStart)
				g_soundManager:playSamples(v358.motorSamples, 0, v358.samples.motorStart)
				g_soundManager:playSamples(v358.gearboxSamples, 0, v358.samples.motorStart)
				g_soundManager:playSample(v358.samples.retarder, 0, v358.samples.motorStart)
				g_animationManager:startAnimations(v358.animationNodes)
				if v358.motorStartAnimation ~= nil then
					p355:playAnimation(v358.motorStartAnimation, 1, nil, true)
				end
			end
			v358.motorStartTime = g_currentMission.time + v358.motorStartDuration
			v358.motorNotRequiredTimer = 0
			v358.compressionSoundTime = g_currentMission.time + math.random(5000, 20000)
			v358.motor.lastMotorRpm = 0
			SpecializationUtil.raiseEvent(p355, "onStartMotor")
			p355.rootVehicle:raiseStateChange(VehicleStateChange.MOTOR_TURN_ON)
		elseif v361 then
			if p355.isClient then
				if v358.exhaustParticleSystems ~= nil then
					for _, v365 in pairs(v358.exhaustParticleSystems) do
						ParticleUtil.setEmittingState(v365, false)
					end
				end
				if v358.exhaustEffects ~= nil then
					for _, v366 in pairs(v358.exhaustEffects) do
						setVisibility(v366.effectNode, false)
					end
				end
				for _, v367 in ipairs(v358.exhaustFlaps) do
					setRotation(v367.node, 0, 0, 0)
				end
				g_soundManager:stopSamples(v358.samples)
				g_soundManager:playSample(v358.samples.motorStop)
				g_soundManager:stopSamples(v358.motorSamples)
				g_soundManager:stopSamples(v358.gearboxSamples)
				v358.isBrakeSamplePlaying = false
				g_animationManager:stopAnimations(v358.animationNodes)
				if v358.motorStartAnimation ~= nil then
					p355:playAnimation(v358.motorStartAnimation, -1, nil, true)
				end
			end
			SpecializationUtil.raiseEvent(p355, "onStopMotor")
			p355.rootVehicle:raiseStateChange(VehicleStateChange.MOTOR_TURN_OFF)
		end
	end
	if p356 == MotorState.ON or p356 == MotorState.STARTING then
		if p355.isServer then
			p355:wakeUp()
		end
	else
		v358.motor.lastMotorRpm = 0
	end
	if p355.setDashboardsDirty ~= nil then
		p355:setDashboardsDirty()
	end
end
--Motorized.setMotorState = Utils.overwrittenFunction(Motorized.setMotorState, VehicleBreakdowns.Motorized_setMotorState)

---Stop motor
-- @param boolean noEventSend no event send
function VehicleBreakdowns:stopMotor(superFunc, noEventSend)
	local spec = self.spec_motorized
	local rvbs = self.spec_faultData

	SetRVBMotorTurnedOnEvent.sendEvent(self, false, noEventSend)

	if rvbs.isRVBMotorStarted and self:getIsFaultSelfStarter() or self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.MOTOR and not self:getIsFaultGenerator() and not self:getIsFaultGlowPlug() then
		if rvbs.isRVBMotorStarted then
			rvbs.isRVBMotorStarted = false
			if self.isClient then
				--stopSample(VehicleBreakdowns.sounds["self_starter"], 0 , 0)
				g_soundManager:stopSamples(spec.samples)
				g_soundManager:playSample(spec.samples.motorStop)
				g_soundManager:stopSamples(spec.motorSamples)
				--g_soundManager:stopSamples(spec.gearboxSamples)
			end
		end
	
	elseif rvbs.isRVBMotorStarted and self:getIsFaultGenerator() and self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.MOTOR and not self:getIsFaultSelfStarter() and not self:getIsFaultGlowPlug() then
		if rvbs.isRVBMotorStarted then
			rvbs.isRVBMotorStarted = false
			if self.isClient then
				--stopSample(VehicleBreakdowns.sounds["self_starter"], 0 , 0)
				g_soundManager:stopSamples(spec.samples)
				g_soundManager:playSample(spec.samples.motorStop)
				g_soundManager:stopSamples(spec.motorSamples)
				g_soundManager:stopSamples(spec.gearboxSamples)
			end
		end

	else
		if self:getIsFaultBattery() < VehicleBreakdowns.SET.BatteryLevel.MOTOR then
			if self.isClient then
				g_soundManager:stopSamples(spec.samples)
				g_soundManager:playSample(spec.samples.motorStop)
				g_soundManager:stopSamples(spec.motorSamples)
				g_soundManager:stopSamples(spec.gearboxSamples)
			end
		end
		superFunc(self, noEventSend)
	end
	
end

function VehicleBreakdowns:getIsRVBMotorStarted(isRunning)
    return self.spec_faultData.isRVBMotorStarted and (not isRunning or self.spec_faultData.rvbmotorStartTime < g_currentMission.time)
end

function VehicleBreakdowns:getIsActiveForWipers(superFunc)
	local spec = self.spec_faultData
	if self:getIsFaultWipers() and self:getMotorState() == MotorState.ON then
       return false
    end
    return superFunc(self)
end

function VehicleBreakdowns:onStartOperatingHours(dt)
	local spec = self.spec_faultData
	local oneGameMinute = 1000 * 60 * 60
	local runtimeIncrease = dt * g_currentMission.missionInfo.timeScale / oneGameMinute
	local increase = runtimeIncrease
	if increase ~= 0 then
		spec.runtimeToChange = spec.runtimeToChange + increase
		local runtimeToChange = spec.runtimeToChange
		if math.abs(runtimeToChange) > 0.016666 then
			increase = spec.runtimeToChange
			spec.runtimeToChange = 0
			-- TotaloperatingHours
			spec.rvb[3] = spec.rvb[3] + increase
			-- Service operatingHours
			spec.rvb[4] = spec.rvb[4] + increase
			-- PARTS operatingHours
			spec.parts[1].operatingHours = spec.parts[1].operatingHours + increase
			spec.parts[5].operatingHours = spec.parts[5].operatingHours + increase
			spec.parts[6].operatingHours = spec.parts[6].operatingHours + increase
			spec.parts[8].operatingHours = spec.parts[8].operatingHours + increase
			self:raiseDirtyFlags(spec.dirtyFlag)
			RVBTotal_Event.sendEvent(self, unpack(spec.rvb))
			RVBParts_Event.sendEvent(self, unpack(spec.parts))
		end
	end
end		

function VehicleBreakdowns:FillUnit_showInfo(superFunc, box)
end
FillUnit.showInfo = Utils.overwrittenFunction(FillUnit.showInfo, VehicleBreakdowns.FillUnit_showInfo)

-- InfoDisplayExtension
function VehicleBreakdowns:showInfo(superFunc, box)
	if self.ideHasPower == nil then
		local powerConfig = Motorized.loadSpecValuePowerConfig(self.xmlFile)
		
		self.ideHasPower = 0
		
		if powerConfig ~= nil then
			for configName, config in pairs(self.configurations) do
				local configPower = powerConfig[configName][config]

				if configPower ~= nil then
					self.ideHasPower = configPower
				end
			end
		end
	end
	
	if self.ideHasPower ~= nil and self.ideHasPower ~= 0 then
		local hp, kw = g_i18n:getPower(self.ideHasPower)
		local neededPower = string.format(g_i18n:getText("shop_neededPowerValue"), MathUtil.round(kw), MathUtil.round(hp));
		box:addLine(g_i18n:getText("infoDisplayExtension_currentPower"), neededPower)
		
		local spec = self.spec_faultData
	
		-- INSPECTION
		if spec.inspection[1] then -- and not spec.repair[10]
			local tomorrowText = ""
			if spec.inspection[3] > g_currentMission.environment.currentDay then
				tomorrowText = g_i18n:getText("infoDisplayExtension_tomorrow")
			end
			box:addLine(g_i18n:getText("infoDisplayExtension_inspectionVheicle"), tomorrowText..string.format("%02d:%02d", spec.inspection[4], spec.inspection[5]))
		end
		
		-- REPAIR
		if spec.repair[1] then
			local tomorrowText = ""
			if spec.repair[3] > g_currentMission.environment.currentDay then
				tomorrowText = g_i18n:getText("infoDisplayExtension_tomorrow")
			end
			box:addLine(g_i18n:getText("infoDisplayExtension_repairVheicle"), tomorrowText..string.format("%02d:%02d", spec.repair[4], spec.repair[5]))
		end
		
		-- SERVICE
		if self:getIsService() then
			local tomorrowText = ""
			if spec.service[3] > g_currentMission.environment.currentDay then
				tomorrowText = g_i18n:getText("infoDisplayExtension_tomorrow")
			end
			box:addLine(g_i18n:getText("infoDisplayExtension_serviceVheicle"), tomorrowText..string.format("%02d:%02d", spec.service[4], spec.service[5]))
		end
		
	end
	
	local specFillU = self.spec_fillUnit

    if specFillU.isInfoDirty then
        specFillU.fillUnitInfos = {}
        local fillTypeToInfo = {}

        for fillUnitIndex, fillUnit in ipairs(specFillU.fillUnits) do
			
			if self.getConsumerFillUnitIndex ~= nil then
				local fillUnitIndexELECTRIC = self:getConsumerFillUnitIndex(FillType.ELECTRICCHARGE)
				local fillUnitIndexDIESEL = self:getConsumerFillUnitIndex(FillType.DIESEL)
				
				if fillUnitIndexELECTRIC ~= nil and fillUnitIndexDIESEL ~= nil then

					if fillUnit.fillType ~= FillType.ELECTRICCHARGE then
						if fillUnit.showOnInfoHud and fillUnit.fillLevel > 0 then
							local info = fillTypeToInfo[fillUnit.fillType]
							if info == nil then
								local fillType = g_fillTypeManager:getFillTypeByIndex(fillUnit.fillType)
								info = {title=fillType.title, fillLevel=0, unit=fillUnit.unitText, precision=0}
								table.insert(specFillU.fillUnitInfos, info)
								fillTypeToInfo[fillUnit.fillType] = info
							end

							info.fillLevel = info.fillLevel + fillUnit.fillLevel
							if info.precision == 0 and fillUnit.fillLevel > 0 then
								info.precision = fillUnit.uiPrecision or 0
							end
						end
					end

					if fillUnit.fillType == FillType.ELECTRICCHARGE then
						local fillType = g_fillTypeManager:getFillTypeByIndex(fillUnit.fillType)
							
						local info = fillTypeToInfo[fillUnit.fillType]
						if info == nil then
							local fillType = g_fillTypeManager:getFillTypeByIndex(fillUnit.fillType)
							info = {title=g_i18n:getText("RVB_list_battery"), fillLevel=0, unit="%", precision=0}
							table.insert(specFillU.fillUnitInfos, info)
							fillTypeToInfo[fillUnit.fillType] = info
						end

						info.fillLevel = info.fillLevel + fillUnit.fillLevel / fillUnit.capacity * 100
						if info.precision == 0 and fillUnit.fillLevel >= 0 then
							info.precision = fillUnit.uiPrecision or 0
						end
							
					end

				else

					local fillType = g_fillTypeManager:getFillTypeByIndex(fillUnit.fillType)

					if fillUnit.showOnInfoHud and fillUnit.fillLevel > 0 then
						local info = fillTypeToInfo[fillUnit.fillType]
						if info == nil then
							local fillType = g_fillTypeManager:getFillTypeByIndex(fillUnit.fillType)
							info = {title=fillType.title, fillLevel=0, unit=fillUnit.unitText, precision=0}
							table.insert(specFillU.fillUnitInfos, info)
							fillTypeToInfo[fillUnit.fillType] = info
						end

						info.fillLevel = info.fillLevel + fillUnit.fillLevel
						if info.precision == 0 and fillUnit.fillLevel > 0 then
							info.precision = fillUnit.uiPrecision or 0
						end
					end
				
				end
				
			end

        end

        specFillU.isInfoDirty = false
    end

    for _, info in ipairs(specFillU.fillUnitInfos) do
        local formattedNumber
        if info.precision > 0 then
            local rounded = MathUtil.round(info.fillLevel, info.precision)
            formattedNumber = string.format("%d%s%0"..info.precision.."d", math.floor(rounded), g_i18n.decimalSeparator, (rounded - math.floor(rounded)) * 10 ^ info.precision)
        else
            formattedNumber = string.format("%d", MathUtil.round(info.fillLevel))
        end

        formattedNumber = formattedNumber .. " " .. (info.unit or g_i18n:getVolumeUnit())

        box:addLine(info.title, formattedNumber)
    end
	
	superFunc(self, box)
	
end

function VehicleBreakdowns:onDelete()
    local spec = self.spec_faultData

	g_messageCenter:unsubscribe(MessageType.MINUTE_CHANGED, self)
	g_messageCenter:unsubscribe(MessageType.HOUR_CHANGED, self)
	
end

function VehicleBreakdowns:getBatteryChPrice()
	local spec = self.spec_faultData
	return VehicleBreakdowns.calculateBatteryChPrice(300, spec.rvb[5])
end

function VehicleBreakdowns:getBatteryChPrice_AAAA()
	local spec = self.spec_faultData
	local currentChargeLevel = math.floor((1 - self:getIsFaultBattery())*100)
	local lackofcharge = 100 - currentChargeLevel
	spec.battery.chargeAmount = self.calculateBatteryChPrice(1000, self:getIsFaultBattery()) / lackofcharge

	return self.calculateBatteryChPrice(1000, self:getIsFaultBattery())
end

function VehicleBreakdowns.calculateBatteryChPrice(price, charge)
    -- up to 9% of the price at full damage
    -- repairing more often at low damages is rewarded - repairing always at 10% saves about half of the repair price
    return price * math.pow(charge, 1.5) * 0.09
end

function VehicleBreakdowns:addDamage(dt)

	local spec = self.spec_faultData
	local RVBSET = g_currentMission.vehicleBreakdowns		

	local _value = self.spec_motorized.motorTemperature.value
	local motor = self.spec_motorized.motor

	local maximumSpeed = motor:getMaximumForwardSpeed() * 3.6
	local maxspeedNotBreakdown = string.format("%.0f", maximumSpeed * 0.4)

	maxspeedNotBreakdown = string.format("%.0f", maxspeedNotBreakdown)

	local currentspeed = self:getSpeed(self)
	local currentTemp = _value
	local mintempNotBreakdown = 30

	local oneGameMinute = 60 * 1000 / 3600000

	if tonumber(currentTemp) < tonumber(mintempNotBreakdown) and tonumber(currentspeed) > tonumber(maxspeedNotBreakdown) then
		
		local mennyivel = currentspeed - maxspeedNotBreakdown
		local breakdownValue = 0

		if tonumber(mennyivel) > 0 then
		
			if tonumber(mennyivel) > 0 and tonumber(mennyivel) < 6 then
				breakdownValue = 0.00001
				oneGameMinute = oneGameMinute
			elseif tonumber(mennyivel) > 5 and tonumber(mennyivel) < 16 then
				breakdownValue = 0.00002
				oneGameMinute = oneGameMinute * 1.5
			elseif tonumber(mennyivel) > 15 and tonumber(mennyivel) < 26 then
				breakdownValue = 0.00003
				oneGameMinute = oneGameMinute * 2
			elseif tonumber(mennyivel) > 25 then
				breakdownValue = 0.00005
				oneGameMinute = oneGameMinute * 2.5
			end
			oneGameMinute = oneGameMinute / 60
			--local oneGameMinute = 60 * 1000 / 3600000
			-- PARTS operatingHours
			spec.parts[1].operatingHours = spec.parts[1].operatingHours + oneGameMinute + dt * g_currentMission.missionInfo.timeScale / 3600000
			spec.parts[6].operatingHours = spec.parts[6].operatingHours + oneGameMinute + dt * g_currentMission.missionInfo.timeScale / 3600000

			--if self.isServer then
			--elseif self.isClient then
				RVBParts_Event.sendEvent(self, unpack(spec.parts))
				--self:raiseDirtyFlags(spec.dirtyFlag)
			--end


			local fault_text = "RVB_fault_"
			local fault_hud_text = "RVB_fault_hud"
			if spec.faultStorage[2] then
				fault_text = "RVB_fault_thermostatC"
				fault_hud_text = "RVB_fault_thermostatC_hud"
			end
			if RVBSET:getIsAlertMessage() and not spec.addDamage.alert then
				if self.getIsEntered ~= nil and self:getIsEntered() then
					if self.getConsumerFillUnitIndex ~= nil and self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil then
						g_currentMission:showBlinkingWarning(g_i18n:getText(fault_text), 2500)
					end
				--	g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_INFO, "- "..string.format(g_i18n:getText(fault_hud_text), self:getFullName()))
				else
				--	g_currentMission.hud:addSideNotification(VehicleBreakdowns.INGAME_NOTIFICATION, string.format(g_i18n:getText(fault_hud_text), self:getFullName()), 5000)
				end
				spec.addDamage.alert = true
			end

		end

	end

end

function VehicleBreakdowns:DebugFaultPrint(spec)
    local faultMessages = {}
    for faultIndex, isActive in pairs(spec.faultList) do
        if isActive and VehicleBreakdowns.faultText[faultIndex] then
			table.insert(faultMessages, g_i18n:getText("RVB_faultText_"..VehicleBreakdowns.faultText[faultIndex]))
        end
    end
    if #faultMessages > 0 then
        local NotifiText = g_i18n:getText("RVB_ErrorNotifi") .. table.concat(faultMessages, ", ")
        g_currentMission:addGameNotification(
            g_i18n:getText("input_VEHICLE_BREAKDOWN_MENU"),
            NotifiText,
            "",
            "dataS/menu/vignette.dds",
            4000
        )
    end
    for faultIndex, _ in pairs(spec.faultList) do
        spec.faultList[faultIndex] = nil
    end
end


-- IGAZÁBÓL NEM KELL
function VehicleBreakdowns:onEnterVehicle()
	local spec = self.spec_faultData
end

function VehicleBreakdowns:onLeaveVehicle()
	local spec = self.spec_faultData
	if spec.isRVBMotorStarted then
        	spec.isRVBMotorStarted = false
		if self.isClient then
			stopSample(VehicleBreakdowns.sounds["self_starter"], 0 , 0)
		end
	end
end

function VehicleBreakdowns:mouseEvent(posX, posY, isDown, isUp, button)
end

function VehicleBreakdowns:keyEvent(unicode, sym, modifier, isDown)
end


function VehicleBreakdowns:getCanMotorRun(superFunc)
	if self.spec_faultData ~= nil then
		local spec = self.spec_faultData
		if spec ~= nil then
			local engine_percent = (spec.parts[6].operatingHours * 100) / spec.parts[6].tmp_lifetime
			if engine_percent < 99 and not spec.battery[1] and not spec.service[1] and not spec.repair[1] and not spec.inspection[1] and self:getIsFaultBattery() >= 0.06 and spec.batteryCHActive == false then
				return superFunc(self)
			end
		end
	end
	
    return false
end
	
function VehicleBreakdowns:getMotorNotAllowedWarning()
    local spec = self.spec_motorized

    for _, fillUnit in pairs(spec.propellantFillUnitIndices) do
        if self:getFillUnitFillLevel(fillUnit) == 0 then
            return spec.consumersEmptyWarning
        end
    end
	
	local specf = self.spec_faultData
	
	if self:getIsFaultGenerator()and not specf.repair[1] then
        --return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_GENERATOR
    end

	local engine_percent = (specf.parts[6].operatingHours * 100) / specf.parts[6].tmp_lifetime
	if engine_percent >= 99 and not specf.repair[1] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE
    end
	
	if specf.inspection[1] and not specf.inspection[2] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_INSPECTION
	end
	if specf.inspection[1] and specf.inspection[2] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_SUSPENSION
	end
	
	if specf.repair[1] and not specf.repair[2] and specf.inspection[8] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_REPAIR
	end
	if specf.repair[1] and specf.repair[2] and specf.inspection[8] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_SUSPENSION
    end
	
	if specf.service[1] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_SERVICE
    end
	if specf.service[1] and specf.service[2] then
        return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_SUSPENSION
    end
	
	--if specf.battery[1] then
    --    return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_BATTERY_CHARGING
    --end
	if self:getIsFaultBattery() > 0.03 and self:getIsFaultBattery() < 0.10 then -- VehicleBreakdowns.SET.BatteryLevel.MOTOR then
		return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_BATTERY
	end
	--if specf.battery[1] and specf.battery[2] then
    --    return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_SUSPENSION
    --end
	if specf.batteryCHActive == true then
		return g_i18n.modEnvironments[g_vehicleBreakdownsModName].texts.VehicleBreakdown_DEAD_ENGINE_BATTERY
	end

    local canMotorRun, reason = spec.motor:getCanMotorRun()
	if canMotorRun or reason ~= VehicleMotor.REASON_CLUTCH_NOT_ENGAGED then
		return nil
	else
		return spec.clutchNoEngagedWarning
	end

end
--[[
function Motorized.updateMotorTemperature(p401, p402)
	local v403 = p401.spec_motorized
	local v404 = v403.motorTemperature.heatingPerMS * p402 * ((1 + 4 * v403.actualLoadPercentage) / 5 + p401:getMotorRpmPercentage())
	local v405 = v403.motorTemperature
	local v406 = v403.motorTemperature.valueMax
	local v407 = v403.motorTemperature.value + v404
	v405.value = math.min(v406, v407)
	local v408 = v403.motorTemperature.coolingByWindPerMS * p402
	local v409 = p401:getLastSpeed() / 30
	local v410 = math.min(1, v409)
	local v411 = math.pow(v410, 2)
	local v412 = v403.motorTemperature
	local v413 = v403.motorTemperature.valueMin
	local v414 = v403.motorTemperature.value - v411 * v408
	v412.value = math.max(v413, v414)
	if v403.motorTemperature.value > v403.motorFan.enableTemperature then
		v403.motorFan.enabled = true
	end
	if v403.motorFan.enabled and v403.motorTemperature.value < v403.motorFan.disableTemperature then
		v403.motorFan.enabled = false
	end
	if v403.motorFan.enabled then
		local v415 = v403.motorFan.coolingPerMS * p402
		local v416 = v403.motorTemperature
		local v417 = v403.motorTemperature.valueMin
		local v418 = v403.motorTemperature.value - v415
		v416.value = math.max(v417, v418)
	end
end--]]

function VehicleBreakdowns:updateMotorTemperature(superFunc, dt)
    local spec = self.spec_motorized
	local rvb = self.spec_faultData
	
    -- Heating phase: Calculate heat generated based on load and RPM
    local heatingRate = spec.motorTemperature.heatingPerMS * dt
    local loadFactor = (1 + 4 * spec.actualLoadPercentage) / 5
    local rpmFactor = self:getMotorRpmPercentage()
    local totalHeating = heatingRate * (loadFactor + rpmFactor)
    spec.motorTemperature.value = math.min(spec.motorTemperature.valueMax, spec.motorTemperature.value + totalHeating)

    -- cooling due to wind Cooling phase: Calculate cooling by wind based on speed
    local windCoolingRate = spec.motorTemperature.coolingByWindPerMS * dt
    local speedFactor = math.pow(math.min(1, self:getLastSpeed() / 30), 2)
    spec.motorTemperature.value = math.max(spec.motorTemperature.valueMin, spec.motorTemperature.value - speedFactor * windCoolingRate)

    -- cooling per fan
    if spec.motorTemperature.value > spec.motorFan.enableTemperature then
        spec.motorFan.enabled = true
    end
	
	if rvb.faultStorage[1] and not spec.motorFan.enabled then
		spec.motorFan.enabled = false
		spec.motorFan.enableTemperature = 121
		spec.motorFan.disableTemperature = 100
	end

	if rvb.faultStorage[2] then
		spec.motorFan.enableTemperature = 45
		spec.motorFan.disableTemperature = 25
	end
	
    if spec.motorFan.enabled and spec.motorTemperature.value < spec.motorFan.disableTemperature then
        spec.motorFan.enabled = false
    end

    -- Cooling phase: Additional cooling by fan if enabled
    if spec.motorFan.enabled then
        local fanCoolingRate = spec.motorFan.coolingPerMS * dt
        spec.motorTemperature.value = math.max(spec.motorTemperature.valueMin, spec.motorTemperature.value - fanCoolingRate)
    end
end


function VehicleBreakdowns:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
    local spec = self.spec_motorized
	local rvb = self.spec_faultData
	local accInput = 0
	if self.getAxisForward ~= nil then
		accInput = self:getAxisForward()
	end
	

	--
	if self:getIsMotorStarted() then
	
		if self.getCruiseControlState ~= nil then
			if self:getCruiseControlState() ~= Drivable.CRUISECONTROL_STATE_OFF then
				accInput = 1
			end
		end
			
		if self.isClient and not self.isServer then

			--self:updateMotorTemperature(dt)

			if self.getConsumerFillUnitIndex ~= nil then
				VehicleBreakdowns.ECONOMIZER.TIME = VehicleBreakdowns.ECONOMIZER.TIME + dt
				if VehicleBreakdowns.ECONOMIZER.TIME > VehicleBreakdowns.ECONOMIZER.REFRESH_PERIOD then
					VehicleBreakdowns.ECONOMIZER.TIME = VehicleBreakdowns.ECONOMIZER.TIME - VehicleBreakdowns.ECONOMIZER.REFRESH_PERIOD
					local isDieselMotor = (self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil)
					if isDieselMotor then					
						--self:updateConsumers(dt, accInput)
						local value = spec.lastFuelUsage or 0.0
						rvb.instantFuel.Consumption = string.format("%.1f l/h", value)
						VehicleBreakdowns.ECONOMIZER.DISPLAY = true
					else -- no DIESEL
						VehicleBreakdowns.ECONOMIZER.DISPLAY = false
					end
				end
			else -- no fill unit
				VehicleBreakdowns.ECONOMIZER.DISPLAY = false
			end

		else

			if self.getConsumerFillUnitIndex ~= nil then
				VehicleBreakdowns.ECONOMIZER.TIME = VehicleBreakdowns.ECONOMIZER.TIME + dt
				if VehicleBreakdowns.ECONOMIZER.TIME > VehicleBreakdowns.ECONOMIZER.REFRESH_PERIOD then
					VehicleBreakdowns.ECONOMIZER.TIME = VehicleBreakdowns.ECONOMIZER.TIME - VehicleBreakdowns.ECONOMIZER.REFRESH_PERIOD
					local isDieselMotor = (self:getConsumerFillUnitIndex(FillType.DIESEL) ~= nil)
					if isDieselMotor then					
						local value = spec.lastFuelUsage or 0.0
						rvb.instantFuel.Consumption = string.format("%.1f l/h", value)
						VehicleBreakdowns.ECONOMIZER.DISPLAY = true
					else -- no DIESEL
						VehicleBreakdowns.ECONOMIZER.DISPLAY = false
					end
				end
			else -- no fill unit
				VehicleBreakdowns.ECONOMIZER.DISPLAY = false
			end
			
		end
    end
	
	
	-- sync engine data with server
	rvb.updateTimer = rvb.updateTimer + dt
	if self.isServer and self.getIsMotorStarted ~= nil and self:getIsMotorStarted() then
		rvb.motorTemperature = spec.motorTemperature.value
		rvb.fanEnabled = spec.motorFan.enabled
		rvb.lastFuelUsage = spec.lastFuelUsage
		rvb.lastDefUsage = spec.lastDefUsage
		rvb.lastAirUsage = spec.lastAirUsage
		rvb.fanEnableTemperature = spec.motorFan.enableTemperature
		rvb.fanDisableTemperature = spec.motorFan.disableTemperature
		
		if rvb.updateTimer >= 1000 and rvb.motorTemperature ~= self.spec_motorized.motorTemperature.valueSend then
			self:raiseDirtyFlags(rvb.dirtyFlag)
		end
		if rvb.fanEnabled ~= rvb.fanEnabledLast then
			rvb.fanEnabledLast = rvb.fanEnabled
			self:raiseDirtyFlags(rvb.dirtyFlag)
		end
	end
	if self.isClient and not self.isServer and self.getIsMotorStarted ~= nil and self:getIsMotorStarted() then
		spec.motorTemperature.value = rvb.motorTemperature
		spec.motorFan.enabled = rvb.fanEnabled
		spec.lastFuelUsage = rvb.lastFuelUsage
		spec.lastDefUsage = rvb.lastDefUsage
		spec.lastAirUsage = rvb.lastAirUsage
		spec.motorFan.enableTemperature = rvb.fanEnableTemperature
		spec.motorFan.disableTemperature = rvb.fanDisableTemperature
	end
	-- sync end


	rvb.updateBatteryTimer = rvb.updateBatteryTimer + dt
	if self.isServer then
		rvb.RVB_BatteryFillLevel = self.spec_fillUnit.fillUnits[rvb.batteryFillUnitIndex].fillLevel
		
		if rvb.updateBatteryTimer >= 1000 then
			self:raiseDirtyFlags(rvb.dirtyFlag)
			rvb.updateBatteryTimer = 0
		end
	end
	if self.isClient and not self.isServer then
		self.spec_fillUnit.fillUnits[rvb.batteryFillUnitIndex].fillLevel = rvb.RVB_BatteryFillLevel
		self.spec_fillUnit.fillUnits[rvb.batteryFillUnitIndex].fillType = FillType.ELECTRICCHARGE
		--self:raiseDirtyFlags(self.spec_fillUnit.dirtyFlag)
	end

end

function VehicleBreakdowns:getSpeed(vehicle)
	local speedMulti = g_gameSettings:getValue('useMiles') and 0.621371192 or 1
	local speed = math.max(Utils.getNoNil(vehicle.lastSpeed, 0) * 3600 * speedMulti, 0)
	return string.format("%1.0f", speed)
end

function VehicleBreakdowns:updateConsumers(superFunc, p375, p376)
	local v377 = self.spec_motorized
	local v378 = (v377.motor.lastMotorRpm - v377.motor.minRpm) / (v377.motor.maxRpm - v377.motor.minRpm)
	local v379 = 0.5 + v378 * 0.5
	local v380 = v377.smoothedLoadPercentage * v378
	local v381 = math.max(v380, 0)
	local v382 = 0.5 * (0.2 * v379 + 1.8 * v381)
	local v383 = g_currentMission.missionInfo
	local v384 = v383.fuelUsage
	
	--local v385 = v384 == 1 and 1 or (v384 == 3 and 2.5 or 1.5)
	
	local rvb = self.spec_faultData

    local v385 = 1.5 -- medium
	if rvb.parts[1].damaged or rvb.parts[1].repairreq or self:getIsFaultGlowPlug() then
		v385 = 2.4 -- 160%
	end
    if v384 == 1 then
        v385 = 1.0 -- low
		if rvb.parts[1].damaged or rvb.parts[1].repairreq or self:getIsFaultGlowPlug() then
			v385 = 1.6
		end
    elseif v384 == 3 then
        v385 = 2.5 -- high
		if rvb.parts[1].damaged or rvb.parts[1].repairreq or self:getIsFaultGlowPlug() then
			v385 = 4.0
		end
    end
	
	
	local v386 = self:getVehicleDamage()
	if v386 > 0 then
		v385 = v385 * (1 + v386 * Motorized.DAMAGED_USAGE_INCREASE)
	end
	for _, v387 in pairs(v377.consumers) do
		if v387.permanentConsumption and v387.usage > 0 then
			local v388 = v385 * v382 * v387.usage * p375
			if v388 ~= 0 then
				v387.fillLevelToChange = v387.fillLevelToChange + v388
				local v389 = v387.fillLevelToChange
				if math.abs(v389) > 1 then
					v388 = v387.fillLevelToChange
					v387.fillLevelToChange = 0
					local v390 = self:getFillUnitLastValidFillType(v387.fillUnitIndex)
					g_farmManager:updateFarmStats(self:getOwnerFarmId(), "fuelUsage", v388)
					if self:getIsAIActive() and (v390 == FillType.DIESEL or v390 == FillType.DEF) and v383.helperBuyFuel then
						if v390 == FillType.DIESEL then
							local v391 = v388 * g_currentMission.economyManager:getCostPerLiter(v390) * 1.5
							g_farmManager:updateFarmStats(self:getOwnerFarmId(), "expenses", v391)
							g_currentMission:addMoney(-v391, self:getOwnerFarmId(), MoneyType.PURCHASE_FUEL, true)
							v388 = 0
						else
							v388 = 0
						end
					end
					if v390 == v387.fillType then
						self:addFillUnitFillLevel(self:getOwnerFarmId(), v387.fillUnitIndex, -v388, v390, ToolType.UNDEFINED)
					end
				end
				if v387.fillType == FillType.DIESEL or (v387.fillType == FillType.ELECTRICCHARGE or v387.fillType == FillType.METHANE) then
					v377.lastFuelUsage = v388 / p375 * 1000 * 60 * 60
				elseif v387.fillType == FillType.DEF then
					v377.lastDefUsage = v388 / p375 * 1000 * 60 * 60
				end
			end
		end
	end
	if v377.consumersByFillTypeName.AIR ~= nil then
		local v392 = v377.consumersByFillTypeName.AIR
		if self:getFillUnitLastValidFillType(v392.fillUnitIndex) == v392.fillType then
			local v393 = 0
			local v394 = self.movingDirection * self:getReverserDirection()
			local v395
			if v394 > 0 then
				v395 = p376 < 0
			else
				v395 = false
			end
			local v396
			if v394 < 0 then
				v396 = p376 > 0
			else
				v396 = false
			end
			local v397
			if self:getLastSpeed() > 1 then
				v397 = v395 or v396
			else
				v397 = false
			end
			if v397 then
				local v398 = math.abs(p376) * p375 * self:getAirConsumerUsage() / 1000
				self:addFillUnitFillLevel(self:getOwnerFarmId(), v392.fillUnitIndex, -v398, v392.fillType, ToolType.UNDEFINED)
				v393 = v398 / p375 * 1000
			end
			local v399 = self:getFillUnitFillLevelPercentage(v392.fillUnitIndex)
			if v399 < v392.refillCapacityPercentage then
				v392.doRefill = true
			elseif v399 == 1 then
				v392.doRefill = false
			end
			if v392.doRefill then
				local v400 = v392.refillLitersPerSecond / 1000 * p375
				self:addFillUnitFillLevel(self:getOwnerFarmId(), v392.fillUnitIndex, v400, v392.fillType, ToolType.UNDEFINED)
				v393 = -v400 / p375 * 1000
			end
			v377.lastAirUsage = v393
		end
	end
end
--[[
function VehicleBreakdowns:updateConsumers(superFunc, dt, accInput)
    local spec = self.spec_motorized

    local idleFactor = 0.5
    local rpmPercentage = (spec.motor.lastMotorRpm - spec.motor.minRpm) / (spec.motor.maxRpm - spec.motor.minRpm)
    local rpmFactor = idleFactor + rpmPercentage * (1-idleFactor)
    local loadFactor = math.max(spec.smoothedLoadPercentage * rpmPercentage, 0)
    local motorFactor = 0.5 * ( (0.2*rpmFactor) + (1.8*loadFactor) )

    local rvb = self.spec_faultData

    local usageFactor = 1.5 -- medium
	if rvb.parts[1].repairreq or self:getIsFaultGlowPlug() then
		usageFactor = 2.4 -- 160%
	end
    if g_currentMission.missionInfo.fuelUsage == 1 then
        usageFactor = 1.0 -- low
		if rvb.parts[1].repairreq or self:getIsFaultGlowPlug() then
			usageFactor = 1.6
		end
    elseif g_currentMission.missionInfo.fuelUsage == 3 then
        usageFactor = 2.5 -- high
		if rvb.parts[1].repairreq or self:getIsFaultGlowPlug() then
			usageFactor = 4.0
		end
    end
	
    local damage = self:getVehicleDamage()
    if damage > 0 then
        usageFactor = usageFactor * (1 + damage * Motorized.DAMAGED_USAGE_INCREASE)
    end

    -- update permanent consumers
    for _,consumer in pairs(spec.consumers) do

        if consumer.permanentConsumption and consumer.usage > 0 then
            local used = usageFactor * motorFactor * consumer.usage * dt

            if used ~= 0 then

                consumer.fillLevelToChange = consumer.fillLevelToChange + used

                if math.abs(consumer.fillLevelToChange) > 1 then
                    used = consumer.fillLevelToChange
                    consumer.fillLevelToChange = 0

                    local fillType = self:getFillUnitLastValidFillType(consumer.fillUnitIndex)

                    local stats = g_currentMission:farmStats(self:getOwnerFarmId())
                    stats:updateStats("fuelUsage", used)

                    if self:getIsAIActive() then
                        if fillType == FillType.DIESEL or fillType == FillType.DEF then
                            if g_currentMission.missionInfo.helperBuyFuel then
                                if fillType == FillType.DIESEL then
                                    local price = used * g_currentMission.economyManager:getCostPerLiter(fillType) * 1.5
                                    stats:updateStats("expenses", price)

                                    g_currentMission:addMoney(-price, self:getOwnerFarmId(), MoneyType.PURCHASE_FUEL, true)
                                end

                                used = 0
                            end
                        end
                    end

                    if fillType == consumer.fillType then
                        self:addFillUnitFillLevel(self:getOwnerFarmId(), consumer.fillUnitIndex, -used, fillType, ToolType.UNDEFINED)
                    end
                end

				if consumer.fillType == FillType.DIESEL or consumer.fillType == FillType.ELECTRICCHARGE or consumer.fillType == FillType.METHANE then
					spec.lastFuelUsage = used / dt * 1000 * 60 * 60 -- per hour
                elseif consumer.fillType == FillType.DEF then
                    spec.lastDefUsage = used / dt * 1000 * 60 * 60 -- per hour
                end

            end
        end
    end
	
    -- update air consuming
    if spec.consumersByFillTypeName["AIR"] ~= nil then
        local consumer = spec.consumersByFillTypeName["AIR"]
        local fillType = self:getFillUnitLastValidFillType(consumer.fillUnitIndex)
        if fillType == consumer.fillType then
            local usage = 0

            -- consume air on brake
            local direction = self.movingDirection * self:getReverserDirection()
            local forwardBrake = direction > 0 and accInput < 0
            local backwardBrake = direction < 0 and accInput > 0
            local brakeIsPressed = self:getLastSpeed() > 1.0 and (forwardBrake or backwardBrake)
            if brakeIsPressed then
                local delta = math.abs(accInput) * dt * self:getAirConsumerUsage() / 1000
                self:addFillUnitFillLevel(self:getOwnerFarmId(), consumer.fillUnitIndex, -delta, consumer.fillType, ToolType.UNDEFINED)

                usage = delta / dt * 1000 -- per sec
            end

            --refill air fill unit if it is below given level
            local fillLevelPercentage = self:getFillUnitFillLevelPercentage(consumer.fillUnitIndex)
            if fillLevelPercentage < consumer.refillCapacityPercentage then
                consumer.doRefill = true
            elseif fillLevelPercentage == 1 then
                consumer.doRefill = false
            end

            if consumer.doRefill then
                local delta = consumer.refillLitersPerSecond / 1000 * dt
                self:addFillUnitFillLevel(self:getOwnerFarmId(), consumer.fillUnitIndex, delta, consumer.fillType, ToolType.UNDEFINED)

                usage = -delta / dt * 1000 -- per sec
            end

            spec.lastAirUsage = usage
        end
    end
end
]]
function VehicleBreakdowns:getIsOperatingHoursTemp()
	local spec = self.spec_faultData
	return spec.rvb[2]
end

function VehicleBreakdowns:getFaultThermostat()
	local spec = self.spec_faultData
	return spec.parts[1].damaged or spec.parts[1].repairreq
end

function VehicleBreakdowns:getIsFaultThermostatoverHeating()
	local spec = self.spec_faultData
	return spec.faultStorage[1]
end

function VehicleBreakdowns:getIsFaultThermostatoverCooling()
	local spec = self.spec_faultData
	return spec.faultStorage[2]
end

function VehicleBreakdowns:getIsFaultLightings()
	local spec = self.spec_faultData
	return spec.parts[2].damaged or spec.parts[2].repairreq
end

function VehicleBreakdowns:getIsFaultGlowPlug()
	local spec = self.spec_faultData
	return spec.parts[3].damaged or spec.parts[3].repairreq
end

function VehicleBreakdowns:getIsFaultWipers()
	local spec = self.spec_faultData
	return spec.parts[4].damaged or spec.parts[4].repairreq
end

function VehicleBreakdowns:getIsFaultGenerator()
	local spec = self.spec_faultData
	return spec.parts[5].damaged or spec.parts[5].repairreq
end

function VehicleBreakdowns:getIsFaultEngine()
	local spec = self.spec_faultData
	return spec.parts[6].damaged or spec.parts[6].repairreq
end

function VehicleBreakdowns:getIsFaultSelfStarter()
	local spec = self.spec_faultData
	return spec.parts[7].damaged or spec.parts[7].repairreq
end

function VehicleBreakdowns:getIsFaultBattery()
	local batteryFillUnitIndex = self:getConsumerFillUnitIndex(FillType.ELECTRICCHARGE)
	local dieselFillUnitIndex = self:getConsumerFillUnitIndex(FillType.DIESEL)
	
	if batteryFillUnitIndex ~= nil and dieselFillUnitIndex ~= nil then
		return tonumber(self:getFillUnitFillLevelPercentage(batteryFillUnitIndex)) or 1
	end
	return 1
end

function VehicleBreakdowns:setIsFaultBattery(value)
	local spec = self.spec_faultData
	spec.rvb[5] = value
	--if spec.rvb[5] > 1 then
	--	spec.rvb[5] = 1
	--end
	return spec.rvb[5]
end

function VehicleBreakdowns:getThermostatPercentage()
	local spec = self.spec_faultData
	return (spec.parts[1].operatingHours * 100) / spec.parts[1].tmp_lifetime
end

function VehicleBreakdowns:getPartsPercentage(part)
	local spec = self.spec_faultData
	return (spec.parts[part].operatingHours * 100) / spec.parts[part].tmp_lifetime
end
function VehicleBreakdowns:getFaultParts(part)
	local spec = self.spec_faultData
	return spec.parts[part].damaged or spec.parts[part].repairreq
end
	
function VehicleBreakdowns:getIsFaultOperatingHours()
	local spec = self.spec_faultData
	return spec.rvb[4]
end

function VehicleBreakdowns:getIsInspection()
	local spec = self.spec_faultData
	return spec.inspection[1]
end
function VehicleBreakdowns:getIsService()
	local spec = self.spec_faultData
	return spec.service[1]
end

function VehicleBreakdowns:getIsDailyService()
	local spec = self.spec_faultData
	return spec.service[2]
end

function VehicleBreakdowns:getIsPeriodicServiceTime()
	local spec = self.spec_faultData
	return spec.service[3]
end

function VehicleBreakdowns:setIsPeriodicServiceTime(servicetime)
	local spec = self.spec_faultData
	spec.service[3] = servicetime
end

function VehicleBreakdowns:getIsRepairStartService()
	local spec = self.spec_faultData
	return spec.vehicleService[3]
end

function VehicleBreakdowns:getIsRepairClockService()
	local spec = self.spec_faultData
	return spec.vehicleService[4]
end

function VehicleBreakdowns:getIsRepairTimeService()
	local spec = self.spec_faultData
	return spec.vehicleService[5]
end

function VehicleBreakdowns:getIsRepairTimePassedService()
	local spec = self.spec_faultData
	return spec.vehicleService[6]
end

function VehicleBreakdowns:getIsRepairScaleService()
	local spec = self.spec_faultData
	return spec.vehicleService[7]
end


function VehicleBreakdowns:updateDamageAmount(superFunc, dt)
	local spec = self.spec_faultData
	if spec ~= nil then
		local currentPartslifetime = 0
		local currentPartsoperatingHours = 0
		for i, value in pairs(spec.parts) do
			if i ~= 9 and i ~= 10 and i ~= 11 and i ~= 12 then
				currentPartslifetime = currentPartslifetime + value.tmp_lifetime
				currentPartsoperatingHours = currentPartsoperatingHours + value.operatingHours
			end
		end
		self:setDamageAmount(currentPartsoperatingHours/currentPartslifetime)
		return 0
	else
		return superFunc(dt)
	end
end
function VehicleBreakdowns:getSellPrice_RVBClone()
    local storeItem = g_storeManager:getItemByXMLFilename(self.configFileName)
    return VehicleBreakdowns.calculateSellPriceClone(storeItem, self.age, self.operatingTime, self:getPrice(), self:getRepairPrice(), self:getRepairPrice_RVBClone(), self:getRepaintPrice())
end
function VehicleBreakdowns.calculateSellPriceClone(storeItem, age, operatingTime, price, repairPrice, repairPriceRVBClone, repaintPrice)
	local operatingTimeHours = operatingTime / 3600000
	local maxVehicleAge = storeItem.lifetime
	local ageInYears = age / Environment.PERIODS_IN_YEAR
	StoreItemUtil.loadSpecsFromXML(storeItem)
	local operatingTimeFactor = 1 - operatingTimeHours ^ (storeItem.specs.power == nil and 1.3 or 1) / maxVehicleAge
	local ageFactor = -0.1 * math.log(ageInYears) + 0.75
	local v476 = math.min(ageFactor, 0.85)
	local v477 = price * operatingTimeFactor * v476 - repairPrice - repairPriceRVBClone - repaintPrice
	local v478 = price * 0.03
	return math.max(v477, v478)
end

function VehicleBreakdowns:getRepairPrice_RVBClone()
	local spec = self.spec_faultData
	local faultListCosts = 0
	local ageInYears = self.age / Environment.PERIODS_IN_YEAR
	local ageFactor = -0.1 * math.log(ageInYears) + 0.75
	ageFactor = math.min(ageFactor, 0.85)
	for i=1, #spec.parts do
		if spec.parts[i].repairreq then
			faultListCosts = faultListCosts + VehicleBreakdowns.repairCosts[i]
		end
	end
	return self:getPrice() * ageFactor * faultListCosts
end


function VehicleBreakdowns:getServicePrice()

	local spec = self.spec_faultData
	
	local ageInYears = self.age / Environment.PERIODS_IN_YEAR
	local ageFactor = math.min(-0.1 * math.log(ageInYears) + 0.75, 0.8)

    return self:getPrice() * ageFactor * VehicleBreakdowns.repairCosts[9]

end


function VehicleBreakdowns:getInspectionPrice()

	local spec = self.spec_faultData
	
	local ageInYears = self.age / Environment.PERIODS_IN_YEAR
	local ageFactor = math.min(-0.1 * math.log(ageInYears) + 0.75, 0.8)

    return self:getPrice() * ageFactor * VehicleBreakdowns.repairCosts[10]

end





function table:count()
	local c = 0
	if self ~= nil then
		for _ in pairs(self) do
			c = c + 1
		end
	end
	return c
end

function table:contains(value)
	for _, v in pairs(self) do
		if v == value then
			return true
		end
	end
	return false
end

